/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 0;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 1;

    case E_V32HFmode:
      if (!gcn_alu_operand (operands[1], E_V32HFmode))
        return -1;
      return 2;

    case E_V32SFmode:
      if (!gcn_alu_operand (operands[1], E_V32SFmode))
        return -1;
      return 3;

    case E_V32DFmode:
      if (!gcn_alu_operand (operands[1], E_V32DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!gcn_alu_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!gcn_alu_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!gcn_alu_operand (operands[1], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 26
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != VEC_DUPLICATE)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != SCRATCH)
    return -1;
  x7 = XEXP (x4, 0);
  if (!immediate_operand (x7, E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  if (!immediate_operand (x8, E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 3);
  if (!immediate_operand (x9, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern39 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern39 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern39 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4QImode:
      if (pattern39 (x1, 
E_V4QImode) != 0)
        return -1;
      return 3;

    case E_V4HImode:
      if (pattern39 (x1, 
E_V4HImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern39 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V8QImode:
      if (pattern39 (x1, 
E_V8QImode) != 0)
        return -1;
      return 6;

    case E_V8HImode:
      if (pattern39 (x1, 
E_V8HImode) != 0)
        return -1;
      return 7;

    case E_V8SImode:
      if (pattern39 (x1, 
E_V8SImode) != 0)
        return -1;
      return 8;

    case E_V16QImode:
      if (pattern39 (x1, 
E_V16QImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern39 (x1, 
E_V16HImode) != 0)
        return -1;
      return 10;

    case E_V16SImode:
      if (pattern39 (x1, 
E_V16SImode) != 0)
        return -1;
      return 11;

    case E_V32QImode:
      if (pattern39 (x1, 
E_V32QImode) != 0)
        return -1;
      return 12;

    case E_V32HImode:
      if (pattern39 (x1, 
E_V32HImode) != 0)
        return -1;
      return 13;

    case E_V32SImode:
      if (pattern39 (x1, 
E_V32SImode) != 0)
        return -1;
      return 14;

    case E_V64QImode:
      if (pattern39 (x1, 
E_V64QImode) != 0)
        return -1;
      return 15;

    case E_V64HImode:
      if (pattern39 (x1, 
E_V64HImode) != 0)
        return -1;
      return 16;

    case E_V64SImode:
      if (pattern39 (x1, 
E_V64SImode) != 0)
        return -1;
      return 17;

    case E_V2DImode:
      if (pattern40 (x1, 
E_V2DImode) != 0)
        return -1;
      return 18;

    case E_V4DImode:
      if (pattern40 (x1, 
E_V4DImode) != 0)
        return -1;
      return 19;

    case E_V8DImode:
      if (pattern40 (x1, 
E_V8DImode) != 0)
        return -1;
      return 20;

    case E_V16DImode:
      if (pattern40 (x1, 
E_V16DImode) != 0)
        return -1;
      return 21;

    case E_V32DImode:
      if (pattern40 (x1, 
E_V32DImode) != 0)
        return -1;
      return 22;

    case E_V64DImode:
      if (pattern40 (x1, 
E_V64DImode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!gcn_alu_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!gcn_alu_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!gcn_alu_operand (operands[1], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gcn_alu_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!scratch_operand (operands[2], E_BImode))
    return -1;
  return 0;
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!gcn_alu_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_BImode))
    return -1;
  return pattern81 (x4); /* [-1, 1] */
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern86 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern86 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern86 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V2HFmode:
      if (pattern86 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern86 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4QImode:
      if (pattern86 (x1, 
E_V4QImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern86 (x1, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern86 (x1, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V4HFmode:
      if (pattern86 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 8;

    case E_V4SFmode:
      if (pattern86 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 9;

    case E_V8QImode:
      if (pattern86 (x1, 
E_V8QImode) != 0)
        return -1;
      return 10;

    case E_V8HImode:
      if (pattern86 (x1, 
E_V8HImode) != 0)
        return -1;
      return 11;

    case E_V8SImode:
      if (pattern86 (x1, 
E_V8SImode) != 0)
        return -1;
      return 12;

    case E_V8HFmode:
      if (pattern86 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 13;

    case E_V8SFmode:
      if (pattern86 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 14;

    case E_V16QImode:
      if (pattern86 (x1, 
E_V16QImode) != 0)
        return -1;
      return 15;

    case E_V16HImode:
      if (pattern86 (x1, 
E_V16HImode) != 0)
        return -1;
      return 16;

    case E_V16SImode:
      if (pattern86 (x1, 
E_V16SImode) != 0)
        return -1;
      return 17;

    case E_V16HFmode:
      if (pattern86 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 18;

    case E_V16SFmode:
      if (pattern86 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 19;

    case E_V32QImode:
      if (pattern86 (x1, 
E_V32QImode) != 0)
        return -1;
      return 20;

    case E_V32HImode:
      if (pattern86 (x1, 
E_V32HImode) != 0)
        return -1;
      return 21;

    case E_V32SImode:
      if (pattern86 (x1, 
E_V32SImode) != 0)
        return -1;
      return 22;

    case E_V32HFmode:
      if (pattern86 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 23;

    case E_V32SFmode:
      if (pattern86 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 24;

    case E_V64QImode:
      if (pattern86 (x1, 
E_V64QImode) != 0)
        return -1;
      return 25;

    case E_V64HImode:
      if (pattern86 (x1, 
E_V64HImode) != 0)
        return -1;
      return 26;

    case E_V64SImode:
      if (pattern86 (x1, 
E_V64SImode) != 0)
        return -1;
      return 27;

    case E_V64HFmode:
      if (pattern86 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 28;

    case E_V64SFmode:
      if (pattern86 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 29;

    case E_V2DImode:
      if (pattern86 (x1, 
E_V2DImode) != 0)
        return -1;
      return 30;

    case E_V4DImode:
      if (pattern86 (x1, 
E_V4DImode) != 0)
        return -1;
      return 31;

    case E_V8DImode:
      if (pattern86 (x1, 
E_V8DImode) != 0)
        return -1;
      return 32;

    case E_V16DImode:
      if (pattern86 (x1, 
E_V16DImode) != 0)
        return -1;
      return 33;

    case E_V32DImode:
      if (pattern86 (x1, 
E_V32DImode) != 0)
        return -1;
      return 34;

    case E_V64DImode:
      if (pattern86 (x1, 
E_V64DImode) != 0)
        return -1;
      return 35;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gcn_ds_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_ds_memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern108 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern108 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern108 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern108 (x1, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern108 (x1, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern108 (x1, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != LTU
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != VEC_DUPLICATE)
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!gcn_32bit_immediate_operand (operands[2], E_DImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_DImode
      || GET_MODE (x3) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) != E_DImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gcn_valu_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_valu_src0_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern160 (x1, 
E_V2DImode, 
E_V2SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern160 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern160 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern160 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern160 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern160 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[2], i2)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gcn_alu_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[2], i2)
      || !register_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V64DImode)
        return -1;
      return 0;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V64SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_MODE (x5) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 0;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 1;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 2;

        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[3], E_V2DImode))
            return -1;
          return 5;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 6;

        case E_V2TImode:
          if (!register_operand (operands[3], E_V2TImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_V4DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_MODE (x5) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 8;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 9;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 10;

        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 12;

        case E_V4DImode:
          if (!register_operand (operands[3], E_V4DImode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 14;

        case E_V4TImode:
          if (!register_operand (operands[3], E_V4TImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_V8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_V8DImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_MODE (x5) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 16;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 17;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 18;

        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 19;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 20;

        case E_V8DImode:
          if (!register_operand (operands[3], E_V8DImode))
            return -1;
          return 21;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 22;

        case E_V8TImode:
          if (!register_operand (operands[3], E_V8TImode))
            return -1;
          return 23;

        default:
          return -1;
        }

    case E_V16DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V16DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_V16DImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_MODE (x5) != E_V16DImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 24;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 25;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 26;

        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 27;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 28;

        case E_V16DImode:
          if (!register_operand (operands[3], E_V16DImode))
            return -1;
          return 29;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 30;

        case E_V16TImode:
          if (!register_operand (operands[3], E_V16TImode))
            return -1;
          return 31;

        default:
          return -1;
        }

    case E_V32DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V32DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_V32DImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_MODE (x5) != E_V32DImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 32;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 33;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 34;

        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 35;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 36;

        case E_V32DImode:
          if (!register_operand (operands[3], E_V32DImode))
            return -1;
          return 37;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 38;

        case E_V32TImode:
          if (!register_operand (operands[3], E_V32TImode))
            return -1;
          return 39;

        default:
          return -1;
        }

    case E_V64DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V64DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_V64DImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_MODE (x5) != E_V64DImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 40;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 41;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 42;

        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 43;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 44;

        case E_V64DImode:
          if (!register_operand (operands[3], E_V64DImode))
            return -1;
          return 45;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 46;

        case E_V64TImode:
          if (!register_operand (operands[3], E_V64TImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern99 (x2, 
E_V64SImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6003; /* *truncv2qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8559; /* *truncv2qiv64si_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6007; /* *truncv2hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8565; /* *truncv2hiv64si_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6011; /* *truncv2siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8571; /* *truncv2siv64si_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6015; /* *truncv4qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8577; /* *truncv4qiv64si_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6019; /* *truncv4hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8583; /* *truncv4hiv64si_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6023; /* *truncv4siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8589; /* *truncv4siv64si_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6027; /* *truncv8qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8595; /* *truncv8qiv64si_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6031; /* *truncv8hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8601; /* *truncv8hiv64si_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6035; /* *truncv8siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8607; /* *truncv8siv64si_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6039; /* *truncv16qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8613; /* *truncv16qiv64si_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6043; /* *truncv16hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8619; /* *truncv16hiv64si_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6047; /* *truncv16siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8625; /* *truncv16siv64si_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6051; /* *truncv32qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8631; /* *truncv32qiv64si_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6055; /* *truncv32hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8637; /* *truncv32hiv64si_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6059; /* *truncv32siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8643; /* *truncv32siv64si_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6063; /* *truncv64qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8649; /* *truncv64qiv64si_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6067; /* *truncv64hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8655; /* *truncv64hiv64si_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6071; /* *truncv64siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8661; /* *truncv64siv64si_shift */

    case 18:
      return 8684; /* truncv64div64si2 */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern98 (x2, 
E_V32HImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5715; /* *truncv2qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8127; /* *truncv2qiv32hi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5719; /* *truncv2hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8133; /* *truncv2hiv32hi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5723; /* *truncv2siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8139; /* *truncv2siv32hi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5727; /* *truncv4qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8145; /* *truncv4qiv32hi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5731; /* *truncv4hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8151; /* *truncv4hiv32hi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5735; /* *truncv4siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8157; /* *truncv4siv32hi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5739; /* *truncv8qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8163; /* *truncv8qiv32hi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5743; /* *truncv8hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8169; /* *truncv8hiv32hi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5747; /* *truncv8siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8175; /* *truncv8siv32hi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5751; /* *truncv16qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8181; /* *truncv16qiv32hi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5755; /* *truncv16hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8187; /* *truncv16hiv32hi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5759; /* *truncv16siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8193; /* *truncv16siv32hi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5763; /* *truncv32qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8199; /* *truncv32qiv32hi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5767; /* *truncv32hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8205; /* *truncv32hiv32hi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5771; /* *truncv32siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8211; /* *truncv32siv32hi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5775; /* *truncv64qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8217; /* *truncv64qiv32hi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5779; /* *truncv64hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8223; /* *truncv64hiv32hi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5783; /* *truncv64siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8229; /* *truncv64siv32hi_shift */

    case 18:
      return 8680; /* truncv32div32hi2 */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern97 (x2, 
E_V16QImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5427; /* *truncv2qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7695; /* *truncv2qiv16qi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5431; /* *truncv2hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7701; /* *truncv2hiv16qi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5435; /* *truncv2siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7707; /* *truncv2siv16qi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5439; /* *truncv4qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7713; /* *truncv4qiv16qi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5443; /* *truncv4hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7719; /* *truncv4hiv16qi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5447; /* *truncv4siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7725; /* *truncv4siv16qi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5451; /* *truncv8qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7731; /* *truncv8qiv16qi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5455; /* *truncv8hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7737; /* *truncv8hiv16qi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5459; /* *truncv8siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7743; /* *truncv8siv16qi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5463; /* *truncv16qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7749; /* *truncv16qiv16qi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5467; /* *truncv16hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7755; /* *truncv16hiv16qi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5471; /* *truncv16siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7761; /* *truncv16siv16qi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5475; /* *truncv32qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7767; /* *truncv32qiv16qi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5479; /* *truncv32hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7773; /* *truncv32hiv16qi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5483; /* *truncv32siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7779; /* *truncv32siv16qi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5487; /* *truncv64qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7785; /* *truncv64qiv16qi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5491; /* *truncv64hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7791; /* *truncv64hiv16qi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5495; /* *truncv64siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7797; /* *truncv64siv16qi_shift */

    case 18:
      return 8676; /* truncv16div16qi2 */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern95 (x2, 
E_V4SImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5139; /* *truncv2qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7263; /* *truncv2qiv4si_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5143; /* *truncv2hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7269; /* *truncv2hiv4si_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5147; /* *truncv2siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7275; /* *truncv2siv4si_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5151; /* *truncv4qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7281; /* *truncv4qiv4si_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5155; /* *truncv4hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7287; /* *truncv4hiv4si_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5159; /* *truncv4siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7293; /* *truncv4siv4si_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5163; /* *truncv8qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7299; /* *truncv8qiv4si_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5167; /* *truncv8hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7305; /* *truncv8hiv4si_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5171; /* *truncv8siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7311; /* *truncv8siv4si_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5175; /* *truncv16qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7317; /* *truncv16qiv4si_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5179; /* *truncv16hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7323; /* *truncv16hiv4si_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5183; /* *truncv16siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7329; /* *truncv16siv4si_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5187; /* *truncv32qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7335; /* *truncv32qiv4si_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5191; /* *truncv32hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7341; /* *truncv32hiv4si_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5195; /* *truncv32siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7347; /* *truncv32siv4si_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5199; /* *truncv64qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7353; /* *truncv64qiv4si_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5203; /* *truncv64hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7359; /* *truncv64hiv4si_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5207; /* *truncv64siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7365; /* *truncv64siv4si_shift */

    case 18:
      return 8672; /* truncv4div4si2 */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern145 (x2, 
E_V64SImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6004; /* *truncv2qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8560; /* *truncv2qiv64si_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6008; /* *truncv2hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8566; /* *truncv2hiv64si_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6012; /* *truncv2siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8572; /* *truncv2siv64si_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6016; /* *truncv4qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8578; /* *truncv4qiv64si_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6020; /* *truncv4hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8584; /* *truncv4hiv64si_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6024; /* *truncv4siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8590; /* *truncv4siv64si_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6028; /* *truncv8qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8596; /* *truncv8qiv64si_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6032; /* *truncv8hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8602; /* *truncv8hiv64si_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6036; /* *truncv8siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8608; /* *truncv8siv64si_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6040; /* *truncv16qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8614; /* *truncv16qiv64si_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6044; /* *truncv16hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8620; /* *truncv16hiv64si_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6048; /* *truncv16siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8626; /* *truncv16siv64si_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6052; /* *truncv32qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8632; /* *truncv32qiv64si_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6056; /* *truncv32hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8638; /* *truncv32hiv64si_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6060; /* *truncv32siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8644; /* *truncv32siv64si_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6064; /* *truncv64qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8650; /* *truncv64qiv64si_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6068; /* *truncv64hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8656; /* *truncv64hiv64si_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6072; /* *truncv64siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8662; /* *truncv64siv64si_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V64DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V64SImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8702; /* truncv64div64si2_exec */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern144 (x2, 
E_V32HImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5716; /* *truncv2qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8128; /* *truncv2qiv32hi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5720; /* *truncv2hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8134; /* *truncv2hiv32hi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5724; /* *truncv2siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8140; /* *truncv2siv32hi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5728; /* *truncv4qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8146; /* *truncv4qiv32hi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5732; /* *truncv4hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8152; /* *truncv4hiv32hi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5736; /* *truncv4siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8158; /* *truncv4siv32hi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5740; /* *truncv8qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8164; /* *truncv8qiv32hi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5744; /* *truncv8hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8170; /* *truncv8hiv32hi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5748; /* *truncv8siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8176; /* *truncv8siv32hi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5752; /* *truncv16qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8182; /* *truncv16qiv32hi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5756; /* *truncv16hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8188; /* *truncv16hiv32hi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5760; /* *truncv16siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8194; /* *truncv16siv32hi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5764; /* *truncv32qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8200; /* *truncv32qiv32hi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5768; /* *truncv32hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8206; /* *truncv32hiv32hi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5772; /* *truncv32siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8212; /* *truncv32siv32hi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5776; /* *truncv64qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8218; /* *truncv64qiv32hi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5780; /* *truncv64hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8224; /* *truncv64hiv32hi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5784; /* *truncv64siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8230; /* *truncv64siv32hi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V32DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V32HImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8698; /* truncv32div32hi2_exec */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern142 (x2, 
E_V8HImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5284; /* *truncv2qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7480; /* *truncv2qiv8hi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5288; /* *truncv2hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7486; /* *truncv2hiv8hi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5292; /* *truncv2siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7492; /* *truncv2siv8hi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5296; /* *truncv4qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7498; /* *truncv4qiv8hi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5300; /* *truncv4hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7504; /* *truncv4hiv8hi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5304; /* *truncv4siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7510; /* *truncv4siv8hi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5308; /* *truncv8qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7516; /* *truncv8qiv8hi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5312; /* *truncv8hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7522; /* *truncv8hiv8hi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5316; /* *truncv8siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7528; /* *truncv8siv8hi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5320; /* *truncv16qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7534; /* *truncv16qiv8hi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5324; /* *truncv16hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7540; /* *truncv16hiv8hi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5328; /* *truncv16siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7546; /* *truncv16siv8hi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5332; /* *truncv32qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7552; /* *truncv32qiv8hi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5336; /* *truncv32hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7558; /* *truncv32hiv8hi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5340; /* *truncv32siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7564; /* *truncv32siv8hi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5344; /* *truncv64qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7570; /* *truncv64qiv8hi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5348; /* *truncv64hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7576; /* *truncv64hiv8hi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5352; /* *truncv64siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7582; /* *truncv64siv8hi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V8DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V8HImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8692; /* truncv8div8hi2_exec */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  switch (GET_CODE (x5))
    {
    case ASHIFT:
      x6 = XEXP (x5, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!gcn_alu_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern158 (x2, 
E_V2QImode, 
E_QImode) != 0)
            return -1;
          return 285; /* *vec_setv2qi */

        case E_V2HImode:
          if (pattern158 (x2, 
E_V2HImode, 
E_HImode) != 0)
            return -1;
          return 286; /* *vec_setv2hi */

        case E_V2SImode:
          if (pattern158 (x2, 
E_V2SImode, 
E_SImode) != 0)
            return -1;
          return 287; /* *vec_setv2si */

        case E_V2HFmode:
          if (pattern158 (x2, 
E_V2HFmode, 
E_HFmode) != 0)
            return -1;
          return 288; /* *vec_setv2hf */

        case E_V2SFmode:
          if (pattern158 (x2, 
E_V2SFmode, 
E_SFmode) != 0)
            return -1;
          return 289; /* *vec_setv2sf */

        case E_V4QImode:
          if (pattern158 (x2, 
E_V4QImode, 
E_QImode) != 0)
            return -1;
          return 290; /* *vec_setv4qi */

        case E_V4HImode:
          if (pattern158 (x2, 
E_V4HImode, 
E_HImode) != 0)
            return -1;
          return 291; /* *vec_setv4hi */

        case E_V4SImode:
          if (pattern158 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          return 292; /* *vec_setv4si */

        case E_V4HFmode:
          if (pattern158 (x2, 
E_V4HFmode, 
E_HFmode) != 0)
            return -1;
          return 293; /* *vec_setv4hf */

        case E_V4SFmode:
          if (pattern158 (x2, 
E_V4SFmode, 
E_SFmode) != 0)
            return -1;
          return 294; /* *vec_setv4sf */

        case E_V8QImode:
          if (pattern158 (x2, 
E_V8QImode, 
E_QImode) != 0)
            return -1;
          return 295; /* *vec_setv8qi */

        case E_V8HImode:
          if (pattern158 (x2, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          return 296; /* *vec_setv8hi */

        case E_V8SImode:
          if (pattern158 (x2, 
E_V8SImode, 
E_SImode) != 0)
            return -1;
          return 297; /* *vec_setv8si */

        case E_V8HFmode:
          if (pattern158 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
            return -1;
          return 298; /* *vec_setv8hf */

        case E_V8SFmode:
          if (pattern158 (x2, 
E_V8SFmode, 
E_SFmode) != 0)
            return -1;
          return 299; /* *vec_setv8sf */

        case E_V16QImode:
          if (pattern158 (x2, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          return 300; /* *vec_setv16qi */

        case E_V16HImode:
          if (pattern158 (x2, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 301; /* *vec_setv16hi */

        case E_V16SImode:
          if (pattern158 (x2, 
E_V16SImode, 
E_SImode) != 0)
            return -1;
          return 302; /* *vec_setv16si */

        case E_V16HFmode:
          if (pattern158 (x2, 
E_V16HFmode, 
E_HFmode) != 0)
            return -1;
          return 303; /* *vec_setv16hf */

        case E_V16SFmode:
          if (pattern158 (x2, 
E_V16SFmode, 
E_SFmode) != 0)
            return -1;
          return 304; /* *vec_setv16sf */

        case E_V32QImode:
          if (pattern158 (x2, 
E_V32QImode, 
E_QImode) != 0)
            return -1;
          return 305; /* *vec_setv32qi */

        case E_V32HImode:
          if (pattern158 (x2, 
E_V32HImode, 
E_HImode) != 0)
            return -1;
          return 306; /* *vec_setv32hi */

        case E_V32SImode:
          if (pattern158 (x2, 
E_V32SImode, 
E_SImode) != 0)
            return -1;
          return 307; /* *vec_setv32si */

        case E_V32HFmode:
          if (pattern158 (x2, 
E_V32HFmode, 
E_HFmode) != 0)
            return -1;
          return 308; /* *vec_setv32hf */

        case E_V32SFmode:
          if (pattern158 (x2, 
E_V32SFmode, 
E_SFmode) != 0)
            return -1;
          return 309; /* *vec_setv32sf */

        case E_V64QImode:
          if (pattern158 (x2, 
E_V64QImode, 
E_QImode) != 0)
            return -1;
          return 310; /* *vec_setv64qi */

        case E_V64HImode:
          if (pattern158 (x2, 
E_V64HImode, 
E_HImode) != 0)
            return -1;
          return 311; /* *vec_setv64hi */

        case E_V64SImode:
          if (pattern158 (x2, 
E_V64SImode, 
E_SImode) != 0)
            return -1;
          return 312; /* *vec_setv64si */

        case E_V64HFmode:
          if (pattern158 (x2, 
E_V64HFmode, 
E_HFmode) != 0)
            return -1;
          return 313; /* *vec_setv64hf */

        case E_V64SFmode:
          if (pattern158 (x2, 
E_V64SFmode, 
E_SFmode) != 0)
            return -1;
          return 314; /* *vec_setv64sf */

        case E_V2DImode:
          if (pattern158 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return -1;
          return 315; /* *vec_setv2di */

        case E_V2DFmode:
          if (pattern158 (x2, 
E_V2DFmode, 
E_DFmode) != 0)
            return -1;
          return 316; /* *vec_setv2df */

        case E_V4DImode:
          if (pattern158 (x2, 
E_V4DImode, 
E_DImode) != 0)
            return -1;
          return 317; /* *vec_setv4di */

        case E_V4DFmode:
          if (pattern158 (x2, 
E_V4DFmode, 
E_DFmode) != 0)
            return -1;
          return 318; /* *vec_setv4df */

        case E_V8DImode:
          if (pattern158 (x2, 
E_V8DImode, 
E_DImode) != 0)
            return -1;
          return 319; /* *vec_setv8di */

        case E_V8DFmode:
          if (pattern158 (x2, 
E_V8DFmode, 
E_DFmode) != 0)
            return -1;
          return 320; /* *vec_setv8df */

        case E_V16DImode:
          if (pattern158 (x2, 
E_V16DImode, 
E_DImode) != 0)
            return -1;
          return 321; /* *vec_setv16di */

        case E_V16DFmode:
          if (pattern158 (x2, 
E_V16DFmode, 
E_DFmode) != 0)
            return -1;
          return 322; /* *vec_setv16df */

        case E_V32DImode:
          if (pattern158 (x2, 
E_V32DImode, 
E_DImode) != 0)
            return -1;
          return 323; /* *vec_setv32di */

        case E_V32DFmode:
          if (pattern158 (x2, 
E_V32DFmode, 
E_DFmode) != 0)
            return -1;
          return 324; /* *vec_setv32df */

        case E_V64DImode:
          if (pattern158 (x2, 
E_V64DImode, 
E_DImode) != 0)
            return -1;
          return 325; /* *vec_setv64di */

        case E_V64DFmode:
          if (pattern158 (x2, 
E_V64DFmode, 
E_DFmode) != 0)
            return -1;
          return 326; /* *vec_setv64df */

        default:
          return -1;
        }

    case CONST_INT:
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern158 (x2, 
E_V2QImode, 
E_QImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2QImode))))
            return -1;
          return 327; /* *vec_setv2qi_1 */

        case E_V2HImode:
          if (pattern158 (x2, 
E_V2HImode, 
E_HImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2HImode))))
            return -1;
          return 328; /* *vec_setv2hi_1 */

        case E_V2SImode:
          if (pattern158 (x2, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2SImode))))
            return -1;
          return 329; /* *vec_setv2si_1 */

        case E_V2HFmode:
          if (pattern158 (x2, 
E_V2HFmode, 
E_HFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2HFmode))))
            return -1;
          return 330; /* *vec_setv2hf_1 */

        case E_V2SFmode:
          if (pattern158 (x2, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2SFmode))))
            return -1;
          return 331; /* *vec_setv2sf_1 */

        case E_V4QImode:
          if (pattern158 (x2, 
E_V4QImode, 
E_QImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4QImode))))
            return -1;
          return 332; /* *vec_setv4qi_1 */

        case E_V4HImode:
          if (pattern158 (x2, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4HImode))))
            return -1;
          return 333; /* *vec_setv4hi_1 */

        case E_V4SImode:
          if (pattern158 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4SImode))))
            return -1;
          return 334; /* *vec_setv4si_1 */

        case E_V4HFmode:
          if (pattern158 (x2, 
E_V4HFmode, 
E_HFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4HFmode))))
            return -1;
          return 335; /* *vec_setv4hf_1 */

        case E_V4SFmode:
          if (pattern158 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4SFmode))))
            return -1;
          return 336; /* *vec_setv4sf_1 */

        case E_V8QImode:
          if (pattern158 (x2, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8QImode))))
            return -1;
          return 337; /* *vec_setv8qi_1 */

        case E_V8HImode:
          if (pattern158 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8HImode))))
            return -1;
          return 338; /* *vec_setv8hi_1 */

        case E_V8SImode:
          if (pattern158 (x2, 
E_V8SImode, 
E_SImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8SImode))))
            return -1;
          return 339; /* *vec_setv8si_1 */

        case E_V8HFmode:
          if (pattern158 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8HFmode))))
            return -1;
          return 340; /* *vec_setv8hf_1 */

        case E_V8SFmode:
          if (pattern158 (x2, 
E_V8SFmode, 
E_SFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8SFmode))))
            return -1;
          return 341; /* *vec_setv8sf_1 */

        case E_V16QImode:
          if (pattern158 (x2, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16QImode))))
            return -1;
          return 342; /* *vec_setv16qi_1 */

        case E_V16HImode:
          if (pattern158 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16HImode))))
            return -1;
          return 343; /* *vec_setv16hi_1 */

        case E_V16SImode:
          if (pattern158 (x2, 
E_V16SImode, 
E_SImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16SImode))))
            return -1;
          return 344; /* *vec_setv16si_1 */

        case E_V16HFmode:
          if (pattern158 (x2, 
E_V16HFmode, 
E_HFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16HFmode))))
            return -1;
          return 345; /* *vec_setv16hf_1 */

        case E_V16SFmode:
          if (pattern158 (x2, 
E_V16SFmode, 
E_SFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16SFmode))))
            return -1;
          return 346; /* *vec_setv16sf_1 */

        case E_V32QImode:
          if (pattern158 (x2, 
E_V32QImode, 
E_QImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32QImode))))
            return -1;
          return 347; /* *vec_setv32qi_1 */

        case E_V32HImode:
          if (pattern158 (x2, 
E_V32HImode, 
E_HImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32HImode))))
            return -1;
          return 348; /* *vec_setv32hi_1 */

        case E_V32SImode:
          if (pattern158 (x2, 
E_V32SImode, 
E_SImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32SImode))))
            return -1;
          return 349; /* *vec_setv32si_1 */

        case E_V32HFmode:
          if (pattern158 (x2, 
E_V32HFmode, 
E_HFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32HFmode))))
            return -1;
          return 350; /* *vec_setv32hf_1 */

        case E_V32SFmode:
          if (pattern158 (x2, 
E_V32SFmode, 
E_SFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32SFmode))))
            return -1;
          return 351; /* *vec_setv32sf_1 */

        case E_V64QImode:
          if (pattern158 (x2, 
E_V64QImode, 
E_QImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64QImode))))
            return -1;
          return 352; /* *vec_setv64qi_1 */

        case E_V64HImode:
          if (pattern158 (x2, 
E_V64HImode, 
E_HImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64HImode))))
            return -1;
          return 353; /* *vec_setv64hi_1 */

        case E_V64SImode:
          if (pattern158 (x2, 
E_V64SImode, 
E_SImode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64SImode))))
            return -1;
          return 354; /* *vec_setv64si_1 */

        case E_V64HFmode:
          if (pattern158 (x2, 
E_V64HFmode, 
E_HFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64HFmode))))
            return -1;
          return 355; /* *vec_setv64hf_1 */

        case E_V64SFmode:
          if (pattern158 (x2, 
E_V64SFmode, 
E_SFmode) != 0
              || !
#line 849 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64SFmode))))
            return -1;
          return 356; /* *vec_setv64sf_1 */

        case E_V2DImode:
          if (pattern158 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2DImode))))
            return -1;
          return 357; /* *vec_setv2di_1 */

        case E_V2DFmode:
          if (pattern158 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V2DFmode))))
            return -1;
          return 358; /* *vec_setv2df_1 */

        case E_V4DImode:
          if (pattern158 (x2, 
E_V4DImode, 
E_DImode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4DImode))))
            return -1;
          return 359; /* *vec_setv4di_1 */

        case E_V4DFmode:
          if (pattern158 (x2, 
E_V4DFmode, 
E_DFmode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V4DFmode))))
            return -1;
          return 360; /* *vec_setv4df_1 */

        case E_V8DImode:
          if (pattern158 (x2, 
E_V8DImode, 
E_DImode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8DImode))))
            return -1;
          return 361; /* *vec_setv8di_1 */

        case E_V8DFmode:
          if (pattern158 (x2, 
E_V8DFmode, 
E_DFmode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V8DFmode))))
            return -1;
          return 362; /* *vec_setv8df_1 */

        case E_V16DImode:
          if (pattern158 (x2, 
E_V16DImode, 
E_DImode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16DImode))))
            return -1;
          return 363; /* *vec_setv16di_1 */

        case E_V16DFmode:
          if (pattern158 (x2, 
E_V16DFmode, 
E_DFmode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V16DFmode))))
            return -1;
          return 364; /* *vec_setv16df_1 */

        case E_V32DImode:
          if (pattern158 (x2, 
E_V32DImode, 
E_DImode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32DImode))))
            return -1;
          return 365; /* *vec_setv32di_1 */

        case E_V32DFmode:
          if (pattern158 (x2, 
E_V32DFmode, 
E_DFmode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V32DFmode))))
            return -1;
          return 366; /* *vec_setv32df_1 */

        case E_V64DImode:
          if (pattern158 (x2, 
E_V64DImode, 
E_DImode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64DImode))))
            return -1;
          return 367; /* *vec_setv64di_1 */

        case E_V64DFmode:
          if (pattern158 (x2, 
E_V64DFmode, 
E_DFmode) != 0
              || !
#line 866 "../../gcc/config/gcn/gcn-valu.md"
(((unsigned) exact_log2 (INTVAL (operands[2])) < GET_MODE_NUNITS (V64DFmode))))
            return -1;
          return 368; /* *vec_setv64df_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x5;
      if (!gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern159 (x2, 
E_V2QImode, 
E_QImode) != 0)
            return -1;
          return 370; /* vec_duplicatev2qi_exec */

        case E_V2HImode:
          if (pattern159 (x2, 
E_V2HImode, 
E_HImode) != 0)
            return -1;
          return 372; /* vec_duplicatev2hi_exec */

        case E_V2SImode:
          if (pattern159 (x2, 
E_V2SImode, 
E_SImode) != 0)
            return -1;
          return 374; /* vec_duplicatev2si_exec */

        case E_V2HFmode:
          if (pattern159 (x2, 
E_V2HFmode, 
E_HFmode) != 0)
            return -1;
          return 376; /* vec_duplicatev2hf_exec */

        case E_V2SFmode:
          if (pattern159 (x2, 
E_V2SFmode, 
E_SFmode) != 0)
            return -1;
          return 378; /* vec_duplicatev2sf_exec */

        case E_V4QImode:
          if (pattern159 (x2, 
E_V4QImode, 
E_QImode) != 0)
            return -1;
          return 380; /* vec_duplicatev4qi_exec */

        case E_V4HImode:
          if (pattern159 (x2, 
E_V4HImode, 
E_HImode) != 0)
            return -1;
          return 382; /* vec_duplicatev4hi_exec */

        case E_V4SImode:
          if (pattern159 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          return 384; /* vec_duplicatev4si_exec */

        case E_V4HFmode:
          if (pattern159 (x2, 
E_V4HFmode, 
E_HFmode) != 0)
            return -1;
          return 386; /* vec_duplicatev4hf_exec */

        case E_V4SFmode:
          if (pattern159 (x2, 
E_V4SFmode, 
E_SFmode) != 0)
            return -1;
          return 388; /* vec_duplicatev4sf_exec */

        case E_V8QImode:
          if (pattern159 (x2, 
E_V8QImode, 
E_QImode) != 0)
            return -1;
          return 390; /* vec_duplicatev8qi_exec */

        case E_V8HImode:
          if (pattern159 (x2, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          return 392; /* vec_duplicatev8hi_exec */

        case E_V8SImode:
          if (pattern159 (x2, 
E_V8SImode, 
E_SImode) != 0)
            return -1;
          return 394; /* vec_duplicatev8si_exec */

        case E_V8HFmode:
          if (pattern159 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
            return -1;
          return 396; /* vec_duplicatev8hf_exec */

        case E_V8SFmode:
          if (pattern159 (x2, 
E_V8SFmode, 
E_SFmode) != 0)
            return -1;
          return 398; /* vec_duplicatev8sf_exec */

        case E_V16QImode:
          if (pattern159 (x2, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          return 400; /* vec_duplicatev16qi_exec */

        case E_V16HImode:
          if (pattern159 (x2, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 402; /* vec_duplicatev16hi_exec */

        case E_V16SImode:
          if (pattern159 (x2, 
E_V16SImode, 
E_SImode) != 0)
            return -1;
          return 404; /* vec_duplicatev16si_exec */

        case E_V16HFmode:
          if (pattern159 (x2, 
E_V16HFmode, 
E_HFmode) != 0)
            return -1;
          return 406; /* vec_duplicatev16hf_exec */

        case E_V16SFmode:
          if (pattern159 (x2, 
E_V16SFmode, 
E_SFmode) != 0)
            return -1;
          return 408; /* vec_duplicatev16sf_exec */

        case E_V32QImode:
          if (pattern159 (x2, 
E_V32QImode, 
E_QImode) != 0)
            return -1;
          return 410; /* vec_duplicatev32qi_exec */

        case E_V32HImode:
          if (pattern159 (x2, 
E_V32HImode, 
E_HImode) != 0)
            return -1;
          return 412; /* vec_duplicatev32hi_exec */

        case E_V32SImode:
          if (pattern159 (x2, 
E_V32SImode, 
E_SImode) != 0)
            return -1;
          return 414; /* vec_duplicatev32si_exec */

        case E_V32HFmode:
          if (pattern159 (x2, 
E_V32HFmode, 
E_HFmode) != 0)
            return -1;
          return 416; /* vec_duplicatev32hf_exec */

        case E_V32SFmode:
          if (pattern159 (x2, 
E_V32SFmode, 
E_SFmode) != 0)
            return -1;
          return 418; /* vec_duplicatev32sf_exec */

        case E_V64QImode:
          if (pattern159 (x2, 
E_V64QImode, 
E_QImode) != 0)
            return -1;
          return 420; /* vec_duplicatev64qi_exec */

        case E_V64HImode:
          if (pattern159 (x2, 
E_V64HImode, 
E_HImode) != 0)
            return -1;
          return 422; /* vec_duplicatev64hi_exec */

        case E_V64SImode:
          if (pattern159 (x2, 
E_V64SImode, 
E_SImode) != 0)
            return -1;
          return 424; /* vec_duplicatev64si_exec */

        case E_V64HFmode:
          if (pattern159 (x2, 
E_V64HFmode, 
E_HFmode) != 0)
            return -1;
          return 426; /* vec_duplicatev64hf_exec */

        case E_V64SFmode:
          if (pattern159 (x2, 
E_V64SFmode, 
E_SFmode) != 0)
            return -1;
          return 428; /* vec_duplicatev64sf_exec */

        case E_V2DImode:
          if (pattern159 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return -1;
          return 430; /* vec_duplicatev2di_exec */

        case E_V2DFmode:
          if (pattern159 (x2, 
E_V2DFmode, 
E_DFmode) != 0)
            return -1;
          return 432; /* vec_duplicatev2df_exec */

        case E_V4DImode:
          if (pattern159 (x2, 
E_V4DImode, 
E_DImode) != 0)
            return -1;
          return 434; /* vec_duplicatev4di_exec */

        case E_V4DFmode:
          if (pattern159 (x2, 
E_V4DFmode, 
E_DFmode) != 0)
            return -1;
          return 436; /* vec_duplicatev4df_exec */

        case E_V8DImode:
          if (pattern159 (x2, 
E_V8DImode, 
E_DImode) != 0)
            return -1;
          return 438; /* vec_duplicatev8di_exec */

        case E_V8DFmode:
          if (pattern159 (x2, 
E_V8DFmode, 
E_DFmode) != 0)
            return -1;
          return 440; /* vec_duplicatev8df_exec */

        case E_V16DImode:
          if (pattern159 (x2, 
E_V16DImode, 
E_DImode) != 0)
            return -1;
          return 442; /* vec_duplicatev16di_exec */

        case E_V16DFmode:
          if (pattern159 (x2, 
E_V16DFmode, 
E_DFmode) != 0)
            return -1;
          return 444; /* vec_duplicatev16df_exec */

        case E_V32DImode:
          if (pattern159 (x2, 
E_V32DImode, 
E_DImode) != 0)
            return -1;
          return 446; /* vec_duplicatev32di_exec */

        case E_V32DFmode:
          if (pattern159 (x2, 
E_V32DFmode, 
E_DFmode) != 0)
            return -1;
          return 448; /* vec_duplicatev32df_exec */

        case E_V64DImode:
          if (pattern159 (x2, 
E_V64DImode, 
E_DImode) != 0)
            return -1;
          return 450; /* vec_duplicatev64di_exec */

        case E_V64DFmode:
          if (pattern159 (x2, 
E_V64DFmode, 
E_DFmode) != 0)
            return -1;
          return 452; /* vec_duplicatev64df_exec */

        case E_V2TImode:
          if (pattern159 (x2, 
E_V2TImode, 
E_TImode) != 0)
            return -1;
          return 454; /* vec_duplicatev2ti_exec */

        case E_V4TImode:
          if (pattern159 (x2, 
E_V4TImode, 
E_TImode) != 0)
            return -1;
          return 456; /* vec_duplicatev4ti_exec */

        case E_V8TImode:
          if (pattern159 (x2, 
E_V8TImode, 
E_TImode) != 0)
            return -1;
          return 458; /* vec_duplicatev8ti_exec */

        case E_V16TImode:
          if (pattern159 (x2, 
E_V16TImode, 
E_TImode) != 0)
            return -1;
          return 460; /* vec_duplicatev16ti_exec */

        case E_V32TImode:
          if (pattern159 (x2, 
E_V32TImode, 
E_TImode) != 0)
            return -1;
          return 462; /* vec_duplicatev32ti_exec */

        case E_V64TImode:
          if (pattern159 (x2, 
E_V64TImode, 
E_TImode) != 0)
            return -1;
          return 464; /* vec_duplicatev64ti_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (pattern157 (x2, 
E_V2QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 171; /* movv2qi_exec */

    case E_V2HImode:
      if (pattern157 (x2, 
E_V2HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 172; /* movv2hi_exec */

    case E_V2SImode:
      if (pattern157 (x2, 
E_V2SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 173; /* movv2si_exec */

    case E_V2HFmode:
      if (pattern157 (x2, 
E_V2HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 174; /* movv2hf_exec */

    case E_V2SFmode:
      if (pattern157 (x2, 
E_V2SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 175; /* movv2sf_exec */

    case E_V4QImode:
      if (pattern157 (x2, 
E_V4QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 176; /* movv4qi_exec */

    case E_V4HImode:
      if (pattern157 (x2, 
E_V4HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 177; /* movv4hi_exec */

    case E_V4SImode:
      if (pattern157 (x2, 
E_V4SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 178; /* movv4si_exec */

    case E_V4HFmode:
      if (pattern157 (x2, 
E_V4HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 179; /* movv4hf_exec */

    case E_V4SFmode:
      if (pattern157 (x2, 
E_V4SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 180; /* movv4sf_exec */

    case E_V8QImode:
      if (pattern157 (x2, 
E_V8QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 181; /* movv8qi_exec */

    case E_V8HImode:
      if (pattern157 (x2, 
E_V8HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 182; /* movv8hi_exec */

    case E_V8SImode:
      if (pattern157 (x2, 
E_V8SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 183; /* movv8si_exec */

    case E_V8HFmode:
      if (pattern157 (x2, 
E_V8HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 184; /* movv8hf_exec */

    case E_V8SFmode:
      if (pattern157 (x2, 
E_V8SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 185; /* movv8sf_exec */

    case E_V16QImode:
      if (pattern157 (x2, 
E_V16QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 186; /* movv16qi_exec */

    case E_V16HImode:
      if (pattern157 (x2, 
E_V16HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 187; /* movv16hi_exec */

    case E_V16SImode:
      if (pattern157 (x2, 
E_V16SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 188; /* movv16si_exec */

    case E_V16HFmode:
      if (pattern157 (x2, 
E_V16HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 189; /* movv16hf_exec */

    case E_V16SFmode:
      if (pattern157 (x2, 
E_V16SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 190; /* movv16sf_exec */

    case E_V32QImode:
      if (pattern157 (x2, 
E_V32QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 191; /* movv32qi_exec */

    case E_V32HImode:
      if (pattern157 (x2, 
E_V32HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 192; /* movv32hi_exec */

    case E_V32SImode:
      if (pattern157 (x2, 
E_V32SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 193; /* movv32si_exec */

    case E_V32HFmode:
      if (pattern157 (x2, 
E_V32HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 194; /* movv32hf_exec */

    case E_V32SFmode:
      if (pattern157 (x2, 
E_V32SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 195; /* movv32sf_exec */

    case E_V64QImode:
      if (pattern157 (x2, 
E_V64QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 196; /* movv64qi_exec */

    case E_V64HImode:
      if (pattern157 (x2, 
E_V64HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 197; /* movv64hi_exec */

    case E_V64SImode:
      if (pattern157 (x2, 
E_V64SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 198; /* movv64si_exec */

    case E_V64HFmode:
      if (pattern157 (x2, 
E_V64HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 199; /* movv64hf_exec */

    case E_V64SFmode:
      if (pattern157 (x2, 
E_V64SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 200; /* movv64sf_exec */

    case E_V2DImode:
      if (pattern157 (x2, 
E_V2DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 213; /* movv2di_exec */

    case E_V2DFmode:
      if (pattern157 (x2, 
E_V2DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 214; /* movv2df_exec */

    case E_V4DImode:
      if (pattern157 (x2, 
E_V4DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 215; /* movv4di_exec */

    case E_V4DFmode:
      if (pattern157 (x2, 
E_V4DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 216; /* movv4df_exec */

    case E_V8DImode:
      if (pattern157 (x2, 
E_V8DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 217; /* movv8di_exec */

    case E_V8DFmode:
      if (pattern157 (x2, 
E_V8DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 218; /* movv8df_exec */

    case E_V16DImode:
      if (pattern157 (x2, 
E_V16DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 219; /* movv16di_exec */

    case E_V16DFmode:
      if (pattern157 (x2, 
E_V16DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 220; /* movv16df_exec */

    case E_V32DImode:
      if (pattern157 (x2, 
E_V32DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 221; /* movv32di_exec */

    case E_V32DFmode:
      if (pattern157 (x2, 
E_V32DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 222; /* movv32df_exec */

    case E_V64DImode:
      if (pattern157 (x2, 
E_V64DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 223; /* movv64di_exec */

    case E_V64DFmode:
      if (pattern157 (x2, 
E_V64DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 224; /* movv64df_exec */

    case E_V2TImode:
      if (pattern157 (x2, 
E_V2TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 231; /* movv2ti_exec */

    case E_V4TImode:
      if (pattern157 (x2, 
E_V4TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 232; /* movv4ti_exec */

    case E_V8TImode:
      if (pattern157 (x2, 
E_V8TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 233; /* movv8ti_exec */

    case E_V16TImode:
      if (pattern157 (x2, 
E_V16TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 234; /* movv16ti_exec */

    case E_V32TImode:
      if (pattern157 (x2, 
E_V32TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 235; /* movv32ti_exec */

    case E_V64TImode:
      if (pattern157 (x2, 
E_V64TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      *pnum_clobbers = 1;
      return 236; /* movv64ti_exec */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (XVECLEN (x3, 0) == 1)
    {
      res = recog_63 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x3;
  if (!ascending_zero_int_parallel (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x2) != E_V2QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!register_operand (operands[1], E_V4QImode))
            return -1;
          return 513; /* vec_extractv4qiv2qi_nop */

        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 514; /* vec_extractv8qiv2qi_nop */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 515; /* vec_extractv16qiv2qi_nop */

        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 516; /* vec_extractv32qiv2qi_nop */

        case E_V64QImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 517; /* vec_extractv64qiv2qi_nop */

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x2) != E_V2HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 518; /* vec_extractv4hiv2hi_nop */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 519; /* vec_extractv8hiv2hi_nop */

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 520; /* vec_extractv16hiv2hi_nop */

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode))
            return -1;
          return 521; /* vec_extractv32hiv2hi_nop */

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64HImode))
            return -1;
          return 522; /* vec_extractv64hiv2hi_nop */

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 523; /* vec_extractv4siv2si_nop */

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 524; /* vec_extractv8siv2si_nop */

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 525; /* vec_extractv16siv2si_nop */

        case E_V32SImode:
          if (!register_operand (operands[1], E_V32SImode))
            return -1;
          return 526; /* vec_extractv32siv2si_nop */

        case E_V64SImode:
          if (!register_operand (operands[1], E_V64SImode))
            return -1;
          return 527; /* vec_extractv64siv2si_nop */

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x2) != E_V2HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode))
            return -1;
          return 528; /* vec_extractv4hfv2hf_nop */

        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 529; /* vec_extractv8hfv2hf_nop */

        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 530; /* vec_extractv16hfv2hf_nop */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          return 531; /* vec_extractv32hfv2hf_nop */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode))
            return -1;
          return 532; /* vec_extractv64hfv2hf_nop */

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode))
            return -1;
          return 533; /* vec_extractv4sfv2sf_nop */

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 534; /* vec_extractv8sfv2sf_nop */

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 535; /* vec_extractv16sfv2sf_nop */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode))
            return -1;
          return 536; /* vec_extractv32sfv2sf_nop */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode))
            return -1;
          return 537; /* vec_extractv64sfv2sf_nop */

        default:
          return -1;
        }

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x2) != E_V4QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 538; /* vec_extractv8qiv4qi_nop */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 539; /* vec_extractv16qiv4qi_nop */

        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 540; /* vec_extractv32qiv4qi_nop */

        case E_V64QImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 541; /* vec_extractv64qiv4qi_nop */

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 542; /* vec_extractv8hiv4hi_nop */

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 543; /* vec_extractv16hiv4hi_nop */

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode))
            return -1;
          return 544; /* vec_extractv32hiv4hi_nop */

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64HImode))
            return -1;
          return 545; /* vec_extractv64hiv4hi_nop */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 546; /* vec_extractv8siv4si_nop */

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 547; /* vec_extractv16siv4si_nop */

        case E_V32SImode:
          if (!register_operand (operands[1], E_V32SImode))
            return -1;
          return 548; /* vec_extractv32siv4si_nop */

        case E_V64SImode:
          if (!register_operand (operands[1], E_V64SImode))
            return -1;
          return 549; /* vec_extractv64siv4si_nop */

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 550; /* vec_extractv8hfv4hf_nop */

        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 551; /* vec_extractv16hfv4hf_nop */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          return 552; /* vec_extractv32hfv4hf_nop */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode))
            return -1;
          return 553; /* vec_extractv64hfv4hf_nop */

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 554; /* vec_extractv8sfv4sf_nop */

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 555; /* vec_extractv16sfv4sf_nop */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode))
            return -1;
          return 556; /* vec_extractv32sfv4sf_nop */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode))
            return -1;
          return 557; /* vec_extractv64sfv4sf_nop */

        default:
          return -1;
        }

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 558; /* vec_extractv16qiv8qi_nop */

        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 559; /* vec_extractv32qiv8qi_nop */

        case E_V64QImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 560; /* vec_extractv64qiv8qi_nop */

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 561; /* vec_extractv16hiv8hi_nop */

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode))
            return -1;
          return 562; /* vec_extractv32hiv8hi_nop */

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64HImode))
            return -1;
          return 563; /* vec_extractv64hiv8hi_nop */

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 564; /* vec_extractv16siv8si_nop */

        case E_V32SImode:
          if (!register_operand (operands[1], E_V32SImode))
            return -1;
          return 565; /* vec_extractv32siv8si_nop */

        case E_V64SImode:
          if (!register_operand (operands[1], E_V64SImode))
            return -1;
          return 566; /* vec_extractv64siv8si_nop */

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 567; /* vec_extractv16hfv8hf_nop */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          return 568; /* vec_extractv32hfv8hf_nop */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode))
            return -1;
          return 569; /* vec_extractv64hfv8hf_nop */

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 570; /* vec_extractv16sfv8sf_nop */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode))
            return -1;
          return 571; /* vec_extractv32sfv8sf_nop */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode))
            return -1;
          return 572; /* vec_extractv64sfv8sf_nop */

        default:
          return -1;
        }

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 573; /* vec_extractv32qiv16qi_nop */

        case E_V64QImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 574; /* vec_extractv64qiv16qi_nop */

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode))
            return -1;
          return 575; /* vec_extractv32hiv16hi_nop */

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64HImode))
            return -1;
          return 576; /* vec_extractv64hiv16hi_nop */

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32SImode:
          if (!register_operand (operands[1], E_V32SImode))
            return -1;
          return 577; /* vec_extractv32siv16si_nop */

        case E_V64SImode:
          if (!register_operand (operands[1], E_V64SImode))
            return -1;
          return 578; /* vec_extractv64siv16si_nop */

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          return 579; /* vec_extractv32hfv16hf_nop */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode))
            return -1;
          return 580; /* vec_extractv64hfv16hf_nop */

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode))
            return -1;
          return 581; /* vec_extractv32sfv16sf_nop */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode))
            return -1;
          return 582; /* vec_extractv64sfv16sf_nop */

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 583; /* vec_extractv64qiv32qi_nop */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 584; /* vec_extractv64hiv32hi_nop */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 585; /* vec_extractv64siv32si_nop */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 586; /* vec_extractv64hfv32hf_nop */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 587; /* vec_extractv64sfv32sf_nop */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode))
            return -1;
          return 588; /* vec_extractv4div2di_nop */

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 590; /* vec_extractv8div2di_nop */

        case E_V16DImode:
          if (!register_operand (operands[1], E_V16DImode))
            return -1;
          return 594; /* vec_extractv16div2di_nop */

        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode))
            return -1;
          return 600; /* vec_extractv32div2di_nop */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode))
            return -1;
          return 608; /* vec_extractv64div2di_nop */

        default:
          return -1;
        }

    case E_V2DFmode:
      return recog_64 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 591; /* vec_extractv8div4di_nop */

        case E_V16DImode:
          if (!register_operand (operands[1], E_V16DImode))
            return -1;
          return 595; /* vec_extractv16div4di_nop */

        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode))
            return -1;
          return 601; /* vec_extractv32div4di_nop */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode))
            return -1;
          return 609; /* vec_extractv64div4di_nop */

        default:
          return -1;
        }

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 593; /* vec_extractv8dfv4df_nop */

        case E_V16DFmode:
          if (!register_operand (operands[1], E_V16DFmode))
            return -1;
          return 598; /* vec_extractv16dfv4df_nop */

        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode))
            return -1;
          return 605; /* vec_extractv32dfv4df_nop */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode))
            return -1;
          return 614; /* vec_extractv64dfv4df_nop */

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16DImode:
          if (!register_operand (operands[1], E_V16DImode))
            return -1;
          return 596; /* vec_extractv16div8di_nop */

        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode))
            return -1;
          return 602; /* vec_extractv32div8di_nop */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode))
            return -1;
          return 610; /* vec_extractv64div8di_nop */

        default:
          return -1;
        }

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[1], E_V16DFmode))
            return -1;
          return 599; /* vec_extractv16dfv8df_nop */

        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode))
            return -1;
          return 606; /* vec_extractv32dfv8df_nop */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode))
            return -1;
          return 615; /* vec_extractv64dfv8df_nop */

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x2) != E_V16DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode))
            return -1;
          return 603; /* vec_extractv32div16di_nop */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode))
            return -1;
          return 611; /* vec_extractv64div16di_nop */

        default:
          return -1;
        }

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x2) != E_V16DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode))
            return -1;
          return 607; /* vec_extractv32dfv16df_nop */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode))
            return -1;
          return 616; /* vec_extractv64dfv16df_nop */

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 612; /* vec_extractv64div32di_nop */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 617; /* vec_extractv64dfv32df_nop */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern25 (x1))
    {
    case 0:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HImode,
		    float_cvt)))
        return 3119; /* floathihi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HImode,
		    float_cvt)))
        return 3125; /* floatsihi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HImode,
		    float_cvt)))
        return 3131; /* floathfhi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HImode,
		    float_cvt)))
        return 3137; /* floatsfhi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HImode,
		    float_cvt)))
        return -1;
      return 3143; /* floatdfhi2 */

    case 1:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SImode,
		    float_cvt)))
        return 3149; /* floathisi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SImode,
		    float_cvt)))
        return 3155; /* floatsisi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SImode,
		    float_cvt)))
        return 3161; /* floathfsi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SImode,
		    float_cvt)))
        return 3167; /* floatsfsi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SImode,
		    float_cvt)))
        return -1;
      return 3173; /* floatdfsi2 */

    case 2:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HFmode,
		    float_cvt)))
        return 3179; /* floathihf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HFmode,
		    float_cvt)))
        return 3185; /* floatsihf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HFmode,
		    float_cvt)))
        return 3191; /* floathfhf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HFmode,
		    float_cvt)))
        return 3197; /* floatsfhf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HFmode,
		    float_cvt)))
        return -1;
      return 3203; /* floatdfhf2 */

    case 3:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SFmode,
		    float_cvt)))
        return 3209; /* floathisf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SFmode,
		    float_cvt)))
        return 3215; /* floatsisf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SFmode,
		    float_cvt)))
        return 3221; /* floathfsf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SFmode,
		    float_cvt)))
        return 3227; /* floatsfsf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SFmode,
		    float_cvt)))
        return -1;
      return 3233; /* floatdfsf2 */

    case 4:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, DFmode,
		    float_cvt)))
        return 3239; /* floathidf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, DFmode,
		    float_cvt)))
        return 3245; /* floatsidf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, DFmode,
		    float_cvt)))
        return 3251; /* floathfdf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, DFmode,
		    float_cvt)))
        return 3257; /* floatsfdf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, DFmode,
		    float_cvt)))
        return -1;
      return 3263; /* floatdfdf2 */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3271; /* floatv2hiv2hf2 */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3283; /* floatv2siv2hf2 */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3295; /* floatv2hfv2hf2 */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3307; /* floatv2sfv2hf2 */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3319; /* floatv2dfv2hf2 */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3331; /* floatv2hiv2sf2 */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3343; /* floatv2siv2sf2 */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3355; /* floatv2hfv2sf2 */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3367; /* floatv2sfv2sf2 */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3379; /* floatv2dfv2sf2 */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3391; /* floatv2hiv2df2 */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3403; /* floatv2siv2df2 */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3415; /* floatv2hfv2df2 */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3427; /* floatv2sfv2df2 */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3439; /* floatv2dfv2df2 */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3451; /* floatv4hiv4hf2 */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3463; /* floatv4siv4hf2 */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3475; /* floatv4hfv4hf2 */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3487; /* floatv4sfv4hf2 */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3499; /* floatv4dfv4hf2 */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3511; /* floatv4hiv4sf2 */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3523; /* floatv4siv4sf2 */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3535; /* floatv4hfv4sf2 */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3547; /* floatv4sfv4sf2 */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3559; /* floatv4dfv4sf2 */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3571; /* floatv4hiv4df2 */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3583; /* floatv4siv4df2 */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3595; /* floatv4hfv4df2 */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3607; /* floatv4sfv4df2 */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3619; /* floatv4dfv4df2 */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3631; /* floatv8hiv8hf2 */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3643; /* floatv8siv8hf2 */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3655; /* floatv8hfv8hf2 */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3667; /* floatv8sfv8hf2 */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3679; /* floatv8dfv8hf2 */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3691; /* floatv8hiv8sf2 */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3703; /* floatv8siv8sf2 */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3715; /* floatv8hfv8sf2 */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3727; /* floatv8sfv8sf2 */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3739; /* floatv8dfv8sf2 */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3751; /* floatv8hiv8df2 */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3763; /* floatv8siv8df2 */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3775; /* floatv8hfv8df2 */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3787; /* floatv8sfv8df2 */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3799; /* floatv8dfv8df2 */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3811; /* floatv16hiv16hf2 */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3823; /* floatv16siv16hf2 */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3835; /* floatv16hfv16hf2 */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3847; /* floatv16sfv16hf2 */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3859; /* floatv16dfv16hf2 */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3871; /* floatv16hiv16sf2 */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3883; /* floatv16siv16sf2 */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3895; /* floatv16hfv16sf2 */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3907; /* floatv16sfv16sf2 */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3919; /* floatv16dfv16sf2 */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3931; /* floatv16hiv16df2 */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3943; /* floatv16siv16df2 */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3955; /* floatv16hfv16df2 */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3967; /* floatv16sfv16df2 */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3979; /* floatv16dfv16df2 */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       float_cvt)))
        return -1;
      return 3991; /* floatv32hiv32hf2 */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4003; /* floatv32siv32hf2 */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4015; /* floatv32hfv32hf2 */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4027; /* floatv32sfv32hf2 */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4039; /* floatv32dfv32hf2 */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4051; /* floatv32hiv32sf2 */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4063; /* floatv32siv32sf2 */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4075; /* floatv32hfv32sf2 */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4087; /* floatv32sfv32sf2 */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4099; /* floatv32dfv32sf2 */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4111; /* floatv32hiv32df2 */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4123; /* floatv32siv32df2 */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4135; /* floatv32hfv32df2 */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4147; /* floatv32sfv32df2 */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4159; /* floatv32dfv32df2 */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4171; /* floatv64hiv64hf2 */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4183; /* floatv64siv64hf2 */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4195; /* floatv64hfv64hf2 */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4207; /* floatv64sfv64hf2 */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4219; /* floatv64dfv64hf2 */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4231; /* floatv64hiv64sf2 */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4243; /* floatv64siv64sf2 */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4255; /* floatv64hfv64sf2 */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4267; /* floatv64sfv64sf2 */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4279; /* floatv64dfv64sf2 */

    case 90:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4291; /* floatv64hiv64df2 */

    case 91:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4303; /* floatv64siv64df2 */

    case 92:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4315; /* floatv64hfv64df2 */

    case 93:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4327; /* floatv64sfv64df2 */

    case 94:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4339; /* floatv64dfv64df2 */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       float_cvt)))
        return -1;
      return 4351; /* floatv2hfv2hi2 */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       float_cvt)))
        return -1;
      return 4363; /* floatv2sfv2hi2 */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       float_cvt)))
        return -1;
      return 4375; /* floatv2dfv2hi2 */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       float_cvt)))
        return -1;
      return 4387; /* floatv2hfv2si2 */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       float_cvt)))
        return -1;
      return 4399; /* floatv2sfv2si2 */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       float_cvt)))
        return -1;
      return 4411; /* floatv2dfv2si2 */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       float_cvt)))
        return -1;
      return 4423; /* floatv4hfv4hi2 */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       float_cvt)))
        return -1;
      return 4435; /* floatv4sfv4hi2 */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       float_cvt)))
        return -1;
      return 4447; /* floatv4dfv4hi2 */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       float_cvt)))
        return -1;
      return 4459; /* floatv4hfv4si2 */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       float_cvt)))
        return -1;
      return 4471; /* floatv4sfv4si2 */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       float_cvt)))
        return -1;
      return 4483; /* floatv4dfv4si2 */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       float_cvt)))
        return -1;
      return 4495; /* floatv8hfv8hi2 */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       float_cvt)))
        return -1;
      return 4507; /* floatv8sfv8hi2 */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       float_cvt)))
        return -1;
      return 4519; /* floatv8dfv8hi2 */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       float_cvt)))
        return -1;
      return 4531; /* floatv8hfv8si2 */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       float_cvt)))
        return -1;
      return 4543; /* floatv8sfv8si2 */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       float_cvt)))
        return -1;
      return 4555; /* floatv8dfv8si2 */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       float_cvt)))
        return -1;
      return 4567; /* floatv16hfv16hi2 */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       float_cvt)))
        return -1;
      return 4579; /* floatv16sfv16hi2 */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       float_cvt)))
        return -1;
      return 4591; /* floatv16dfv16hi2 */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       float_cvt)))
        return -1;
      return 4603; /* floatv16hfv16si2 */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       float_cvt)))
        return -1;
      return 4615; /* floatv16sfv16si2 */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       float_cvt)))
        return -1;
      return 4627; /* floatv16dfv16si2 */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       float_cvt)))
        return -1;
      return 4639; /* floatv32hfv32hi2 */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       float_cvt)))
        return -1;
      return 4651; /* floatv32sfv32hi2 */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       float_cvt)))
        return -1;
      return 4663; /* floatv32dfv32hi2 */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       float_cvt)))
        return -1;
      return 4675; /* floatv32hfv32si2 */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       float_cvt)))
        return -1;
      return 4687; /* floatv32sfv32si2 */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       float_cvt)))
        return -1;
      return 4699; /* floatv32dfv32si2 */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       float_cvt)))
        return -1;
      return 4711; /* floatv64hfv64hi2 */

    case 126:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       float_cvt)))
        return -1;
      return 4723; /* floatv64sfv64hi2 */

    case 127:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       float_cvt)))
        return -1;
      return 4735; /* floatv64dfv64hi2 */

    case 128:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       float_cvt)))
        return -1;
      return 4747; /* floatv64hfv64si2 */

    case 129:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       float_cvt)))
        return -1;
      return 4759; /* floatv64sfv64si2 */

    case 130:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       float_cvt)))
        return -1;
      return 4771; /* floatv64dfv64si2 */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 4:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 5:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 2:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 3:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (nonimmediate_operand (operands[0], E_V2QImode)
          && gcn_unspec_operand (operands[1], E_V2QImode))
        return 93; /* movv2qi_unspec */
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && gcn_unspec_operand (operands[1], E_V2HImode))
        return 94; /* movv2hi_unspec */
      break;

    case E_V2HFmode:
      if (nonimmediate_operand (operands[0], E_V2HFmode)
          && gcn_unspec_operand (operands[1], E_V2HFmode))
        return 95; /* movv2hf_unspec */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && gcn_unspec_operand (operands[1], E_V2SImode))
        return 96; /* movv2si_unspec */
      break;

    case E_V2SFmode:
      if (nonimmediate_operand (operands[0], E_V2SFmode)
          && gcn_unspec_operand (operands[1], E_V2SFmode))
        return 97; /* movv2sf_unspec */
      break;

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && gcn_unspec_operand (operands[1], E_V2DImode))
        return 98; /* movv2di_unspec */
      break;

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && gcn_unspec_operand (operands[1], E_V2DFmode))
        return 99; /* movv2df_unspec */
      break;

    case E_V2TImode:
      if (nonimmediate_operand (operands[0], E_V2TImode)
          && gcn_unspec_operand (operands[1], E_V2TImode))
        return 100; /* movv2ti_unspec */
      break;

    case E_V4QImode:
      if (nonimmediate_operand (operands[0], E_V4QImode)
          && gcn_unspec_operand (operands[1], E_V4QImode))
        return 101; /* movv4qi_unspec */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && gcn_unspec_operand (operands[1], E_V4HImode))
        return 102; /* movv4hi_unspec */
      break;

    case E_V4HFmode:
      if (nonimmediate_operand (operands[0], E_V4HFmode)
          && gcn_unspec_operand (operands[1], E_V4HFmode))
        return 103; /* movv4hf_unspec */
      break;

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && gcn_unspec_operand (operands[1], E_V4SImode))
        return 104; /* movv4si_unspec */
      break;

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && gcn_unspec_operand (operands[1], E_V4SFmode))
        return 105; /* movv4sf_unspec */
      break;

    case E_V4DImode:
      if (nonimmediate_operand (operands[0], E_V4DImode)
          && gcn_unspec_operand (operands[1], E_V4DImode))
        return 106; /* movv4di_unspec */
      break;

    case E_V4DFmode:
      if (nonimmediate_operand (operands[0], E_V4DFmode)
          && gcn_unspec_operand (operands[1], E_V4DFmode))
        return 107; /* movv4df_unspec */
      break;

    case E_V4TImode:
      if (nonimmediate_operand (operands[0], E_V4TImode)
          && gcn_unspec_operand (operands[1], E_V4TImode))
        return 108; /* movv4ti_unspec */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && gcn_unspec_operand (operands[1], E_V8QImode))
        return 109; /* movv8qi_unspec */
      break;

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && gcn_unspec_operand (operands[1], E_V8HImode))
        return 110; /* movv8hi_unspec */
      break;

    case E_V8HFmode:
      if (nonimmediate_operand (operands[0], E_V8HFmode)
          && gcn_unspec_operand (operands[1], E_V8HFmode))
        return 111; /* movv8hf_unspec */
      break;

    case E_V8SImode:
      if (nonimmediate_operand (operands[0], E_V8SImode)
          && gcn_unspec_operand (operands[1], E_V8SImode))
        return 112; /* movv8si_unspec */
      break;

    case E_V8SFmode:
      if (nonimmediate_operand (operands[0], E_V8SFmode)
          && gcn_unspec_operand (operands[1], E_V8SFmode))
        return 113; /* movv8sf_unspec */
      break;

    case E_V8DImode:
      if (nonimmediate_operand (operands[0], E_V8DImode)
          && gcn_unspec_operand (operands[1], E_V8DImode))
        return 114; /* movv8di_unspec */
      break;

    case E_V8DFmode:
      if (nonimmediate_operand (operands[0], E_V8DFmode)
          && gcn_unspec_operand (operands[1], E_V8DFmode))
        return 115; /* movv8df_unspec */
      break;

    case E_V8TImode:
      if (nonimmediate_operand (operands[0], E_V8TImode)
          && gcn_unspec_operand (operands[1], E_V8TImode))
        return 116; /* movv8ti_unspec */
      break;

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && gcn_unspec_operand (operands[1], E_V16QImode))
        return 117; /* movv16qi_unspec */
      break;

    case E_V16HImode:
      if (nonimmediate_operand (operands[0], E_V16HImode)
          && gcn_unspec_operand (operands[1], E_V16HImode))
        return 118; /* movv16hi_unspec */
      break;

    case E_V16HFmode:
      if (nonimmediate_operand (operands[0], E_V16HFmode)
          && gcn_unspec_operand (operands[1], E_V16HFmode))
        return 119; /* movv16hf_unspec */
      break;

    case E_V16SImode:
      if (nonimmediate_operand (operands[0], E_V16SImode)
          && gcn_unspec_operand (operands[1], E_V16SImode))
        return 120; /* movv16si_unspec */
      break;

    case E_V16SFmode:
      if (nonimmediate_operand (operands[0], E_V16SFmode)
          && gcn_unspec_operand (operands[1], E_V16SFmode))
        return 121; /* movv16sf_unspec */
      break;

    case E_V16DImode:
      if (nonimmediate_operand (operands[0], E_V16DImode)
          && gcn_unspec_operand (operands[1], E_V16DImode))
        return 122; /* movv16di_unspec */
      break;

    case E_V16DFmode:
      if (nonimmediate_operand (operands[0], E_V16DFmode)
          && gcn_unspec_operand (operands[1], E_V16DFmode))
        return 123; /* movv16df_unspec */
      break;

    case E_V16TImode:
      if (nonimmediate_operand (operands[0], E_V16TImode)
          && gcn_unspec_operand (operands[1], E_V16TImode))
        return 124; /* movv16ti_unspec */
      break;

    case E_V32QImode:
      if (nonimmediate_operand (operands[0], E_V32QImode)
          && gcn_unspec_operand (operands[1], E_V32QImode))
        return 125; /* movv32qi_unspec */
      break;

    case E_V32HImode:
      if (nonimmediate_operand (operands[0], E_V32HImode)
          && gcn_unspec_operand (operands[1], E_V32HImode))
        return 126; /* movv32hi_unspec */
      break;

    case E_V32HFmode:
      if (nonimmediate_operand (operands[0], E_V32HFmode)
          && gcn_unspec_operand (operands[1], E_V32HFmode))
        return 127; /* movv32hf_unspec */
      break;

    case E_V32SImode:
      if (nonimmediate_operand (operands[0], E_V32SImode)
          && gcn_unspec_operand (operands[1], E_V32SImode))
        return 128; /* movv32si_unspec */
      break;

    case E_V32SFmode:
      if (nonimmediate_operand (operands[0], E_V32SFmode)
          && gcn_unspec_operand (operands[1], E_V32SFmode))
        return 129; /* movv32sf_unspec */
      break;

    case E_V32DImode:
      if (nonimmediate_operand (operands[0], E_V32DImode)
          && gcn_unspec_operand (operands[1], E_V32DImode))
        return 130; /* movv32di_unspec */
      break;

    case E_V32DFmode:
      if (nonimmediate_operand (operands[0], E_V32DFmode)
          && gcn_unspec_operand (operands[1], E_V32DFmode))
        return 131; /* movv32df_unspec */
      break;

    case E_V32TImode:
      if (nonimmediate_operand (operands[0], E_V32TImode)
          && gcn_unspec_operand (operands[1], E_V32TImode))
        return 132; /* movv32ti_unspec */
      break;

    case E_V64QImode:
      if (nonimmediate_operand (operands[0], E_V64QImode)
          && gcn_unspec_operand (operands[1], E_V64QImode))
        return 133; /* movv64qi_unspec */
      break;

    case E_V64HImode:
      if (nonimmediate_operand (operands[0], E_V64HImode)
          && gcn_unspec_operand (operands[1], E_V64HImode))
        return 134; /* movv64hi_unspec */
      break;

    case E_V64HFmode:
      if (nonimmediate_operand (operands[0], E_V64HFmode)
          && gcn_unspec_operand (operands[1], E_V64HFmode))
        return 135; /* movv64hf_unspec */
      break;

    case E_V64SImode:
      if (nonimmediate_operand (operands[0], E_V64SImode)
          && gcn_unspec_operand (operands[1], E_V64SImode))
        return 136; /* movv64si_unspec */
      break;

    case E_V64SFmode:
      if (nonimmediate_operand (operands[0], E_V64SFmode)
          && gcn_unspec_operand (operands[1], E_V64SFmode))
        return 137; /* movv64sf_unspec */
      break;

    case E_V64DImode:
      if (nonimmediate_operand (operands[0], E_V64DImode)
          && gcn_unspec_operand (operands[1], E_V64DImode))
        return 138; /* movv64di_unspec */
      break;

    case E_V64DFmode:
      if (nonimmediate_operand (operands[0], E_V64DFmode)
          && gcn_unspec_operand (operands[1], E_V64DFmode))
        return 139; /* movv64df_unspec */
      break;

    case E_V64TImode:
      if (nonimmediate_operand (operands[0], E_V64TImode)
          && gcn_unspec_operand (operands[1], E_V64TImode))
        return 140; /* movv64ti_unspec */
      break;

    default:
      break;
    }
  operands[0] = x3;
  return recog_15 (x1, insn, pnum_clobbers);
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern76 (x3, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 55; /* one_cmplsi2 */

    case E_DImode:
      if (pattern76 (x3, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 73; /* one_cmpldi2 */

    case E_V2QImode:
      if (!gcn_valu_dst_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !gcn_valu_src0_operand (operands[1], E_V2QImode))
        return -1;
      return 1755; /* one_cmplv2qi2 */

    case E_V2HImode:
      if (!gcn_valu_dst_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !gcn_valu_src0_operand (operands[1], E_V2HImode))
        return -1;
      return 1759; /* one_cmplv2hi2 */

    case E_V2SImode:
      if (!gcn_valu_dst_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !gcn_valu_src0_operand (operands[1], E_V2SImode))
        return -1;
      return 1763; /* one_cmplv2si2 */

    case E_V4QImode:
      if (!gcn_valu_dst_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !gcn_valu_src0_operand (operands[1], E_V4QImode))
        return -1;
      return 1767; /* one_cmplv4qi2 */

    case E_V4HImode:
      if (!gcn_valu_dst_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !gcn_valu_src0_operand (operands[1], E_V4HImode))
        return -1;
      return 1771; /* one_cmplv4hi2 */

    case E_V4SImode:
      if (!gcn_valu_dst_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !gcn_valu_src0_operand (operands[1], E_V4SImode))
        return -1;
      return 1775; /* one_cmplv4si2 */

    case E_V8QImode:
      if (!gcn_valu_dst_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !gcn_valu_src0_operand (operands[1], E_V8QImode))
        return -1;
      return 1779; /* one_cmplv8qi2 */

    case E_V8HImode:
      if (!gcn_valu_dst_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !gcn_valu_src0_operand (operands[1], E_V8HImode))
        return -1;
      return 1783; /* one_cmplv8hi2 */

    case E_V8SImode:
      if (!gcn_valu_dst_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !gcn_valu_src0_operand (operands[1], E_V8SImode))
        return -1;
      return 1787; /* one_cmplv8si2 */

    case E_V16QImode:
      if (!gcn_valu_dst_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !gcn_valu_src0_operand (operands[1], E_V16QImode))
        return -1;
      return 1791; /* one_cmplv16qi2 */

    case E_V16HImode:
      if (!gcn_valu_dst_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !gcn_valu_src0_operand (operands[1], E_V16HImode))
        return -1;
      return 1795; /* one_cmplv16hi2 */

    case E_V16SImode:
      if (!gcn_valu_dst_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !gcn_valu_src0_operand (operands[1], E_V16SImode))
        return -1;
      return 1799; /* one_cmplv16si2 */

    case E_V32QImode:
      if (!gcn_valu_dst_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !gcn_valu_src0_operand (operands[1], E_V32QImode))
        return -1;
      return 1803; /* one_cmplv32qi2 */

    case E_V32HImode:
      if (!gcn_valu_dst_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !gcn_valu_src0_operand (operands[1], E_V32HImode))
        return -1;
      return 1807; /* one_cmplv32hi2 */

    case E_V32SImode:
      if (!gcn_valu_dst_operand (operands[0], E_V32SImode)
          || GET_MODE (x3) != E_V32SImode
          || !gcn_valu_src0_operand (operands[1], E_V32SImode))
        return -1;
      return 1811; /* one_cmplv32si2 */

    case E_V64QImode:
      if (!gcn_valu_dst_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !gcn_valu_src0_operand (operands[1], E_V64QImode))
        return -1;
      return 1815; /* one_cmplv64qi2 */

    case E_V64HImode:
      if (!gcn_valu_dst_operand (operands[0], E_V64HImode)
          || GET_MODE (x3) != E_V64HImode
          || !gcn_valu_src0_operand (operands[1], E_V64HImode))
        return -1;
      return 1819; /* one_cmplv64hi2 */

    case E_V64SImode:
      if (!gcn_valu_dst_operand (operands[0], E_V64SImode)
          || GET_MODE (x3) != E_V64SImode
          || !gcn_valu_src0_operand (operands[1], E_V64SImode))
        return -1;
      return 1823; /* one_cmplv64si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !gcn_alu_operand (operands[1], E_V2DImode))
        return -1;
      return 2211; /* one_cmplv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !gcn_alu_operand (operands[1], E_V4DImode))
        return -1;
      return 2213; /* one_cmplv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !gcn_alu_operand (operands[1], E_V8DImode))
        return -1;
      return 2215; /* one_cmplv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x3) != E_V16DImode
          || !gcn_alu_operand (operands[1], E_V16DImode))
        return -1;
      return 2217; /* one_cmplv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x3) != E_V32DImode
          || !gcn_alu_operand (operands[1], E_V32DImode))
        return -1;
      return 2219; /* one_cmplv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x3) != E_V64DImode
          || !gcn_alu_operand (operands[1], E_V64DImode))
        return -1;
      return 2221; /* one_cmplv64di2 */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      switch (pattern79 (x1))
        {
        case 0:
          return 63; /* andsi3 */

        case 1:
          return 74; /* anddi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (!gcn_fp_compare_operator (operands[1], E_VOIDmode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[4] = x7;
      if (!gcn_exec_reg_operand (operands[4], E_DImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[5] = x8;
      if (!scratch_operand (operands[5], E_DImode))
        return -1;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x9;
          switch (GET_MODE (operands[2]))
            {
            case E_V2HImode:
              if (!gcn_alu_operand (operands[2], E_V2HImode)
                  || !gcn_vop3_operand (operands[3], E_V2HImode))
                return -1;
              return 8811; /* vec_cmpv2hidi_exec */

            case E_V2HFmode:
              if (!gcn_alu_operand (operands[2], E_V2HFmode)
                  || !gcn_vop3_operand (operands[3], E_V2HFmode))
                return -1;
              return 8812; /* vec_cmpv2hfdi_exec */

            case E_V2SImode:
              if (!gcn_alu_operand (operands[2], E_V2SImode)
                  || !gcn_vop3_operand (operands[3], E_V2SImode))
                return -1;
              return 8813; /* vec_cmpv2sidi_exec */

            case E_V2SFmode:
              if (!gcn_alu_operand (operands[2], E_V2SFmode)
                  || !gcn_vop3_operand (operands[3], E_V2SFmode))
                return -1;
              return 8814; /* vec_cmpv2sfdi_exec */

            case E_V2DImode:
              if (!gcn_alu_operand (operands[2], E_V2DImode)
                  || !gcn_vop3_operand (operands[3], E_V2DImode))
                return -1;
              return 8815; /* vec_cmpv2didi_exec */

            case E_V2DFmode:
              if (!gcn_alu_operand (operands[2], E_V2DFmode)
                  || !gcn_vop3_operand (operands[3], E_V2DFmode))
                return -1;
              return 8816; /* vec_cmpv2dfdi_exec */

            case E_V4HImode:
              if (!gcn_alu_operand (operands[2], E_V4HImode)
                  || !gcn_vop3_operand (operands[3], E_V4HImode))
                return -1;
              return 8817; /* vec_cmpv4hidi_exec */

            case E_V4HFmode:
              if (!gcn_alu_operand (operands[2], E_V4HFmode)
                  || !gcn_vop3_operand (operands[3], E_V4HFmode))
                return -1;
              return 8818; /* vec_cmpv4hfdi_exec */

            case E_V4SImode:
              if (!gcn_alu_operand (operands[2], E_V4SImode)
                  || !gcn_vop3_operand (operands[3], E_V4SImode))
                return -1;
              return 8819; /* vec_cmpv4sidi_exec */

            case E_V4SFmode:
              if (!gcn_alu_operand (operands[2], E_V4SFmode)
                  || !gcn_vop3_operand (operands[3], E_V4SFmode))
                return -1;
              return 8820; /* vec_cmpv4sfdi_exec */

            case E_V4DImode:
              if (!gcn_alu_operand (operands[2], E_V4DImode)
                  || !gcn_vop3_operand (operands[3], E_V4DImode))
                return -1;
              return 8821; /* vec_cmpv4didi_exec */

            case E_V4DFmode:
              if (!gcn_alu_operand (operands[2], E_V4DFmode)
                  || !gcn_vop3_operand (operands[3], E_V4DFmode))
                return -1;
              return 8822; /* vec_cmpv4dfdi_exec */

            case E_V8HImode:
              if (!gcn_alu_operand (operands[2], E_V8HImode)
                  || !gcn_vop3_operand (operands[3], E_V8HImode))
                return -1;
              return 8823; /* vec_cmpv8hidi_exec */

            case E_V8HFmode:
              if (!gcn_alu_operand (operands[2], E_V8HFmode)
                  || !gcn_vop3_operand (operands[3], E_V8HFmode))
                return -1;
              return 8824; /* vec_cmpv8hfdi_exec */

            case E_V8SImode:
              if (!gcn_alu_operand (operands[2], E_V8SImode)
                  || !gcn_vop3_operand (operands[3], E_V8SImode))
                return -1;
              return 8825; /* vec_cmpv8sidi_exec */

            case E_V8SFmode:
              if (!gcn_alu_operand (operands[2], E_V8SFmode)
                  || !gcn_vop3_operand (operands[3], E_V8SFmode))
                return -1;
              return 8826; /* vec_cmpv8sfdi_exec */

            case E_V8DImode:
              if (!gcn_alu_operand (operands[2], E_V8DImode)
                  || !gcn_vop3_operand (operands[3], E_V8DImode))
                return -1;
              return 8827; /* vec_cmpv8didi_exec */

            case E_V8DFmode:
              if (!gcn_alu_operand (operands[2], E_V8DFmode)
                  || !gcn_vop3_operand (operands[3], E_V8DFmode))
                return -1;
              return 8828; /* vec_cmpv8dfdi_exec */

            case E_V16HImode:
              if (!gcn_alu_operand (operands[2], E_V16HImode)
                  || !gcn_vop3_operand (operands[3], E_V16HImode))
                return -1;
              return 8829; /* vec_cmpv16hidi_exec */

            case E_V16HFmode:
              if (!gcn_alu_operand (operands[2], E_V16HFmode)
                  || !gcn_vop3_operand (operands[3], E_V16HFmode))
                return -1;
              return 8830; /* vec_cmpv16hfdi_exec */

            case E_V16SImode:
              if (!gcn_alu_operand (operands[2], E_V16SImode)
                  || !gcn_vop3_operand (operands[3], E_V16SImode))
                return -1;
              return 8831; /* vec_cmpv16sidi_exec */

            case E_V16SFmode:
              if (!gcn_alu_operand (operands[2], E_V16SFmode)
                  || !gcn_vop3_operand (operands[3], E_V16SFmode))
                return -1;
              return 8832; /* vec_cmpv16sfdi_exec */

            case E_V16DImode:
              if (!gcn_alu_operand (operands[2], E_V16DImode)
                  || !gcn_vop3_operand (operands[3], E_V16DImode))
                return -1;
              return 8833; /* vec_cmpv16didi_exec */

            case E_V16DFmode:
              if (!gcn_alu_operand (operands[2], E_V16DFmode)
                  || !gcn_vop3_operand (operands[3], E_V16DFmode))
                return -1;
              return 8834; /* vec_cmpv16dfdi_exec */

            case E_V32HImode:
              if (!gcn_alu_operand (operands[2], E_V32HImode)
                  || !gcn_vop3_operand (operands[3], E_V32HImode))
                return -1;
              return 8835; /* vec_cmpv32hidi_exec */

            case E_V32HFmode:
              if (!gcn_alu_operand (operands[2], E_V32HFmode)
                  || !gcn_vop3_operand (operands[3], E_V32HFmode))
                return -1;
              return 8836; /* vec_cmpv32hfdi_exec */

            case E_V32SImode:
              if (!gcn_alu_operand (operands[2], E_V32SImode)
                  || !gcn_vop3_operand (operands[3], E_V32SImode))
                return -1;
              return 8837; /* vec_cmpv32sidi_exec */

            case E_V32SFmode:
              if (!gcn_alu_operand (operands[2], E_V32SFmode)
                  || !gcn_vop3_operand (operands[3], E_V32SFmode))
                return -1;
              return 8838; /* vec_cmpv32sfdi_exec */

            case E_V32DImode:
              if (!gcn_alu_operand (operands[2], E_V32DImode)
                  || !gcn_vop3_operand (operands[3], E_V32DImode))
                return -1;
              return 8839; /* vec_cmpv32didi_exec */

            case E_V32DFmode:
              if (!gcn_alu_operand (operands[2], E_V32DFmode)
                  || !gcn_vop3_operand (operands[3], E_V32DFmode))
                return -1;
              return 8840; /* vec_cmpv32dfdi_exec */

            case E_V64HImode:
              if (!gcn_alu_operand (operands[2], E_V64HImode)
                  || !gcn_vop3_operand (operands[3], E_V64HImode))
                return -1;
              return 8841; /* vec_cmpv64hidi_exec */

            case E_V64HFmode:
              if (!gcn_alu_operand (operands[2], E_V64HFmode)
                  || !gcn_vop3_operand (operands[3], E_V64HFmode))
                return -1;
              return 8842; /* vec_cmpv64hfdi_exec */

            case E_V64SImode:
              if (!gcn_alu_operand (operands[2], E_V64SImode)
                  || !gcn_vop3_operand (operands[3], E_V64SImode))
                return -1;
              return 8843; /* vec_cmpv64sidi_exec */

            case E_V64SFmode:
              if (!gcn_alu_operand (operands[2], E_V64SFmode)
                  || !gcn_vop3_operand (operands[3], E_V64SFmode))
                return -1;
              return 8844; /* vec_cmpv64sfdi_exec */

            case E_V64DImode:
              if (!gcn_alu_operand (operands[2], E_V64DImode)
                  || !gcn_vop3_operand (operands[3], E_V64DImode))
                return -1;
              return 8845; /* vec_cmpv64didi_exec */

            case E_V64DFmode:
              if (!gcn_alu_operand (operands[2], E_V64DFmode)
                  || !gcn_vop3_operand (operands[3], E_V64DFmode))
                return -1;
              return 8846; /* vec_cmpv64dfdi_exec */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          switch (GET_MODE (x9))
            {
            case E_V2HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V2HImode))
                return -1;
              return 8883; /* vec_cmpv2hidi_dup_exec */

            case E_V2HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V2HFmode))
                return -1;
              return 8884; /* vec_cmpv2hfdi_dup_exec */

            case E_V2SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V2SImode))
                return -1;
              return 8885; /* vec_cmpv2sidi_dup_exec */

            case E_V2SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V2SFmode))
                return -1;
              return 8886; /* vec_cmpv2sfdi_dup_exec */

            case E_V2DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V2DImode))
                return -1;
              return 8887; /* vec_cmpv2didi_dup_exec */

            case E_V2DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V2DFmode))
                return -1;
              return 8888; /* vec_cmpv2dfdi_dup_exec */

            case E_V4HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V4HImode))
                return -1;
              return 8889; /* vec_cmpv4hidi_dup_exec */

            case E_V4HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V4HFmode))
                return -1;
              return 8890; /* vec_cmpv4hfdi_dup_exec */

            case E_V4SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V4SImode))
                return -1;
              return 8891; /* vec_cmpv4sidi_dup_exec */

            case E_V4SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V4SFmode))
                return -1;
              return 8892; /* vec_cmpv4sfdi_dup_exec */

            case E_V4DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V4DImode))
                return -1;
              return 8893; /* vec_cmpv4didi_dup_exec */

            case E_V4DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V4DFmode))
                return -1;
              return 8894; /* vec_cmpv4dfdi_dup_exec */

            case E_V8HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V8HImode))
                return -1;
              return 8895; /* vec_cmpv8hidi_dup_exec */

            case E_V8HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V8HFmode))
                return -1;
              return 8896; /* vec_cmpv8hfdi_dup_exec */

            case E_V8SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V8SImode))
                return -1;
              return 8897; /* vec_cmpv8sidi_dup_exec */

            case E_V8SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V8SFmode))
                return -1;
              return 8898; /* vec_cmpv8sfdi_dup_exec */

            case E_V8DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V8DImode))
                return -1;
              return 8899; /* vec_cmpv8didi_dup_exec */

            case E_V8DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V8DFmode))
                return -1;
              return 8900; /* vec_cmpv8dfdi_dup_exec */

            case E_V16HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V16HImode))
                return -1;
              return 8901; /* vec_cmpv16hidi_dup_exec */

            case E_V16HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V16HFmode))
                return -1;
              return 8902; /* vec_cmpv16hfdi_dup_exec */

            case E_V16SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V16SImode))
                return -1;
              return 8903; /* vec_cmpv16sidi_dup_exec */

            case E_V16SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V16SFmode))
                return -1;
              return 8904; /* vec_cmpv16sfdi_dup_exec */

            case E_V16DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V16DImode))
                return -1;
              return 8905; /* vec_cmpv16didi_dup_exec */

            case E_V16DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V16DFmode))
                return -1;
              return 8906; /* vec_cmpv16dfdi_dup_exec */

            case E_V32HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V32HImode))
                return -1;
              return 8907; /* vec_cmpv32hidi_dup_exec */

            case E_V32HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V32HFmode))
                return -1;
              return 8908; /* vec_cmpv32hfdi_dup_exec */

            case E_V32SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V32SImode))
                return -1;
              return 8909; /* vec_cmpv32sidi_dup_exec */

            case E_V32SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V32SFmode))
                return -1;
              return 8910; /* vec_cmpv32sfdi_dup_exec */

            case E_V32DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V32DImode))
                return -1;
              return 8911; /* vec_cmpv32didi_dup_exec */

            case E_V32DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V32DFmode))
                return -1;
              return 8912; /* vec_cmpv32dfdi_dup_exec */

            case E_V64HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V64HImode))
                return -1;
              return 8913; /* vec_cmpv64hidi_dup_exec */

            case E_V64HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V64HFmode))
                return -1;
              return 8914; /* vec_cmpv64hfdi_dup_exec */

            case E_V64SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V64SImode))
                return -1;
              return 8915; /* vec_cmpv64sidi_dup_exec */

            case E_V64SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V64SFmode))
                return -1;
              return 8916; /* vec_cmpv64sfdi_dup_exec */

            case E_V64DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V64DImode))
                return -1;
              return 8917; /* vec_cmpv64didi_dup_exec */

            case E_V64DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V64DFmode))
                return -1;
              return 8918; /* vec_cmpv64dfdi_dup_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32DFmode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32DFmode)
      && general_operand (operands[1], E_V32DFmode))
    return gen_split_61 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32DFmode)
      || !memory_operand (operands[1], E_V32DFmode))
    return NULL;
  return gen_split_157 (insn, operands);
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32SImode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32SImode)
      && general_operand (operands[1], E_V32SImode))
    return gen_split_58 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32SImode)
      || !memory_operand (operands[1], E_V32SImode))
    return NULL;
  return gen_split_154 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64TImode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64TImode)
      && general_operand (operands[1], E_V64TImode))
    return gen_split_118 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64TImode)
      || !memory_operand (operands[1], E_V64TImode))
    return NULL;
  return gen_split_214 (insn, operands);
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64HFmode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64HFmode)
      && general_operand (operands[1], E_V64HFmode))
    return gen_split_113 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64HFmode)
      || !memory_operand (operands[1], E_V64HFmode))
    return NULL;
  return gen_split_209 (insn, operands);
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32DImode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32DImode)
      && general_operand (operands[1], E_V32DImode))
    return gen_split_108 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32DImode)
      || !memory_operand (operands[1], E_V32DImode))
    return NULL;
  return gen_split_204 (insn, operands);
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 2);
  operands[3] = x7;
  x8 = XEXP (x5, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (GET_MODE (x3) != E_V2QImode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2QImode)
          && general_operand (operands[1], E_V2QImode))
        return gen_split_71 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !memory_operand (operands[1], E_V2QImode))
        return NULL;
      return gen_split_167 (insn, operands);

    case E_V2HImode:
      if (GET_MODE (x3) != E_V2HImode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2HImode)
          && general_operand (operands[1], E_V2HImode))
        return gen_split_72 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !memory_operand (operands[1], E_V2HImode))
        return NULL;
      return gen_split_168 (insn, operands);

    case E_V2HFmode:
      if (GET_MODE (x3) != E_V2HFmode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2HFmode)
          && general_operand (operands[1], E_V2HFmode))
        return gen_split_73 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2HFmode)
          || !memory_operand (operands[1], E_V2HFmode))
        return NULL;
      return gen_split_169 (insn, operands);

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode))
        return gen_split_74 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !memory_operand (operands[1], E_V2SImode))
        return NULL;
      return gen_split_170 (insn, operands);

    case E_V2SFmode:
      if (GET_MODE (x3) != E_V2SFmode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2SFmode)
          && general_operand (operands[1], E_V2SFmode))
        return gen_split_75 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !memory_operand (operands[1], E_V2SFmode))
        return NULL;
      return gen_split_171 (insn, operands);

    case E_V2DImode:
      if (GET_MODE (x3) != E_V2DImode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        return gen_split_76 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return NULL;
      return gen_split_172 (insn, operands);

    case E_V2DFmode:
      if (GET_MODE (x3) != E_V2DFmode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        return gen_split_77 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return NULL;
      return gen_split_173 (insn, operands);

    case E_V2TImode:
      if (GET_MODE (x3) != E_V2TImode
          || !scratch_operand (operands[4], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2TImode)
          && general_operand (operands[1], E_V2TImode))
        return gen_split_78 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !memory_operand (operands[1], E_V2TImode))
        return NULL;
      return gen_split_174 (insn, operands);

    case E_V4QImode:
      if (GET_MODE (x3) != E_V4QImode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4QImode)
          && general_operand (operands[1], E_V4QImode))
        return gen_split_79 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !memory_operand (operands[1], E_V4QImode))
        return NULL;
      return gen_split_175 (insn, operands);

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode))
        return gen_split_80 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !memory_operand (operands[1], E_V4HImode))
        return NULL;
      return gen_split_176 (insn, operands);

    case E_V4HFmode:
      if (GET_MODE (x3) != E_V4HFmode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4HFmode)
          && general_operand (operands[1], E_V4HFmode))
        return gen_split_81 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !memory_operand (operands[1], E_V4HFmode))
        return NULL;
      return gen_split_177 (insn, operands);

    case E_V4SImode:
      if (GET_MODE (x3) != E_V4SImode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        return gen_split_82 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return NULL;
      return gen_split_178 (insn, operands);

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        return gen_split_83 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return NULL;
      return gen_split_179 (insn, operands);

    case E_V4DImode:
      if (GET_MODE (x3) != E_V4DImode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4DImode)
          && general_operand (operands[1], E_V4DImode))
        return gen_split_84 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4DImode)
          || !memory_operand (operands[1], E_V4DImode))
        return NULL;
      return gen_split_180 (insn, operands);

    case E_V4DFmode:
      if (GET_MODE (x3) != E_V4DFmode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4DFmode)
          && general_operand (operands[1], E_V4DFmode))
        return gen_split_85 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !memory_operand (operands[1], E_V4DFmode))
        return NULL;
      return gen_split_181 (insn, operands);

    case E_V4TImode:
      if (GET_MODE (x3) != E_V4TImode
          || !scratch_operand (operands[4], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4TImode)
          && general_operand (operands[1], E_V4TImode))
        return gen_split_86 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4TImode)
          || !memory_operand (operands[1], E_V4TImode))
        return NULL;
      return gen_split_182 (insn, operands);

    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8QImode)
          && general_operand (operands[1], E_V8QImode))
        return gen_split_87 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !memory_operand (operands[1], E_V8QImode))
        return NULL;
      return gen_split_183 (insn, operands);

    case E_V8HImode:
      if (GET_MODE (x3) != E_V8HImode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        return gen_split_88 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return NULL;
      return gen_split_184 (insn, operands);

    case E_V8HFmode:
      if (GET_MODE (x3) != E_V8HFmode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8HFmode)
          && general_operand (operands[1], E_V8HFmode))
        return gen_split_89 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !memory_operand (operands[1], E_V8HFmode))
        return NULL;
      return gen_split_185 (insn, operands);

    case E_V8SImode:
      if (GET_MODE (x3) != E_V8SImode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8SImode)
          && general_operand (operands[1], E_V8SImode))
        return gen_split_90 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || !memory_operand (operands[1], E_V8SImode))
        return NULL;
      return gen_split_186 (insn, operands);

    case E_V8SFmode:
      if (GET_MODE (x3) != E_V8SFmode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8SFmode)
          && general_operand (operands[1], E_V8SFmode))
        return gen_split_91 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !memory_operand (operands[1], E_V8SFmode))
        return NULL;
      return gen_split_187 (insn, operands);

    case E_V8DImode:
      if (GET_MODE (x3) != E_V8DImode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8DImode)
          && general_operand (operands[1], E_V8DImode))
        return gen_split_92 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8DImode)
          || !memory_operand (operands[1], E_V8DImode))
        return NULL;
      return gen_split_188 (insn, operands);

    case E_V8DFmode:
      if (GET_MODE (x3) != E_V8DFmode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8DFmode)
          && general_operand (operands[1], E_V8DFmode))
        return gen_split_93 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !memory_operand (operands[1], E_V8DFmode))
        return NULL;
      return gen_split_189 (insn, operands);

    case E_V8TImode:
      if (GET_MODE (x3) != E_V8TImode
          || !scratch_operand (operands[4], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8TImode)
          && general_operand (operands[1], E_V8TImode))
        return gen_split_94 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8TImode)
          || !memory_operand (operands[1], E_V8TImode))
        return NULL;
      return gen_split_190 (insn, operands);

    case E_V16QImode:
      if (GET_MODE (x3) != E_V16QImode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        return gen_split_95 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return NULL;
      return gen_split_191 (insn, operands);

    case E_V16HImode:
      if (GET_MODE (x3) != E_V16HImode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16HImode)
          && general_operand (operands[1], E_V16HImode))
        return gen_split_96 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || !memory_operand (operands[1], E_V16HImode))
        return NULL;
      return gen_split_192 (insn, operands);

    case E_V16HFmode:
      if (GET_MODE (x3) != E_V16HFmode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16HFmode)
          && general_operand (operands[1], E_V16HFmode))
        return gen_split_97 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !memory_operand (operands[1], E_V16HFmode))
        return NULL;
      return gen_split_193 (insn, operands);

    case E_V16SImode:
      if (GET_MODE (x3) != E_V16SImode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16SImode)
          && general_operand (operands[1], E_V16SImode))
        return gen_split_98 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16SImode)
          || !memory_operand (operands[1], E_V16SImode))
        return NULL;
      return gen_split_194 (insn, operands);

    case E_V16SFmode:
      if (GET_MODE (x3) != E_V16SFmode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16SFmode)
          && general_operand (operands[1], E_V16SFmode))
        return gen_split_99 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !memory_operand (operands[1], E_V16SFmode))
        return NULL;
      return gen_split_195 (insn, operands);

    case E_V16DImode:
      if (GET_MODE (x3) != E_V16DImode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16DImode)
          && general_operand (operands[1], E_V16DImode))
        return gen_split_100 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16DImode)
          || !memory_operand (operands[1], E_V16DImode))
        return NULL;
      return gen_split_196 (insn, operands);

    case E_V16DFmode:
      if (GET_MODE (x3) != E_V16DFmode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16DFmode)
          && general_operand (operands[1], E_V16DFmode))
        return gen_split_101 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16DFmode)
          || !memory_operand (operands[1], E_V16DFmode))
        return NULL;
      return gen_split_197 (insn, operands);

    case E_V16TImode:
      if (GET_MODE (x3) != E_V16TImode
          || !scratch_operand (operands[4], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16TImode)
          && general_operand (operands[1], E_V16TImode))
        return gen_split_102 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16TImode)
          || !memory_operand (operands[1], E_V16TImode))
        return NULL;
      return gen_split_198 (insn, operands);

    case E_V32QImode:
      if (GET_MODE (x3) != E_V32QImode
          || !scratch_operand (operands[4], E_V32DImode))
        return NULL;
      if (memory_operand (operands[0], E_V32QImode)
          && general_operand (operands[1], E_V32QImode))
        return gen_split_103 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || !memory_operand (operands[1], E_V32QImode))
        return NULL;
      return gen_split_199 (insn, operands);

    case E_V32HImode:
      return split_33 (x1, insn);

    case E_V32HFmode:
      return split_32 (x1, insn);

    case E_V32SImode:
      return split_31 (x1, insn);

    case E_V32SFmode:
      return split_30 (x1, insn);

    case E_V32DImode:
      return split_29 (x1, insn);

    case E_V32DFmode:
      return split_28 (x1, insn);

    case E_V32TImode:
      return split_27 (x1, insn);

    case E_V64QImode:
      return split_26 (x1, insn);

    case E_V64HImode:
      return split_25 (x1, insn);

    case E_V64HFmode:
      return split_24 (x1, insn);

    case E_V64SImode:
      return split_23 (x1, insn);

    case E_V64SFmode:
      return split_22 (x1, insn);

    case E_V64DImode:
      return split_21 (x1, insn);

    case E_V64DFmode:
      return split_20 (x1, insn);

    case E_V64TImode:
      return split_19 (x1, insn);

    default:
      return NULL;
    }
}
