/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gcn_valu_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_valu_src0_operand (operands[1], i1)
      || !gcn_valu_src1com_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!gcn_alu_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!gcn_alu_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!gcn_alu_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!gcn_alu_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!gcn_alu_operand (operands[1], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!gcn_alu_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!gcn_alu_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V32SFmode:
      if (!gcn_alu_operand (operands[1], E_V32SFmode))
        return -1;
      return 1;

    case E_V32DFmode:
      if (!gcn_alu_operand (operands[1], E_V32DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16DImode)
      || GET_MODE (x1) != E_V16DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern27 (x1); /* [-1, 2] */

    case E_V4DImode:
      res = pattern28 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V8DImode:
      res = pattern29 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V16DImode:
      res = pattern30 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V32DImode:
      res = pattern31 (x1);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_V64DImode:
      res = pattern32 (x1);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern39 (x1, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern39 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern39 (x1, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16SImode:
      if (pattern39 (x1, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32SImode:
      if (pattern39 (x1, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64SImode:
      if (pattern39 (x1, 
E_V64SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_V4DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V4DImode) != 0)
        return -1;
      return 7;

    case E_V8DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V8DImode) != 0)
        return -1;
      return 8;

    case E_V16DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V16DImode) != 0)
        return -1;
      return 9;

    case E_V32DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V32DImode) != 0)
        return -1;
      return 10;

    case E_V64DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V64DImode) != 0)
        return -1;
      return 11;

    case E_V2HFmode:
      if (pattern44 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 12;

    case E_V2SFmode:
      if (pattern44 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 13;

    case E_V2DFmode:
      if (pattern44 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 14;

    case E_V4HFmode:
      if (pattern44 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern44 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V4DFmode:
      if (pattern44 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern44 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V8SFmode:
      if (pattern44 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 19;

    case E_V8DFmode:
      if (pattern44 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 20;

    case E_V16HFmode:
      if (pattern44 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 21;

    case E_V16SFmode:
      if (pattern44 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 22;

    case E_V16DFmode:
      if (pattern44 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 23;

    case E_V32HFmode:
      if (pattern44 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 24;

    case E_V32SFmode:
      if (pattern44 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 25;

    case E_V32DFmode:
      if (pattern44 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 26;

    case E_V64HFmode:
      if (pattern44 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 27;

    case E_V64SFmode:
      if (pattern44 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 28;

    case E_V64DFmode:
      if (pattern44 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !gcn_alu_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !gcn_alu_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER
      || !register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gcn_alu_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!gcn_alu_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_BImode))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 5;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 6;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 7;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 8;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 9;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 10;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 11;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 12;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 13;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 14;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 15;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 16;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 17;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 18;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x1) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 19;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 20;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 21;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 22;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 23;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x1) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 24;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 25;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 26;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 27;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 28;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x1) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      return 0;

    case E_V2HImode:
      return 1;

    case E_V2SImode:
      return 2;

    case E_V4QImode:
      return 3;

    case E_V4HImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V8QImode:
      return 6;

    case E_V8HImode:
      return 7;

    case E_V8SImode:
      return 8;

    case E_V16QImode:
      return 9;

    case E_V16HImode:
      return 10;

    case E_V16SImode:
      return 11;

    case E_V32QImode:
      return 12;

    case E_V32HImode:
      return 13;

    case E_V32SImode:
      return 14;

    case E_V64QImode:
      return 15;

    case E_V64HImode:
      return 16;

    case E_V64SImode:
      return 17;

    case E_V32DImode:
      return 18;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_BImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern164 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i2)
      || !gcn_register_or_unspec_operand (operands[3], i2)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern176 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i2)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || !memory_operand (operands[1], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !general_operand (operands[1], i2)
      || !gcn_alu_or_unspec_operand (operands[2], i2)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V32DImode)
        return -1;
      return 0;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V32SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  return pattern222 (x2, 
i2, 
i3); /* [-1, 0] */
}

int
pattern226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  return pattern222 (x2, 
E_V8DImode, 
E_V8SImode); /* [-1, 0] */
}

int
pattern235 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i3))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2
      || !gcn_register_or_unspec_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_BImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_BImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!nonimmediate_operand (operands[0], E_BImode)
          || !gcn_load_operand (operands[1], E_BImode))
        return -1;
      return 3; /* *movbi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !gcn_load_operand (operands[1], E_SImode))
        return -1;
      return 4; /* *movsi_insn */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !gcn_load_operand (operands[1], E_SFmode))
        return -1;
      return 5; /* *movsf_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !gcn_load_operand (operands[1], E_QImode)
          || !
#line 608 "../../gcc/config/gcn/gcn.md"
(gcn_valid_move_p (QImode, operands[0], operands[1])))
        return -1;
      return 6; /* *movqi_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !gcn_load_operand (operands[1], E_HImode)
          || !
#line 608 "../../gcc/config/gcn/gcn.md"
(gcn_valid_move_p (HImode, operands[0], operands[1])))
        return -1;
      return 7; /* *movhi_insn */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 641 "../../gcc/config/gcn/gcn.md"
(GET_CODE(operands[1]) != SYMBOL_REF))
        return 8; /* *movdi_insn */
      if (pnum_clobbers == NULL)
        return -1;
      if (
#line 912 "../../gcc/config/gcn/gcn.md"
(GET_CODE (operands[1]) == SYMBOL_REF || GET_CODE (operands[1]) == LABEL_REF))
        {
          *pnum_clobbers = 1;
          return 17; /* movdi_symbol */
        }
      if (!
#line 935 "../../gcc/config/gcn/gcn.md"
((GET_CODE (operands[1]) == SYMBOL_REF || GET_CODE (operands[1]) == LABEL_REF)
  && (lra_in_progress || reload_completed)))
        return -1;
      *pnum_clobbers = 1;
      return 18; /* movdi_symbol_save_scc */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 641 "../../gcc/config/gcn/gcn.md"
(GET_CODE(operands[1]) != SYMBOL_REF))
        return -1;
      return 9; /* *movdf_insn */

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode))
        return -1;
      return 10; /* *movti_insn */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      return 141; /* *movv2qi */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode))
        return -1;
      return 142; /* *movv2hi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode))
        return -1;
      return 143; /* *movv2si */

    case E_V2HFmode:
      if (!nonimmediate_operand (operands[0], E_V2HFmode)
          || !general_operand (operands[1], E_V2HFmode))
        return -1;
      return 144; /* *movv2hf */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode))
        return -1;
      return 145; /* *movv2sf */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode))
        return -1;
      return 146; /* *movv4qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode))
        return -1;
      return 147; /* *movv4hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      return 148; /* *movv4si */

    case E_V4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !general_operand (operands[1], E_V4HFmode))
        return -1;
      return 149; /* *movv4hf */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      return 150; /* *movv4sf */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode))
        return -1;
      return 151; /* *movv8qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      return 152; /* *movv8hi */

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || !general_operand (operands[1], E_V8SImode))
        return -1;
      return 153; /* *movv8si */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !general_operand (operands[1], E_V8HFmode))
        return -1;
      return 154; /* *movv8hf */

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !general_operand (operands[1], E_V8SFmode))
        return -1;
      return 155; /* *movv8sf */

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      return 156; /* *movv16qi */

    case E_V16HImode:
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || !general_operand (operands[1], E_V16HImode))
        return -1;
      return 157; /* *movv16hi */

    case E_V16SImode:
      if (!nonimmediate_operand (operands[0], E_V16SImode)
          || !general_operand (operands[1], E_V16SImode))
        return -1;
      return 158; /* *movv16si */

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !general_operand (operands[1], E_V16HFmode))
        return -1;
      return 159; /* *movv16hf */

    case E_V16SFmode:
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !general_operand (operands[1], E_V16SFmode))
        return -1;
      return 160; /* *movv16sf */

    case E_V32QImode:
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || !general_operand (operands[1], E_V32QImode))
        return -1;
      return 161; /* *movv32qi */

    case E_V32HImode:
      if (!nonimmediate_operand (operands[0], E_V32HImode)
          || !general_operand (operands[1], E_V32HImode))
        return -1;
      return 162; /* *movv32hi */

    case E_V32SImode:
      if (!nonimmediate_operand (operands[0], E_V32SImode)
          || !general_operand (operands[1], E_V32SImode))
        return -1;
      return 163; /* *movv32si */

    case E_V32HFmode:
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !general_operand (operands[1], E_V32HFmode))
        return -1;
      return 164; /* *movv32hf */

    case E_V32SFmode:
      if (!nonimmediate_operand (operands[0], E_V32SFmode)
          || !general_operand (operands[1], E_V32SFmode))
        return -1;
      return 165; /* *movv32sf */

    case E_V64QImode:
      if (!nonimmediate_operand (operands[0], E_V64QImode)
          || !general_operand (operands[1], E_V64QImode))
        return -1;
      return 166; /* *movv64qi */

    case E_V64HImode:
      if (!nonimmediate_operand (operands[0], E_V64HImode)
          || !general_operand (operands[1], E_V64HImode))
        return -1;
      return 167; /* *movv64hi */

    case E_V64SImode:
      if (!nonimmediate_operand (operands[0], E_V64SImode)
          || !general_operand (operands[1], E_V64SImode))
        return -1;
      return 168; /* *movv64si */

    case E_V64HFmode:
      if (!nonimmediate_operand (operands[0], E_V64HFmode)
          || !general_operand (operands[1], E_V64HFmode))
        return -1;
      return 169; /* *movv64hf */

    case E_V64SFmode:
      if (!nonimmediate_operand (operands[0], E_V64SFmode)
          || !general_operand (operands[1], E_V64SFmode))
        return -1;
      return 170; /* *movv64sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      return 201; /* *movv2di */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode))
        return -1;
      return 202; /* *movv2df */

    case E_V4DImode:
      if (!nonimmediate_operand (operands[0], E_V4DImode)
          || !general_operand (operands[1], E_V4DImode))
        return -1;
      return 203; /* *movv4di */

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !general_operand (operands[1], E_V4DFmode))
        return -1;
      return 204; /* *movv4df */

    case E_V8DImode:
      if (!nonimmediate_operand (operands[0], E_V8DImode)
          || !general_operand (operands[1], E_V8DImode))
        return -1;
      return 205; /* *movv8di */

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !general_operand (operands[1], E_V8DFmode))
        return -1;
      return 206; /* *movv8df */

    case E_V16DImode:
      if (!nonimmediate_operand (operands[0], E_V16DImode)
          || !general_operand (operands[1], E_V16DImode))
        return -1;
      return 207; /* *movv16di */

    case E_V16DFmode:
      if (!nonimmediate_operand (operands[0], E_V16DFmode)
          || !general_operand (operands[1], E_V16DFmode))
        return -1;
      return 208; /* *movv16df */

    case E_V32DImode:
      if (!nonimmediate_operand (operands[0], E_V32DImode)
          || !general_operand (operands[1], E_V32DImode))
        return -1;
      return 209; /* *movv32di */

    case E_V32DFmode:
      if (!nonimmediate_operand (operands[0], E_V32DFmode)
          || !general_operand (operands[1], E_V32DFmode))
        return -1;
      return 210; /* *movv32df */

    case E_V64DImode:
      if (!nonimmediate_operand (operands[0], E_V64DImode)
          || !general_operand (operands[1], E_V64DImode))
        return -1;
      return 211; /* *movv64di */

    case E_V64DFmode:
      if (!nonimmediate_operand (operands[0], E_V64DFmode)
          || !general_operand (operands[1], E_V64DFmode))
        return -1;
      return 212; /* *movv64df */

    case E_V2TImode:
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !general_operand (operands[1], E_V2TImode))
        return -1;
      return 225; /* *movv2ti_4reg */

    case E_V4TImode:
      if (!nonimmediate_operand (operands[0], E_V4TImode)
          || !general_operand (operands[1], E_V4TImode))
        return -1;
      return 226; /* *movv4ti_4reg */

    case E_V8TImode:
      if (!nonimmediate_operand (operands[0], E_V8TImode)
          || !general_operand (operands[1], E_V8TImode))
        return -1;
      return 227; /* *movv8ti_4reg */

    case E_V16TImode:
      if (!nonimmediate_operand (operands[0], E_V16TImode)
          || !general_operand (operands[1], E_V16TImode))
        return -1;
      return 228; /* *movv16ti_4reg */

    case E_V32TImode:
      if (!nonimmediate_operand (operands[0], E_V32TImode)
          || !general_operand (operands[1], E_V32TImode))
        return -1;
      return 229; /* *movv32ti_4reg */

    case E_V64TImode:
      if (!nonimmediate_operand (operands[0], E_V64TImode)
          || !general_operand (operands[1], E_V64TImode))
        return -1;
      return 230; /* *movv64ti_4reg */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern98 (x2, 
E_V32SImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5787; /* *truncv2qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8235; /* *truncv2qiv32si_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5791; /* *truncv2hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8241; /* *truncv2hiv32si_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5795; /* *truncv2siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8247; /* *truncv2siv32si_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5799; /* *truncv4qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8253; /* *truncv4qiv32si_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5803; /* *truncv4hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8259; /* *truncv4hiv32si_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5807; /* *truncv4siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8265; /* *truncv4siv32si_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5811; /* *truncv8qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8271; /* *truncv8qiv32si_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5815; /* *truncv8hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8277; /* *truncv8hiv32si_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5819; /* *truncv8siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8283; /* *truncv8siv32si_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5823; /* *truncv16qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8289; /* *truncv16qiv32si_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5827; /* *truncv16hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8295; /* *truncv16hiv32si_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5831; /* *truncv16siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8301; /* *truncv16siv32si_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5835; /* *truncv32qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8307; /* *truncv32qiv32si_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5839; /* *truncv32hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8313; /* *truncv32hiv32si_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5843; /* *truncv32siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8319; /* *truncv32siv32si_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5847; /* *truncv64qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8325; /* *truncv64qiv32si_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5851; /* *truncv64hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8331; /* *truncv64hiv32si_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5855; /* *truncv64siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8337; /* *truncv64siv32si_shift */

    case 18:
      return 8681; /* truncv32div32si2 */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern97 (x2, 
E_V16HImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5499; /* *truncv2qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7803; /* *truncv2qiv16hi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5503; /* *truncv2hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7809; /* *truncv2hiv16hi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5507; /* *truncv2siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7815; /* *truncv2siv16hi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5511; /* *truncv4qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7821; /* *truncv4qiv16hi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5515; /* *truncv4hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7827; /* *truncv4hiv16hi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5519; /* *truncv4siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7833; /* *truncv4siv16hi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5523; /* *truncv8qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7839; /* *truncv8qiv16hi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5527; /* *truncv8hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7845; /* *truncv8hiv16hi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5531; /* *truncv8siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7851; /* *truncv8siv16hi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5535; /* *truncv16qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7857; /* *truncv16qiv16hi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5539; /* *truncv16hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7863; /* *truncv16hiv16hi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5543; /* *truncv16siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7869; /* *truncv16siv16hi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5547; /* *truncv32qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7875; /* *truncv32qiv16hi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5551; /* *truncv32hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7881; /* *truncv32hiv16hi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5555; /* *truncv32siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7887; /* *truncv32siv16hi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5559; /* *truncv64qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7893; /* *truncv64qiv16hi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5563; /* *truncv64hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7899; /* *truncv64hiv16hi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5567; /* *truncv64siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7905; /* *truncv64siv16hi_shift */

    case 18:
      return 8677; /* truncv16div16hi2 */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern96 (x2, 
E_V8QImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5211; /* *truncv2qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7371; /* *truncv2qiv8qi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5215; /* *truncv2hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7377; /* *truncv2hiv8qi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5219; /* *truncv2siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7383; /* *truncv2siv8qi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5223; /* *truncv4qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7389; /* *truncv4qiv8qi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5227; /* *truncv4hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7395; /* *truncv4hiv8qi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5231; /* *truncv4siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7401; /* *truncv4siv8qi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5235; /* *truncv8qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7407; /* *truncv8qiv8qi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5239; /* *truncv8hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7413; /* *truncv8hiv8qi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5243; /* *truncv8siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7419; /* *truncv8siv8qi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5247; /* *truncv16qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7425; /* *truncv16qiv8qi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5251; /* *truncv16hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7431; /* *truncv16hiv8qi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5255; /* *truncv16siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7437; /* *truncv16siv8qi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5259; /* *truncv32qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7443; /* *truncv32qiv8qi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5263; /* *truncv32hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7449; /* *truncv32hiv8qi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5267; /* *truncv32siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7455; /* *truncv32siv8qi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5271; /* *truncv64qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7461; /* *truncv64qiv8qi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5275; /* *truncv64hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7467; /* *truncv64hiv8qi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5279; /* *truncv64siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7473; /* *truncv64siv8qi_shift */

    case 18:
      return 8673; /* truncv8div8qi2 */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  switch (XINT (x3, 1))
    {
    case 29:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 2539; /* floorv2hf2_exec */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 2543; /* floorv2sf2_exec */

        case E_V2DFmode:
          if (pattern166 (x2, 
E_V2DFmode) != 0)
            return -1;
          return 2547; /* floorv2df2_exec */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 2551; /* floorv4hf2_exec */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0)
            return -1;
          return 2555; /* floorv4sf2_exec */

        case E_V4DFmode:
          if (pattern166 (x2, 
E_V4DFmode) != 0)
            return -1;
          return 2559; /* floorv4df2_exec */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0)
            return -1;
          return 2563; /* floorv8hf2_exec */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0)
            return -1;
          return 2567; /* floorv8sf2_exec */

        case E_V8DFmode:
          if (pattern166 (x2, 
E_V8DFmode) != 0)
            return -1;
          return 2571; /* floorv8df2_exec */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0)
            return -1;
          return 2575; /* floorv16hf2_exec */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0)
            return -1;
          return 2579; /* floorv16sf2_exec */

        case E_V16DFmode:
          if (pattern166 (x2, 
E_V16DFmode) != 0)
            return -1;
          return 2583; /* floorv16df2_exec */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0)
            return -1;
          return 2587; /* floorv32hf2_exec */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0)
            return -1;
          return 2591; /* floorv32sf2_exec */

        case E_V32DFmode:
          if (pattern166 (x2, 
E_V32DFmode) != 0)
            return -1;
          return 2595; /* floorv32df2_exec */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0)
            return -1;
          return 2599; /* floorv64hf2_exec */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0)
            return -1;
          return 2603; /* floorv64sf2_exec */

        case E_V64DFmode:
          if (pattern166 (x2, 
E_V64DFmode) != 0)
            return -1;
          return 2607; /* floorv64df2_exec */

        default:
          return -1;
        }

    case 30:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 2541; /* ceilv2hf2_exec */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 2545; /* ceilv2sf2_exec */

        case E_V2DFmode:
          if (pattern166 (x2, 
E_V2DFmode) != 0)
            return -1;
          return 2549; /* ceilv2df2_exec */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 2553; /* ceilv4hf2_exec */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0)
            return -1;
          return 2557; /* ceilv4sf2_exec */

        case E_V4DFmode:
          if (pattern166 (x2, 
E_V4DFmode) != 0)
            return -1;
          return 2561; /* ceilv4df2_exec */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0)
            return -1;
          return 2565; /* ceilv8hf2_exec */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0)
            return -1;
          return 2569; /* ceilv8sf2_exec */

        case E_V8DFmode:
          if (pattern166 (x2, 
E_V8DFmode) != 0)
            return -1;
          return 2573; /* ceilv8df2_exec */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0)
            return -1;
          return 2577; /* ceilv16hf2_exec */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0)
            return -1;
          return 2581; /* ceilv16sf2_exec */

        case E_V16DFmode:
          if (pattern166 (x2, 
E_V16DFmode) != 0)
            return -1;
          return 2585; /* ceilv16df2_exec */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0)
            return -1;
          return 2589; /* ceilv32hf2_exec */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0)
            return -1;
          return 2593; /* ceilv32sf2_exec */

        case E_V32DFmode:
          if (pattern166 (x2, 
E_V32DFmode) != 0)
            return -1;
          return 2597; /* ceilv32df2_exec */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0)
            return -1;
          return 2601; /* ceilv64hf2_exec */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0)
            return -1;
          return 2605; /* ceilv64sf2_exec */

        case E_V64DFmode:
          if (pattern166 (x2, 
E_V64DFmode) != 0)
            return -1;
          return 2609; /* ceilv64df2_exec */

        default:
          return -1;
        }

    case 33:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2615; /* exp2v2hf2_exec */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2619; /* exp2v2sf2_exec */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2623; /* exp2v4hf2_exec */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2627; /* exp2v4sf2_exec */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2631; /* exp2v8hf2_exec */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2635; /* exp2v8sf2_exec */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2639; /* exp2v16hf2_exec */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2643; /* exp2v16sf2_exec */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2647; /* exp2v32hf2_exec */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2651; /* exp2v32sf2_exec */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2655; /* exp2v64hf2_exec */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2659; /* exp2v64sf2_exec */

        default:
          return -1;
        }

    case 34:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2617; /* log2v2hf2_exec */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2621; /* log2v2sf2_exec */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2625; /* log2v4hf2_exec */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2629; /* log2v4sf2_exec */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2633; /* log2v8hf2_exec */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2637; /* log2v8sf2_exec */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2641; /* log2v16hf2_exec */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2645; /* log2v16sf2_exec */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2649; /* log2v32hf2_exec */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2653; /* log2v32sf2_exec */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2657; /* log2v64hf2_exec */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0
              || !
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2661; /* log2v64sf2_exec */

        default:
          return -1;
        }

    case 31:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2667; /* *sinv2hf2_exec_insn */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2671; /* *sinv2sf2_exec_insn */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2675; /* *sinv4hf2_exec_insn */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2679; /* *sinv4sf2_exec_insn */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2683; /* *sinv8hf2_exec_insn */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2687; /* *sinv8sf2_exec_insn */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2691; /* *sinv16hf2_exec_insn */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2695; /* *sinv16sf2_exec_insn */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2699; /* *sinv32hf2_exec_insn */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2703; /* *sinv32sf2_exec_insn */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2707; /* *sinv64hf2_exec_insn */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2711; /* *sinv64sf2_exec_insn */

        default:
          return -1;
        }

    case 32:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2669; /* *cosv2hf2_exec_insn */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2673; /* *cosv2sf2_exec_insn */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2677; /* *cosv4hf2_exec_insn */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2681; /* *cosv4sf2_exec_insn */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2685; /* *cosv8hf2_exec_insn */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2689; /* *cosv8sf2_exec_insn */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2693; /* *cosv16hf2_exec_insn */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2697; /* *cosv16sf2_exec_insn */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2701; /* *cosv32hf2_exec_insn */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2705; /* *cosv32sf2_exec_insn */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2709; /* *cosv64hf2_exec_insn */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0
              || !
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2713; /* *cosv64sf2_exec_insn */

        default:
          return -1;
        }

    case 36:
      return recog_30 (x1, insn, pnum_clobbers);

    case 37:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 2796; /* frexpv2hf_mant2_exec */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 2798; /* frexpv2sf_mant2_exec */

        case E_V2DFmode:
          if (pattern166 (x2, 
E_V2DFmode) != 0)
            return -1;
          return 2800; /* frexpv2df_mant2_exec */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 2802; /* frexpv4hf_mant2_exec */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0)
            return -1;
          return 2804; /* frexpv4sf_mant2_exec */

        case E_V4DFmode:
          if (pattern166 (x2, 
E_V4DFmode) != 0)
            return -1;
          return 2806; /* frexpv4df_mant2_exec */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0)
            return -1;
          return 2808; /* frexpv8hf_mant2_exec */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0)
            return -1;
          return 2810; /* frexpv8sf_mant2_exec */

        case E_V8DFmode:
          if (pattern166 (x2, 
E_V8DFmode) != 0)
            return -1;
          return 2812; /* frexpv8df_mant2_exec */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0)
            return -1;
          return 2814; /* frexpv16hf_mant2_exec */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0)
            return -1;
          return 2816; /* frexpv16sf_mant2_exec */

        case E_V16DFmode:
          if (pattern166 (x2, 
E_V16DFmode) != 0)
            return -1;
          return 2818; /* frexpv16df_mant2_exec */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0)
            return -1;
          return 2820; /* frexpv32hf_mant2_exec */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0)
            return -1;
          return 2822; /* frexpv32sf_mant2_exec */

        case E_V32DFmode:
          if (pattern166 (x2, 
E_V32DFmode) != 0)
            return -1;
          return 2824; /* frexpv32df_mant2_exec */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0)
            return -1;
          return 2826; /* frexpv64hf_mant2_exec */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0)
            return -1;
          return 2828; /* frexpv64sf_mant2_exec */

        case E_V64DFmode:
          if (pattern166 (x2, 
E_V64DFmode) != 0)
            return -1;
          return 2830; /* frexpv64df_mant2_exec */

        default:
          return -1;
        }

    case 27:
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern166 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 2991; /* recipv2hf2_exec */

        case E_V2SFmode:
          if (pattern166 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 2993; /* recipv2sf2_exec */

        case E_V2DFmode:
          if (pattern166 (x2, 
E_V2DFmode) != 0)
            return -1;
          return 2995; /* recipv2df2_exec */

        case E_V4HFmode:
          if (pattern166 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 2997; /* recipv4hf2_exec */

        case E_V4SFmode:
          if (pattern166 (x2, 
E_V4SFmode) != 0)
            return -1;
          return 2999; /* recipv4sf2_exec */

        case E_V4DFmode:
          if (pattern166 (x2, 
E_V4DFmode) != 0)
            return -1;
          return 3001; /* recipv4df2_exec */

        case E_V8HFmode:
          if (pattern166 (x2, 
E_V8HFmode) != 0)
            return -1;
          return 3003; /* recipv8hf2_exec */

        case E_V8SFmode:
          if (pattern166 (x2, 
E_V8SFmode) != 0)
            return -1;
          return 3005; /* recipv8sf2_exec */

        case E_V8DFmode:
          if (pattern166 (x2, 
E_V8DFmode) != 0)
            return -1;
          return 3007; /* recipv8df2_exec */

        case E_V16HFmode:
          if (pattern166 (x2, 
E_V16HFmode) != 0)
            return -1;
          return 3009; /* recipv16hf2_exec */

        case E_V16SFmode:
          if (pattern166 (x2, 
E_V16SFmode) != 0)
            return -1;
          return 3011; /* recipv16sf2_exec */

        case E_V16DFmode:
          if (pattern166 (x2, 
E_V16DFmode) != 0)
            return -1;
          return 3013; /* recipv16df2_exec */

        case E_V32HFmode:
          if (pattern166 (x2, 
E_V32HFmode) != 0)
            return -1;
          return 3015; /* recipv32hf2_exec */

        case E_V32SFmode:
          if (pattern166 (x2, 
E_V32SFmode) != 0)
            return -1;
          return 3017; /* recipv32sf2_exec */

        case E_V32DFmode:
          if (pattern166 (x2, 
E_V32DFmode) != 0)
            return -1;
          return 3019; /* recipv32df2_exec */

        case E_V64HFmode:
          if (pattern166 (x2, 
E_V64HFmode) != 0)
            return -1;
          return 3021; /* recipv64hf2_exec */

        case E_V64SFmode:
          if (pattern166 (x2, 
E_V64SFmode) != 0)
            return -1;
          return 3023; /* recipv64sf2_exec */

        case E_V64DFmode:
          if (pattern166 (x2, 
E_V64DFmode) != 0)
            return -1;
          return 3025; /* recipv64df2_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern71 (x2))
    {
    case 0:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6076; /* extendv2qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6728; /* *extendv2qiv2qi_shift_exec */

    case 1:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6078; /* extendv2hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6734; /* *extendv2hiv2qi_shift_exec */

    case 2:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6080; /* extendv2siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6740; /* *extendv2siv2qi_shift_exec */

    case 3:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6082; /* extendv4qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6746; /* *extendv4qiv2qi_shift_exec */

    case 4:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6084; /* extendv4hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6752; /* *extendv4hiv2qi_shift_exec */

    case 5:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6086; /* extendv4siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6758; /* *extendv4siv2qi_shift_exec */

    case 6:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6088; /* extendv8qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6764; /* *extendv8qiv2qi_shift_exec */

    case 7:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6090; /* extendv8hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6770; /* *extendv8hiv2qi_shift_exec */

    case 8:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6092; /* extendv8siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6776; /* *extendv8siv2qi_shift_exec */

    case 9:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6094; /* extendv16qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6782; /* *extendv16qiv2qi_shift_exec */

    case 10:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6096; /* extendv16hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6788; /* *extendv16hiv2qi_shift_exec */

    case 11:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6098; /* extendv16siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6794; /* *extendv16siv2qi_shift_exec */

    case 12:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6100; /* extendv32qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6800; /* *extendv32qiv2qi_shift_exec */

    case 13:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6102; /* extendv32hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6806; /* *extendv32hiv2qi_shift_exec */

    case 14:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6104; /* extendv32siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6812; /* *extendv32siv2qi_shift_exec */

    case 15:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6106; /* extendv64qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6818; /* *extendv64qiv2qi_shift_exec */

    case 16:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6108; /* extendv64hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6824; /* *extendv64hiv2qi_shift_exec */

    case 17:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6110; /* extendv64siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6830; /* *extendv64siv2qi_shift_exec */

    case 18:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6112; /* extendv2qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6836; /* *extendv2qiv2hi_shift_exec */

    case 19:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6114; /* extendv2hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6842; /* *extendv2hiv2hi_shift_exec */

    case 20:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6116; /* extendv2siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6848; /* *extendv2siv2hi_shift_exec */

    case 21:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6118; /* extendv4qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6854; /* *extendv4qiv2hi_shift_exec */

    case 22:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6120; /* extendv4hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6860; /* *extendv4hiv2hi_shift_exec */

    case 23:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6122; /* extendv4siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6866; /* *extendv4siv2hi_shift_exec */

    case 24:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6124; /* extendv8qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6872; /* *extendv8qiv2hi_shift_exec */

    case 25:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6126; /* extendv8hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6878; /* *extendv8hiv2hi_shift_exec */

    case 26:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6128; /* extendv8siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6884; /* *extendv8siv2hi_shift_exec */

    case 27:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6130; /* extendv16qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6890; /* *extendv16qiv2hi_shift_exec */

    case 28:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6132; /* extendv16hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6896; /* *extendv16hiv2hi_shift_exec */

    case 29:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6134; /* extendv16siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6902; /* *extendv16siv2hi_shift_exec */

    case 30:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6136; /* extendv32qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6908; /* *extendv32qiv2hi_shift_exec */

    case 31:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6138; /* extendv32hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6914; /* *extendv32hiv2hi_shift_exec */

    case 32:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6140; /* extendv32siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6920; /* *extendv32siv2hi_shift_exec */

    case 33:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6142; /* extendv64qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6926; /* *extendv64qiv2hi_shift_exec */

    case 34:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6144; /* extendv64hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6932; /* *extendv64hiv2hi_shift_exec */

    case 35:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6146; /* extendv64siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6938; /* *extendv64siv2hi_shift_exec */

    case 36:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6148; /* extendv2qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6944; /* *extendv2qiv2si_shift_exec */

    case 37:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6150; /* extendv2hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6950; /* *extendv2hiv2si_shift_exec */

    case 38:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6152; /* extendv2siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6956; /* *extendv2siv2si_shift_exec */

    case 39:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6154; /* extendv4qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6962; /* *extendv4qiv2si_shift_exec */

    case 40:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6156; /* extendv4hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6968; /* *extendv4hiv2si_shift_exec */

    case 41:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6158; /* extendv4siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6974; /* *extendv4siv2si_shift_exec */

    case 42:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6160; /* extendv8qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6980; /* *extendv8qiv2si_shift_exec */

    case 43:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6162; /* extendv8hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6986; /* *extendv8hiv2si_shift_exec */

    case 44:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6164; /* extendv8siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6992; /* *extendv8siv2si_shift_exec */

    case 45:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6166; /* extendv16qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6998; /* *extendv16qiv2si_shift_exec */

    case 46:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6168; /* extendv16hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7004; /* *extendv16hiv2si_shift_exec */

    case 47:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6170; /* extendv16siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7010; /* *extendv16siv2si_shift_exec */

    case 48:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6172; /* extendv32qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7016; /* *extendv32qiv2si_shift_exec */

    case 49:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6174; /* extendv32hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7022; /* *extendv32hiv2si_shift_exec */

    case 50:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6176; /* extendv32siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7028; /* *extendv32siv2si_shift_exec */

    case 51:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6178; /* extendv64qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7034; /* *extendv64qiv2si_shift_exec */

    case 52:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6180; /* extendv64hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7040; /* *extendv64hiv2si_shift_exec */

    case 53:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6182; /* extendv64siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7046; /* *extendv64siv2si_shift_exec */

    case 54:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6184; /* extendv2qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7052; /* *extendv2qiv4qi_shift_exec */

    case 55:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6186; /* extendv2hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7058; /* *extendv2hiv4qi_shift_exec */

    case 56:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6188; /* extendv2siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7064; /* *extendv2siv4qi_shift_exec */

    case 57:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6190; /* extendv4qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7070; /* *extendv4qiv4qi_shift_exec */

    case 58:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6192; /* extendv4hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7076; /* *extendv4hiv4qi_shift_exec */

    case 59:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6194; /* extendv4siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7082; /* *extendv4siv4qi_shift_exec */

    case 60:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6196; /* extendv8qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7088; /* *extendv8qiv4qi_shift_exec */

    case 61:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6198; /* extendv8hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7094; /* *extendv8hiv4qi_shift_exec */

    case 62:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6200; /* extendv8siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7100; /* *extendv8siv4qi_shift_exec */

    case 63:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6202; /* extendv16qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7106; /* *extendv16qiv4qi_shift_exec */

    case 64:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6204; /* extendv16hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7112; /* *extendv16hiv4qi_shift_exec */

    case 65:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6206; /* extendv16siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7118; /* *extendv16siv4qi_shift_exec */

    case 66:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6208; /* extendv32qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7124; /* *extendv32qiv4qi_shift_exec */

    case 67:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6210; /* extendv32hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7130; /* *extendv32hiv4qi_shift_exec */

    case 68:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6212; /* extendv32siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7136; /* *extendv32siv4qi_shift_exec */

    case 69:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6214; /* extendv64qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7142; /* *extendv64qiv4qi_shift_exec */

    case 70:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6216; /* extendv64hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7148; /* *extendv64hiv4qi_shift_exec */

    case 71:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6218; /* extendv64siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7154; /* *extendv64siv4qi_shift_exec */

    case 72:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6220; /* extendv2qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7160; /* *extendv2qiv4hi_shift_exec */

    case 73:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6222; /* extendv2hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7166; /* *extendv2hiv4hi_shift_exec */

    case 74:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6224; /* extendv2siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7172; /* *extendv2siv4hi_shift_exec */

    case 75:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6226; /* extendv4qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7178; /* *extendv4qiv4hi_shift_exec */

    case 76:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6228; /* extendv4hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7184; /* *extendv4hiv4hi_shift_exec */

    case 77:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6230; /* extendv4siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7190; /* *extendv4siv4hi_shift_exec */

    case 78:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6232; /* extendv8qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7196; /* *extendv8qiv4hi_shift_exec */

    case 79:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6234; /* extendv8hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7202; /* *extendv8hiv4hi_shift_exec */

    case 80:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6236; /* extendv8siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7208; /* *extendv8siv4hi_shift_exec */

    case 81:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6238; /* extendv16qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7214; /* *extendv16qiv4hi_shift_exec */

    case 82:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6240; /* extendv16hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7220; /* *extendv16hiv4hi_shift_exec */

    case 83:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6242; /* extendv16siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7226; /* *extendv16siv4hi_shift_exec */

    case 84:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6244; /* extendv32qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7232; /* *extendv32qiv4hi_shift_exec */

    case 85:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6246; /* extendv32hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7238; /* *extendv32hiv4hi_shift_exec */

    case 86:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6248; /* extendv32siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7244; /* *extendv32siv4hi_shift_exec */

    case 87:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6250; /* extendv64qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7250; /* *extendv64qiv4hi_shift_exec */

    case 88:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6252; /* extendv64hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7256; /* *extendv64hiv4hi_shift_exec */

    case 89:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6254; /* extendv64siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7262; /* *extendv64siv4hi_shift_exec */

    case 90:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6256; /* extendv2qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7268; /* *extendv2qiv4si_shift_exec */

    case 91:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6258; /* extendv2hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7274; /* *extendv2hiv4si_shift_exec */

    case 92:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6260; /* extendv2siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7280; /* *extendv2siv4si_shift_exec */

    case 93:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6262; /* extendv4qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7286; /* *extendv4qiv4si_shift_exec */

    case 94:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6264; /* extendv4hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7292; /* *extendv4hiv4si_shift_exec */

    case 95:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6266; /* extendv4siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7298; /* *extendv4siv4si_shift_exec */

    case 96:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6268; /* extendv8qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7304; /* *extendv8qiv4si_shift_exec */

    case 97:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6270; /* extendv8hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7310; /* *extendv8hiv4si_shift_exec */

    case 98:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6272; /* extendv8siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7316; /* *extendv8siv4si_shift_exec */

    case 99:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6274; /* extendv16qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7322; /* *extendv16qiv4si_shift_exec */

    case 100:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6276; /* extendv16hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7328; /* *extendv16hiv4si_shift_exec */

    case 101:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6278; /* extendv16siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7334; /* *extendv16siv4si_shift_exec */

    case 102:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6280; /* extendv32qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7340; /* *extendv32qiv4si_shift_exec */

    case 103:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6282; /* extendv32hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7346; /* *extendv32hiv4si_shift_exec */

    case 104:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6284; /* extendv32siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7352; /* *extendv32siv4si_shift_exec */

    case 105:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6286; /* extendv64qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7358; /* *extendv64qiv4si_shift_exec */

    case 106:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6288; /* extendv64hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7364; /* *extendv64hiv4si_shift_exec */

    case 107:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6290; /* extendv64siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7370; /* *extendv64siv4si_shift_exec */

    case 108:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6292; /* extendv2qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7376; /* *extendv2qiv8qi_shift_exec */

    case 109:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6294; /* extendv2hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7382; /* *extendv2hiv8qi_shift_exec */

    case 110:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6296; /* extendv2siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7388; /* *extendv2siv8qi_shift_exec */

    case 111:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6298; /* extendv4qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7394; /* *extendv4qiv8qi_shift_exec */

    case 112:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6300; /* extendv4hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7400; /* *extendv4hiv8qi_shift_exec */

    case 113:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6302; /* extendv4siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7406; /* *extendv4siv8qi_shift_exec */

    case 114:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6304; /* extendv8qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7412; /* *extendv8qiv8qi_shift_exec */

    case 115:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6306; /* extendv8hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7418; /* *extendv8hiv8qi_shift_exec */

    case 116:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6308; /* extendv8siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7424; /* *extendv8siv8qi_shift_exec */

    case 117:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6310; /* extendv16qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7430; /* *extendv16qiv8qi_shift_exec */

    case 118:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6312; /* extendv16hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7436; /* *extendv16hiv8qi_shift_exec */

    case 119:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6314; /* extendv16siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7442; /* *extendv16siv8qi_shift_exec */

    case 120:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6316; /* extendv32qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7448; /* *extendv32qiv8qi_shift_exec */

    case 121:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6318; /* extendv32hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7454; /* *extendv32hiv8qi_shift_exec */

    case 122:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6320; /* extendv32siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7460; /* *extendv32siv8qi_shift_exec */

    case 123:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6322; /* extendv64qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7466; /* *extendv64qiv8qi_shift_exec */

    case 124:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6324; /* extendv64hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7472; /* *extendv64hiv8qi_shift_exec */

    case 125:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6326; /* extendv64siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7478; /* *extendv64siv8qi_shift_exec */

    case 126:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6328; /* extendv2qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7484; /* *extendv2qiv8hi_shift_exec */

    case 127:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6330; /* extendv2hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7490; /* *extendv2hiv8hi_shift_exec */

    case 128:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6332; /* extendv2siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7496; /* *extendv2siv8hi_shift_exec */

    case 129:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6334; /* extendv4qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7502; /* *extendv4qiv8hi_shift_exec */

    case 130:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6336; /* extendv4hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7508; /* *extendv4hiv8hi_shift_exec */

    case 131:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6338; /* extendv4siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7514; /* *extendv4siv8hi_shift_exec */

    case 132:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6340; /* extendv8qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7520; /* *extendv8qiv8hi_shift_exec */

    case 133:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6342; /* extendv8hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7526; /* *extendv8hiv8hi_shift_exec */

    case 134:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6344; /* extendv8siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7532; /* *extendv8siv8hi_shift_exec */

    case 135:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6346; /* extendv16qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7538; /* *extendv16qiv8hi_shift_exec */

    case 136:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6348; /* extendv16hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7544; /* *extendv16hiv8hi_shift_exec */

    case 137:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6350; /* extendv16siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7550; /* *extendv16siv8hi_shift_exec */

    case 138:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6352; /* extendv32qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7556; /* *extendv32qiv8hi_shift_exec */

    case 139:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6354; /* extendv32hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7562; /* *extendv32hiv8hi_shift_exec */

    case 140:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6356; /* extendv32siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7568; /* *extendv32siv8hi_shift_exec */

    case 141:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6358; /* extendv64qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7574; /* *extendv64qiv8hi_shift_exec */

    case 142:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6360; /* extendv64hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7580; /* *extendv64hiv8hi_shift_exec */

    case 143:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6362; /* extendv64siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7586; /* *extendv64siv8hi_shift_exec */

    case 144:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6364; /* extendv2qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7592; /* *extendv2qiv8si_shift_exec */

    case 145:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6366; /* extendv2hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7598; /* *extendv2hiv8si_shift_exec */

    case 146:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6368; /* extendv2siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7604; /* *extendv2siv8si_shift_exec */

    case 147:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6370; /* extendv4qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7610; /* *extendv4qiv8si_shift_exec */

    case 148:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6372; /* extendv4hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7616; /* *extendv4hiv8si_shift_exec */

    case 149:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6374; /* extendv4siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7622; /* *extendv4siv8si_shift_exec */

    case 150:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6376; /* extendv8qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7628; /* *extendv8qiv8si_shift_exec */

    case 151:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6378; /* extendv8hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7634; /* *extendv8hiv8si_shift_exec */

    case 152:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6380; /* extendv8siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7640; /* *extendv8siv8si_shift_exec */

    case 153:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6382; /* extendv16qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7646; /* *extendv16qiv8si_shift_exec */

    case 154:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6384; /* extendv16hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7652; /* *extendv16hiv8si_shift_exec */

    case 155:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6386; /* extendv16siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7658; /* *extendv16siv8si_shift_exec */

    case 156:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6388; /* extendv32qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7664; /* *extendv32qiv8si_shift_exec */

    case 157:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6390; /* extendv32hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7670; /* *extendv32hiv8si_shift_exec */

    case 158:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6392; /* extendv32siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7676; /* *extendv32siv8si_shift_exec */

    case 159:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6394; /* extendv64qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7682; /* *extendv64qiv8si_shift_exec */

    case 160:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6396; /* extendv64hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7688; /* *extendv64hiv8si_shift_exec */

    case 161:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6398; /* extendv64siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7694; /* *extendv64siv8si_shift_exec */

    case 162:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6400; /* extendv2qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7700; /* *extendv2qiv16qi_shift_exec */

    case 163:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6402; /* extendv2hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7706; /* *extendv2hiv16qi_shift_exec */

    case 164:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6404; /* extendv2siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7712; /* *extendv2siv16qi_shift_exec */

    case 165:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6406; /* extendv4qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7718; /* *extendv4qiv16qi_shift_exec */

    case 166:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6408; /* extendv4hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7724; /* *extendv4hiv16qi_shift_exec */

    case 167:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6410; /* extendv4siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7730; /* *extendv4siv16qi_shift_exec */

    case 168:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6412; /* extendv8qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7736; /* *extendv8qiv16qi_shift_exec */

    case 169:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6414; /* extendv8hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7742; /* *extendv8hiv16qi_shift_exec */

    case 170:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6416; /* extendv8siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7748; /* *extendv8siv16qi_shift_exec */

    case 171:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6418; /* extendv16qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7754; /* *extendv16qiv16qi_shift_exec */

    case 172:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6420; /* extendv16hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7760; /* *extendv16hiv16qi_shift_exec */

    case 173:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6422; /* extendv16siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7766; /* *extendv16siv16qi_shift_exec */

    case 174:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6424; /* extendv32qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7772; /* *extendv32qiv16qi_shift_exec */

    case 175:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6426; /* extendv32hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7778; /* *extendv32hiv16qi_shift_exec */

    case 176:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6428; /* extendv32siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7784; /* *extendv32siv16qi_shift_exec */

    case 177:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6430; /* extendv64qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7790; /* *extendv64qiv16qi_shift_exec */

    case 178:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6432; /* extendv64hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7796; /* *extendv64hiv16qi_shift_exec */

    case 179:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6434; /* extendv64siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7802; /* *extendv64siv16qi_shift_exec */

    case 180:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6436; /* extendv2qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7808; /* *extendv2qiv16hi_shift_exec */

    case 181:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6438; /* extendv2hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7814; /* *extendv2hiv16hi_shift_exec */

    case 182:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6440; /* extendv2siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7820; /* *extendv2siv16hi_shift_exec */

    case 183:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6442; /* extendv4qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7826; /* *extendv4qiv16hi_shift_exec */

    case 184:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6444; /* extendv4hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7832; /* *extendv4hiv16hi_shift_exec */

    case 185:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6446; /* extendv4siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7838; /* *extendv4siv16hi_shift_exec */

    case 186:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6448; /* extendv8qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7844; /* *extendv8qiv16hi_shift_exec */

    case 187:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6450; /* extendv8hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7850; /* *extendv8hiv16hi_shift_exec */

    case 188:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6452; /* extendv8siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7856; /* *extendv8siv16hi_shift_exec */

    case 189:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6454; /* extendv16qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7862; /* *extendv16qiv16hi_shift_exec */

    case 190:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6456; /* extendv16hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7868; /* *extendv16hiv16hi_shift_exec */

    case 191:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6458; /* extendv16siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7874; /* *extendv16siv16hi_shift_exec */

    case 192:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6460; /* extendv32qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7880; /* *extendv32qiv16hi_shift_exec */

    case 193:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6462; /* extendv32hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7886; /* *extendv32hiv16hi_shift_exec */

    case 194:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6464; /* extendv32siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7892; /* *extendv32siv16hi_shift_exec */

    case 195:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6466; /* extendv64qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7898; /* *extendv64qiv16hi_shift_exec */

    case 196:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6468; /* extendv64hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7904; /* *extendv64hiv16hi_shift_exec */

    case 197:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6470; /* extendv64siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7910; /* *extendv64siv16hi_shift_exec */

    case 198:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6472; /* extendv2qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7916; /* *extendv2qiv16si_shift_exec */

    case 199:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6474; /* extendv2hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7922; /* *extendv2hiv16si_shift_exec */

    case 200:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6476; /* extendv2siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7928; /* *extendv2siv16si_shift_exec */

    case 201:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6478; /* extendv4qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7934; /* *extendv4qiv16si_shift_exec */

    case 202:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6480; /* extendv4hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7940; /* *extendv4hiv16si_shift_exec */

    case 203:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6482; /* extendv4siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7946; /* *extendv4siv16si_shift_exec */

    case 204:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6484; /* extendv8qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7952; /* *extendv8qiv16si_shift_exec */

    case 205:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6486; /* extendv8hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7958; /* *extendv8hiv16si_shift_exec */

    case 206:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6488; /* extendv8siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7964; /* *extendv8siv16si_shift_exec */

    case 207:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6490; /* extendv16qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7970; /* *extendv16qiv16si_shift_exec */

    case 208:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6492; /* extendv16hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7976; /* *extendv16hiv16si_shift_exec */

    case 209:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6494; /* extendv16siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7982; /* *extendv16siv16si_shift_exec */

    case 210:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6496; /* extendv32qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7988; /* *extendv32qiv16si_shift_exec */

    case 211:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6498; /* extendv32hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7994; /* *extendv32hiv16si_shift_exec */

    case 212:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6500; /* extendv32siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8000; /* *extendv32siv16si_shift_exec */

    case 213:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6502; /* extendv64qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8006; /* *extendv64qiv16si_shift_exec */

    case 214:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6504; /* extendv64hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8012; /* *extendv64hiv16si_shift_exec */

    case 215:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6506; /* extendv64siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8018; /* *extendv64siv16si_shift_exec */

    case 216:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6508; /* extendv2qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8024; /* *extendv2qiv32qi_shift_exec */

    case 217:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6510; /* extendv2hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8030; /* *extendv2hiv32qi_shift_exec */

    case 218:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6512; /* extendv2siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8036; /* *extendv2siv32qi_shift_exec */

    case 219:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6514; /* extendv4qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8042; /* *extendv4qiv32qi_shift_exec */

    case 220:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6516; /* extendv4hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8048; /* *extendv4hiv32qi_shift_exec */

    case 221:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6518; /* extendv4siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8054; /* *extendv4siv32qi_shift_exec */

    case 222:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6520; /* extendv8qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8060; /* *extendv8qiv32qi_shift_exec */

    case 223:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6522; /* extendv8hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8066; /* *extendv8hiv32qi_shift_exec */

    case 224:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6524; /* extendv8siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8072; /* *extendv8siv32qi_shift_exec */

    case 225:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6526; /* extendv16qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8078; /* *extendv16qiv32qi_shift_exec */

    case 226:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6528; /* extendv16hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8084; /* *extendv16hiv32qi_shift_exec */

    case 227:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6530; /* extendv16siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8090; /* *extendv16siv32qi_shift_exec */

    case 228:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6532; /* extendv32qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8096; /* *extendv32qiv32qi_shift_exec */

    case 229:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6534; /* extendv32hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8102; /* *extendv32hiv32qi_shift_exec */

    case 230:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6536; /* extendv32siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8108; /* *extendv32siv32qi_shift_exec */

    case 231:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6538; /* extendv64qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8114; /* *extendv64qiv32qi_shift_exec */

    case 232:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6540; /* extendv64hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8120; /* *extendv64hiv32qi_shift_exec */

    case 233:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6542; /* extendv64siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8126; /* *extendv64siv32qi_shift_exec */

    case 234:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6544; /* extendv2qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8132; /* *extendv2qiv32hi_shift_exec */

    case 235:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6546; /* extendv2hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8138; /* *extendv2hiv32hi_shift_exec */

    case 236:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6548; /* extendv2siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8144; /* *extendv2siv32hi_shift_exec */

    case 237:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6550; /* extendv4qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8150; /* *extendv4qiv32hi_shift_exec */

    case 238:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6552; /* extendv4hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8156; /* *extendv4hiv32hi_shift_exec */

    case 239:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6554; /* extendv4siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8162; /* *extendv4siv32hi_shift_exec */

    case 240:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6556; /* extendv8qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8168; /* *extendv8qiv32hi_shift_exec */

    case 241:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6558; /* extendv8hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8174; /* *extendv8hiv32hi_shift_exec */

    case 242:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6560; /* extendv8siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8180; /* *extendv8siv32hi_shift_exec */

    case 243:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6562; /* extendv16qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8186; /* *extendv16qiv32hi_shift_exec */

    case 244:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6564; /* extendv16hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8192; /* *extendv16hiv32hi_shift_exec */

    case 245:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6566; /* extendv16siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8198; /* *extendv16siv32hi_shift_exec */

    case 246:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6568; /* extendv32qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8204; /* *extendv32qiv32hi_shift_exec */

    case 247:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6570; /* extendv32hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8210; /* *extendv32hiv32hi_shift_exec */

    case 248:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6572; /* extendv32siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8216; /* *extendv32siv32hi_shift_exec */

    case 249:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6574; /* extendv64qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8222; /* *extendv64qiv32hi_shift_exec */

    case 250:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6576; /* extendv64hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8228; /* *extendv64hiv32hi_shift_exec */

    case 251:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6578; /* extendv64siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8234; /* *extendv64siv32hi_shift_exec */

    case 252:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6580; /* extendv2qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8240; /* *extendv2qiv32si_shift_exec */

    case 253:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6582; /* extendv2hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8246; /* *extendv2hiv32si_shift_exec */

    case 254:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6584; /* extendv2siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8252; /* *extendv2siv32si_shift_exec */

    case 255:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6586; /* extendv4qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8258; /* *extendv4qiv32si_shift_exec */

    case 256:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6588; /* extendv4hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8264; /* *extendv4hiv32si_shift_exec */

    case 257:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6590; /* extendv4siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8270; /* *extendv4siv32si_shift_exec */

    case 258:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6592; /* extendv8qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8276; /* *extendv8qiv32si_shift_exec */

    case 259:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6594; /* extendv8hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8282; /* *extendv8hiv32si_shift_exec */

    case 260:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6596; /* extendv8siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8288; /* *extendv8siv32si_shift_exec */

    case 261:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6598; /* extendv16qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8294; /* *extendv16qiv32si_shift_exec */

    case 262:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6600; /* extendv16hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8300; /* *extendv16hiv32si_shift_exec */

    case 263:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6602; /* extendv16siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8306; /* *extendv16siv32si_shift_exec */

    case 264:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6604; /* extendv32qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8312; /* *extendv32qiv32si_shift_exec */

    case 265:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6606; /* extendv32hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8318; /* *extendv32hiv32si_shift_exec */

    case 266:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6608; /* extendv32siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8324; /* *extendv32siv32si_shift_exec */

    case 267:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6610; /* extendv64qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8330; /* *extendv64qiv32si_shift_exec */

    case 268:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6612; /* extendv64hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8336; /* *extendv64hiv32si_shift_exec */

    case 269:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6614; /* extendv64siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8342; /* *extendv64siv32si_shift_exec */

    case 270:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6616; /* extendv2qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8348; /* *extendv2qiv64qi_shift_exec */

    case 271:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6618; /* extendv2hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8354; /* *extendv2hiv64qi_shift_exec */

    case 272:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6620; /* extendv2siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8360; /* *extendv2siv64qi_shift_exec */

    case 273:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6622; /* extendv4qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8366; /* *extendv4qiv64qi_shift_exec */

    case 274:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6624; /* extendv4hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8372; /* *extendv4hiv64qi_shift_exec */

    case 275:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6626; /* extendv4siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8378; /* *extendv4siv64qi_shift_exec */

    case 276:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6628; /* extendv8qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8384; /* *extendv8qiv64qi_shift_exec */

    case 277:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6630; /* extendv8hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8390; /* *extendv8hiv64qi_shift_exec */

    case 278:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6632; /* extendv8siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8396; /* *extendv8siv64qi_shift_exec */

    case 279:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6634; /* extendv16qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8402; /* *extendv16qiv64qi_shift_exec */

    case 280:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6636; /* extendv16hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8408; /* *extendv16hiv64qi_shift_exec */

    case 281:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6638; /* extendv16siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8414; /* *extendv16siv64qi_shift_exec */

    case 282:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6640; /* extendv32qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8420; /* *extendv32qiv64qi_shift_exec */

    case 283:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6642; /* extendv32hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8426; /* *extendv32hiv64qi_shift_exec */

    case 284:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6644; /* extendv32siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8432; /* *extendv32siv64qi_shift_exec */

    case 285:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6646; /* extendv64qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8438; /* *extendv64qiv64qi_shift_exec */

    case 286:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6648; /* extendv64hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8444; /* *extendv64hiv64qi_shift_exec */

    case 287:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6650; /* extendv64siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8450; /* *extendv64siv64qi_shift_exec */

    case 288:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6652; /* extendv2qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8456; /* *extendv2qiv64hi_shift_exec */

    case 289:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6654; /* extendv2hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8462; /* *extendv2hiv64hi_shift_exec */

    case 290:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6656; /* extendv2siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8468; /* *extendv2siv64hi_shift_exec */

    case 291:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6658; /* extendv4qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8474; /* *extendv4qiv64hi_shift_exec */

    case 292:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6660; /* extendv4hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8480; /* *extendv4hiv64hi_shift_exec */

    case 293:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6662; /* extendv4siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8486; /* *extendv4siv64hi_shift_exec */

    case 294:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6664; /* extendv8qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8492; /* *extendv8qiv64hi_shift_exec */

    case 295:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6666; /* extendv8hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8498; /* *extendv8hiv64hi_shift_exec */

    case 296:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6668; /* extendv8siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8504; /* *extendv8siv64hi_shift_exec */

    case 297:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6670; /* extendv16qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8510; /* *extendv16qiv64hi_shift_exec */

    case 298:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6672; /* extendv16hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8516; /* *extendv16hiv64hi_shift_exec */

    case 299:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6674; /* extendv16siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8522; /* *extendv16siv64hi_shift_exec */

    case 300:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6676; /* extendv32qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8528; /* *extendv32qiv64hi_shift_exec */

    case 301:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6678; /* extendv32hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8534; /* *extendv32hiv64hi_shift_exec */

    case 302:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6680; /* extendv32siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8540; /* *extendv32siv64hi_shift_exec */

    case 303:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6682; /* extendv64qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8546; /* *extendv64qiv64hi_shift_exec */

    case 304:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6684; /* extendv64hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8552; /* *extendv64hiv64hi_shift_exec */

    case 305:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6686; /* extendv64siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8558; /* *extendv64siv64hi_shift_exec */

    case 306:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6688; /* extendv2qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8564; /* *extendv2qiv64si_shift_exec */

    case 307:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6690; /* extendv2hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8570; /* *extendv2hiv64si_shift_exec */

    case 308:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6692; /* extendv2siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8576; /* *extendv2siv64si_shift_exec */

    case 309:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6694; /* extendv4qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8582; /* *extendv4qiv64si_shift_exec */

    case 310:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6696; /* extendv4hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8588; /* *extendv4hiv64si_shift_exec */

    case 311:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6698; /* extendv4siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8594; /* *extendv4siv64si_shift_exec */

    case 312:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6700; /* extendv8qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8600; /* *extendv8qiv64si_shift_exec */

    case 313:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6702; /* extendv8hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8606; /* *extendv8hiv64si_shift_exec */

    case 314:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6704; /* extendv8siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8612; /* *extendv8siv64si_shift_exec */

    case 315:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6706; /* extendv16qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8618; /* *extendv16qiv64si_shift_exec */

    case 316:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6708; /* extendv16hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8624; /* *extendv16hiv64si_shift_exec */

    case 317:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6710; /* extendv16siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8630; /* *extendv16siv64si_shift_exec */

    case 318:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6712; /* extendv32qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8636; /* *extendv32qiv64si_shift_exec */

    case 319:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6714; /* extendv32hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8642; /* *extendv32hiv64si_shift_exec */

    case 320:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6716; /* extendv32siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8648; /* *extendv32siv64si_shift_exec */

    case 321:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6718; /* extendv64qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8654; /* *extendv64qiv64si_shift_exec */

    case 322:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6720; /* extendv64hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8660; /* *extendv64hiv64si_shift_exec */

    case 323:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6722; /* extendv64siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8666; /* *extendv64siv64si_shift_exec */

    case 324:
      return 8739; /* extendv2qiv2di2_exec */

    case 325:
      return 8741; /* extendv2hiv2di2_exec */

    case 326:
      return 8743; /* extendv2siv2di2_exec */

    case 327:
      return 8745; /* extendv4qiv4di2_exec */

    case 328:
      return 8747; /* extendv4hiv4di2_exec */

    case 329:
      return 8749; /* extendv4siv4di2_exec */

    case 330:
      return 8751; /* extendv8qiv8di2_exec */

    case 331:
      return 8753; /* extendv8hiv8di2_exec */

    case 332:
      return 8755; /* extendv8siv8di2_exec */

    case 333:
      return 8757; /* extendv16qiv16di2_exec */

    case 334:
      return 8759; /* extendv16hiv16di2_exec */

    case 335:
      return 8761; /* extendv16siv16di2_exec */

    case 336:
      return 8763; /* extendv32qiv32di2_exec */

    case 337:
      return 8765; /* extendv32hiv32di2_exec */

    case 338:
      return 8767; /* extendv32siv32di2_exec */

    case 339:
      return 8769; /* extendv64qiv64di2_exec */

    case 340:
      return 8771; /* extendv64hiv64di2_exec */

    case 341:
      return 8773; /* extendv64siv64di2_exec */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      switch (pattern3 (x3, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 63; /* andsi3 */

        case 1:
          *pnum_clobbers = 1;
          return 74; /* anddi3 */

        case 2:
          return 1827; /* andv2qi3 */

        case 3:
          return 1833; /* andv2hi3 */

        case 4:
          return 1839; /* andv2si3 */

        case 5:
          return 1845; /* andv4qi3 */

        case 6:
          return 1851; /* andv4hi3 */

        case 7:
          return 1857; /* andv4si3 */

        case 8:
          return 1863; /* andv8qi3 */

        case 9:
          return 1869; /* andv8hi3 */

        case 10:
          return 1875; /* andv8si3 */

        case 11:
          return 1881; /* andv16qi3 */

        case 12:
          return 1887; /* andv16hi3 */

        case 13:
          return 1893; /* andv16si3 */

        case 14:
          return 1899; /* andv32qi3 */

        case 15:
          return 1905; /* andv32hi3 */

        case 16:
          return 1911; /* andv32si3 */

        case 17:
          return 1917; /* andv64qi3 */

        case 18:
          return 1923; /* andv64hi3 */

        case 19:
          return 1929; /* andv64si3 */

        case 20:
          return 1935; /* andv2di3 */

        case 21:
          return 1938; /* andv4di3 */

        case 22:
          return 1941; /* andv8di3 */

        case 23:
          return 1944; /* andv16di3 */

        case 24:
          return 1947; /* andv32di3 */

        case 25:
          return 1950; /* andv64di3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pnum_clobbers == NULL
          || !gcn_fp_compare_operator (operands[1], E_VOIDmode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 1);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      if (!gcn_exec_reg_operand (operands[4], E_DImode))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x7;
          switch (GET_MODE (operands[2]))
            {
            case E_V2HImode:
              if (!gcn_alu_operand (operands[2], E_V2HImode)
                  || !gcn_vop3_operand (operands[3], E_V2HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8811; /* vec_cmpv2hidi_exec */

            case E_V2HFmode:
              if (!gcn_alu_operand (operands[2], E_V2HFmode)
                  || !gcn_vop3_operand (operands[3], E_V2HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8812; /* vec_cmpv2hfdi_exec */

            case E_V2SImode:
              if (!gcn_alu_operand (operands[2], E_V2SImode)
                  || !gcn_vop3_operand (operands[3], E_V2SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8813; /* vec_cmpv2sidi_exec */

            case E_V2SFmode:
              if (!gcn_alu_operand (operands[2], E_V2SFmode)
                  || !gcn_vop3_operand (operands[3], E_V2SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8814; /* vec_cmpv2sfdi_exec */

            case E_V2DImode:
              if (!gcn_alu_operand (operands[2], E_V2DImode)
                  || !gcn_vop3_operand (operands[3], E_V2DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8815; /* vec_cmpv2didi_exec */

            case E_V2DFmode:
              if (!gcn_alu_operand (operands[2], E_V2DFmode)
                  || !gcn_vop3_operand (operands[3], E_V2DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8816; /* vec_cmpv2dfdi_exec */

            case E_V4HImode:
              if (!gcn_alu_operand (operands[2], E_V4HImode)
                  || !gcn_vop3_operand (operands[3], E_V4HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8817; /* vec_cmpv4hidi_exec */

            case E_V4HFmode:
              if (!gcn_alu_operand (operands[2], E_V4HFmode)
                  || !gcn_vop3_operand (operands[3], E_V4HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8818; /* vec_cmpv4hfdi_exec */

            case E_V4SImode:
              if (!gcn_alu_operand (operands[2], E_V4SImode)
                  || !gcn_vop3_operand (operands[3], E_V4SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8819; /* vec_cmpv4sidi_exec */

            case E_V4SFmode:
              if (!gcn_alu_operand (operands[2], E_V4SFmode)
                  || !gcn_vop3_operand (operands[3], E_V4SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8820; /* vec_cmpv4sfdi_exec */

            case E_V4DImode:
              if (!gcn_alu_operand (operands[2], E_V4DImode)
                  || !gcn_vop3_operand (operands[3], E_V4DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8821; /* vec_cmpv4didi_exec */

            case E_V4DFmode:
              if (!gcn_alu_operand (operands[2], E_V4DFmode)
                  || !gcn_vop3_operand (operands[3], E_V4DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8822; /* vec_cmpv4dfdi_exec */

            case E_V8HImode:
              if (!gcn_alu_operand (operands[2], E_V8HImode)
                  || !gcn_vop3_operand (operands[3], E_V8HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8823; /* vec_cmpv8hidi_exec */

            case E_V8HFmode:
              if (!gcn_alu_operand (operands[2], E_V8HFmode)
                  || !gcn_vop3_operand (operands[3], E_V8HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8824; /* vec_cmpv8hfdi_exec */

            case E_V8SImode:
              if (!gcn_alu_operand (operands[2], E_V8SImode)
                  || !gcn_vop3_operand (operands[3], E_V8SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8825; /* vec_cmpv8sidi_exec */

            case E_V8SFmode:
              if (!gcn_alu_operand (operands[2], E_V8SFmode)
                  || !gcn_vop3_operand (operands[3], E_V8SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8826; /* vec_cmpv8sfdi_exec */

            case E_V8DImode:
              if (!gcn_alu_operand (operands[2], E_V8DImode)
                  || !gcn_vop3_operand (operands[3], E_V8DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8827; /* vec_cmpv8didi_exec */

            case E_V8DFmode:
              if (!gcn_alu_operand (operands[2], E_V8DFmode)
                  || !gcn_vop3_operand (operands[3], E_V8DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8828; /* vec_cmpv8dfdi_exec */

            case E_V16HImode:
              if (!gcn_alu_operand (operands[2], E_V16HImode)
                  || !gcn_vop3_operand (operands[3], E_V16HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8829; /* vec_cmpv16hidi_exec */

            case E_V16HFmode:
              if (!gcn_alu_operand (operands[2], E_V16HFmode)
                  || !gcn_vop3_operand (operands[3], E_V16HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8830; /* vec_cmpv16hfdi_exec */

            case E_V16SImode:
              if (!gcn_alu_operand (operands[2], E_V16SImode)
                  || !gcn_vop3_operand (operands[3], E_V16SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8831; /* vec_cmpv16sidi_exec */

            case E_V16SFmode:
              if (!gcn_alu_operand (operands[2], E_V16SFmode)
                  || !gcn_vop3_operand (operands[3], E_V16SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8832; /* vec_cmpv16sfdi_exec */

            case E_V16DImode:
              if (!gcn_alu_operand (operands[2], E_V16DImode)
                  || !gcn_vop3_operand (operands[3], E_V16DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8833; /* vec_cmpv16didi_exec */

            case E_V16DFmode:
              if (!gcn_alu_operand (operands[2], E_V16DFmode)
                  || !gcn_vop3_operand (operands[3], E_V16DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8834; /* vec_cmpv16dfdi_exec */

            case E_V32HImode:
              if (!gcn_alu_operand (operands[2], E_V32HImode)
                  || !gcn_vop3_operand (operands[3], E_V32HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8835; /* vec_cmpv32hidi_exec */

            case E_V32HFmode:
              if (!gcn_alu_operand (operands[2], E_V32HFmode)
                  || !gcn_vop3_operand (operands[3], E_V32HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8836; /* vec_cmpv32hfdi_exec */

            case E_V32SImode:
              if (!gcn_alu_operand (operands[2], E_V32SImode)
                  || !gcn_vop3_operand (operands[3], E_V32SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8837; /* vec_cmpv32sidi_exec */

            case E_V32SFmode:
              if (!gcn_alu_operand (operands[2], E_V32SFmode)
                  || !gcn_vop3_operand (operands[3], E_V32SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8838; /* vec_cmpv32sfdi_exec */

            case E_V32DImode:
              if (!gcn_alu_operand (operands[2], E_V32DImode)
                  || !gcn_vop3_operand (operands[3], E_V32DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8839; /* vec_cmpv32didi_exec */

            case E_V32DFmode:
              if (!gcn_alu_operand (operands[2], E_V32DFmode)
                  || !gcn_vop3_operand (operands[3], E_V32DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8840; /* vec_cmpv32dfdi_exec */

            case E_V64HImode:
              if (!gcn_alu_operand (operands[2], E_V64HImode)
                  || !gcn_vop3_operand (operands[3], E_V64HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8841; /* vec_cmpv64hidi_exec */

            case E_V64HFmode:
              if (!gcn_alu_operand (operands[2], E_V64HFmode)
                  || !gcn_vop3_operand (operands[3], E_V64HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8842; /* vec_cmpv64hfdi_exec */

            case E_V64SImode:
              if (!gcn_alu_operand (operands[2], E_V64SImode)
                  || !gcn_vop3_operand (operands[3], E_V64SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8843; /* vec_cmpv64sidi_exec */

            case E_V64SFmode:
              if (!gcn_alu_operand (operands[2], E_V64SFmode)
                  || !gcn_vop3_operand (operands[3], E_V64SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8844; /* vec_cmpv64sfdi_exec */

            case E_V64DImode:
              if (!gcn_alu_operand (operands[2], E_V64DImode)
                  || !gcn_vop3_operand (operands[3], E_V64DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8845; /* vec_cmpv64didi_exec */

            case E_V64DFmode:
              if (!gcn_alu_operand (operands[2], E_V64DFmode)
                  || !gcn_vop3_operand (operands[3], E_V64DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8846; /* vec_cmpv64dfdi_exec */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          switch (GET_MODE (x7))
            {
            case E_V2HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V2HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8883; /* vec_cmpv2hidi_dup_exec */

            case E_V2HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V2HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8884; /* vec_cmpv2hfdi_dup_exec */

            case E_V2SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V2SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8885; /* vec_cmpv2sidi_dup_exec */

            case E_V2SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V2SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8886; /* vec_cmpv2sfdi_dup_exec */

            case E_V2DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V2DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8887; /* vec_cmpv2didi_dup_exec */

            case E_V2DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V2DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8888; /* vec_cmpv2dfdi_dup_exec */

            case E_V4HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V4HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8889; /* vec_cmpv4hidi_dup_exec */

            case E_V4HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V4HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8890; /* vec_cmpv4hfdi_dup_exec */

            case E_V4SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V4SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8891; /* vec_cmpv4sidi_dup_exec */

            case E_V4SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V4SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8892; /* vec_cmpv4sfdi_dup_exec */

            case E_V4DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V4DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8893; /* vec_cmpv4didi_dup_exec */

            case E_V4DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V4DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8894; /* vec_cmpv4dfdi_dup_exec */

            case E_V8HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V8HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8895; /* vec_cmpv8hidi_dup_exec */

            case E_V8HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V8HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8896; /* vec_cmpv8hfdi_dup_exec */

            case E_V8SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V8SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8897; /* vec_cmpv8sidi_dup_exec */

            case E_V8SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V8SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8898; /* vec_cmpv8sfdi_dup_exec */

            case E_V8DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V8DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8899; /* vec_cmpv8didi_dup_exec */

            case E_V8DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V8DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8900; /* vec_cmpv8dfdi_dup_exec */

            case E_V16HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V16HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8901; /* vec_cmpv16hidi_dup_exec */

            case E_V16HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V16HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8902; /* vec_cmpv16hfdi_dup_exec */

            case E_V16SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V16SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8903; /* vec_cmpv16sidi_dup_exec */

            case E_V16SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V16SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8904; /* vec_cmpv16sfdi_dup_exec */

            case E_V16DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V16DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8905; /* vec_cmpv16didi_dup_exec */

            case E_V16DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V16DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8906; /* vec_cmpv16dfdi_dup_exec */

            case E_V32HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V32HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8907; /* vec_cmpv32hidi_dup_exec */

            case E_V32HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V32HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8908; /* vec_cmpv32hfdi_dup_exec */

            case E_V32SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V32SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8909; /* vec_cmpv32sidi_dup_exec */

            case E_V32SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V32SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8910; /* vec_cmpv32sfdi_dup_exec */

            case E_V32DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V32DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8911; /* vec_cmpv32didi_dup_exec */

            case E_V32DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V32DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8912; /* vec_cmpv32dfdi_dup_exec */

            case E_V64HImode:
              if (!gcn_alu_operand (operands[2], E_HImode)
                  || !gcn_vop3_operand (operands[3], E_V64HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8913; /* vec_cmpv64hidi_dup_exec */

            case E_V64HFmode:
              if (!gcn_alu_operand (operands[2], E_HFmode)
                  || !gcn_vop3_operand (operands[3], E_V64HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8914; /* vec_cmpv64hfdi_dup_exec */

            case E_V64SImode:
              if (!gcn_alu_operand (operands[2], E_SImode)
                  || !gcn_vop3_operand (operands[3], E_V64SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8915; /* vec_cmpv64sidi_dup_exec */

            case E_V64SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_vop3_operand (operands[3], E_V64SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8916; /* vec_cmpv64sfdi_dup_exec */

            case E_V64DImode:
              if (!gcn_alu_operand (operands[2], E_DImode)
                  || !gcn_vop3_operand (operands[3], E_V64DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8917; /* vec_cmpv64didi_dup_exec */

            case E_V64DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_vop3_operand (operands[3], E_V64DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8918; /* vec_cmpv64dfdi_dup_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 171; /* movv2qi_exec */

    case E_V2HImode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 172; /* movv2hi_exec */

    case E_V2SImode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 173; /* movv2si_exec */

    case E_V2HFmode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 174; /* movv2hf_exec */

    case E_V2SFmode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 175; /* movv2sf_exec */

    case E_V4QImode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 176; /* movv4qi_exec */

    case E_V4HImode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 177; /* movv4hi_exec */

    case E_V4SImode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 178; /* movv4si_exec */

    case E_V4HFmode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 179; /* movv4hf_exec */

    case E_V4SFmode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 180; /* movv4sf_exec */

    case E_V8QImode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 181; /* movv8qi_exec */

    case E_V8HImode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 182; /* movv8hi_exec */

    case E_V8SImode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 183; /* movv8si_exec */

    case E_V8HFmode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 184; /* movv8hf_exec */

    case E_V8SFmode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 185; /* movv8sf_exec */

    case E_V16QImode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 186; /* movv16qi_exec */

    case E_V16HImode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 187; /* movv16hi_exec */

    case E_V16SImode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 188; /* movv16si_exec */

    case E_V16HFmode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 189; /* movv16hf_exec */

    case E_V16SFmode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 190; /* movv16sf_exec */

    case E_V32QImode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 191; /* movv32qi_exec */

    case E_V32HImode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 192; /* movv32hi_exec */

    case E_V32SImode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 193; /* movv32si_exec */

    case E_V32HFmode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 194; /* movv32hf_exec */

    case E_V32SFmode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 195; /* movv32sf_exec */

    case E_V64QImode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64QImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 196; /* movv64qi_exec */

    case E_V64HImode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64HImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 197; /* movv64hi_exec */

    case E_V64SImode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64SImode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 198; /* movv64si_exec */

    case E_V64HFmode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64HFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 199; /* movv64hf_exec */

    case E_V64SFmode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64SFmode) != 0
          || !
#line 470 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 200; /* movv64sf_exec */

    case E_V2DImode:
      if (pattern193 (x3, 
E_V2DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 213; /* movv2di_exec */

    case E_V2DFmode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 214; /* movv2df_exec */

    case E_V4DImode:
      if (pattern193 (x3, 
E_V4DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 215; /* movv4di_exec */

    case E_V4DFmode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 216; /* movv4df_exec */

    case E_V8DImode:
      if (pattern193 (x3, 
E_V8DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 217; /* movv8di_exec */

    case E_V8DFmode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 218; /* movv8df_exec */

    case E_V16DImode:
      if (pattern193 (x3, 
E_V16DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 219; /* movv16di_exec */

    case E_V16DFmode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 220; /* movv16df_exec */

    case E_V32DImode:
      if (pattern193 (x3, 
E_V32DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 221; /* movv32di_exec */

    case E_V32DFmode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 222; /* movv32df_exec */

    case E_V64DImode:
      if (pattern193 (x3, 
E_V64DImode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 223; /* movv64di_exec */

    case E_V64DFmode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64DFmode) != 0
          || !
#line 532 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 224; /* movv64df_exec */

    case E_V2TImode:
      if (pattern192 (x3, 
E_V2DImode, 
E_V2TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 231; /* movv2ti_exec */

    case E_V4TImode:
      if (pattern192 (x3, 
E_V4DImode, 
E_V4TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 232; /* movv4ti_exec */

    case E_V8TImode:
      if (pattern192 (x3, 
E_V8DImode, 
E_V8TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 233; /* movv8ti_exec */

    case E_V16TImode:
      if (pattern192 (x3, 
E_V16DImode, 
E_V16TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 234; /* movv16ti_exec */

    case E_V32TImode:
      if (pattern192 (x3, 
E_V32DImode, 
E_V32TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 235; /* movv32ti_exec */

    case E_V64TImode:
      if (pattern192 (x3, 
E_V64DImode, 
E_V64TImode) != 0
          || !
#line 583 "../../gcc/config/gcn/gcn-valu.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 236; /* movv64ti_exec */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 1; /* nop */

    case TRAP_IF:
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 2; /* trap */

    case SET:
      return recog_94 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          if (XINT (x1, 1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          return 11; /* prologue_use */

        case 2:
          if (XINT (x1, 1) != 4)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          return 22; /* clear_icache */

        default:
          return -1;
        }

    case RETURN:
      return 15; /* gcn_return */

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x4 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x4))
            {
            case CALL:
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) != MEM)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (pattern72 (x5, 
18) != 0)
                return -1;
              x7 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x7) != CLOBBER)
                return -1;
              x8 = XEXP (x6, 0);
              operands[0] = x8;
              x9 = XEXP (x4, 1);
              operands[1] = x9;
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              if (!scratch_operand (operands[2], E_DImode))
                return -1;
              switch (GET_CODE (operands[0]))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  if (!immediate_operand (operands[0], E_VOIDmode)
                      || !const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 16; /* gcn_simple_call */

                case REG:
                case SUBREG:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 19; /* gcn_indirect_call */

                default:
                  return -1;
                }

            case SET:
              x6 = XEXP (x4, 0);
              operands[0] = x6;
              x9 = XEXP (x4, 1);
              switch (GET_CODE (x9))
                {
                case CALL:
                  x11 = XEXP (x9, 0);
                  if (GET_CODE (x11) != MEM)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (pattern72 (x5, 
18) != 0)
                    return -1;
                  x7 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x7) != CLOBBER
                      || !register_operand (operands[0], E_VOIDmode))
                    return -1;
                  x12 = XEXP (x11, 0);
                  operands[1] = x12;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  x10 = XEXP (x7, 0);
                  operands[3] = x10;
                  if (!scratch_operand (operands[3], E_DImode))
                    return -1;
                  switch (GET_CODE (operands[1]))
                    {
                    case CONST_INT:
                    case CONST_WIDE_INT:
                    case CONST_POLY_INT:
                    case CONST_FIXED:
                    case CONST_DOUBLE:
                    case CONST_VECTOR:
                    case CONST:
                    case LABEL_REF:
                    case SYMBOL_REF:
                    case HIGH:
                      if (!immediate_operand (operands[1], E_VOIDmode)
                          || !const_int_operand (operands[2], E_VOIDmode))
                        return -1;
                      return 20; /* gcn_call_value */

                    case REG:
                    case SUBREG:
                      if (!register_operand (operands[1], E_DImode))
                        return -1;
                      return 21; /* gcn_call_value_indirect */

                    default:
                      return -1;
                    }

                case PLUS:
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x7 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x7) != CLOBBER)
                    return -1;
                  x14 = XEXP (x5, 0);
                  operands[3] = x14;
                  x11 = XEXP (x9, 0);
                  switch (GET_CODE (x11))
                    {
                    case CONST_INT:
                    case CONST_DOUBLE:
                    case CONST_VECTOR:
                    case REG:
                    case SUBREG:
                    case LABEL_REF:
                    case SYMBOL_REF:
                      operands[1] = x11;
                      x13 = XEXP (x9, 1);
                      operands[2] = x13;
                      if (!scratch_operand (operands[3], E_BImode))
                        return -1;
                      x10 = XEXP (x7, 0);
                      operands[4] = x10;
                      if (!scratch_operand (operands[4], E_DImode))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern78 (x9, 
E_SImode) != 0)
                            return -1;
                          return 28; /* addsi3 */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || GET_MODE (x9) != E_DImode
                              || !register_operand (operands[1], E_DImode)
                              || !nonmemory_operand (operands[2], E_DImode))
                            return -1;
                          return 29; /* adddi3 */

                        default:
                          return -1;
                        }

                    case SIGN_EXTEND:
                      switch (pattern152 (x1))
                        {
                        case 0:
                          return 1584; /* addv2di3_sext_dup2 */

                        case 1:
                          return 1585; /* addv4di3_sext_dup2 */

                        case 2:
                          return 1586; /* addv8di3_sext_dup2 */

                        case 3:
                          return 1587; /* addv16di3_sext_dup2 */

                        case 4:
                          return 1588; /* addv32di3_sext_dup2 */

                        case 5:
                          return 1589; /* addv64di3_sext_dup2 */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case MINUS:
                  if (GET_MODE (x9) != E_SImode)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x7 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x7) != CLOBBER
                      || !register_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x9, 0);
                  operands[1] = x11;
                  if (!gcn_alu_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  if (!gcn_alu_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x5, 0);
                  operands[3] = x14;
                  if (!scratch_operand (operands[3], E_BImode))
                    return -1;
                  x10 = XEXP (x7, 0);
                  operands[4] = x10;
                  if (!scratch_operand (operands[4], E_DImode))
                    return -1;
                  return 35; /* subsi3 */

                case SUBREG:
                case MEM:
                  operands[1] = x9;
                  x5 = XVECEXP (x1, 0, 1);
                  if (pattern100 (x5, 
3, 
1, 
UNSPEC_VOLATILE) != 0)
                    return -1;
                  x7 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x7) != USE)
                    return -1;
                  x15 = XEXP (x5, 1);
                  x16 = XVECEXP (x15, 0, 0);
                  operands[2] = x16;
                  x10 = XEXP (x7, 0);
                  operands[3] = x10;
                  if (!immediate_operand (operands[3], E_VOIDmode))
                    return -1;
                  x14 = XEXP (x5, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern198 (x15, 
E_SImode) != 0)
                        return -1;
                      return 90; /* atomic_exchangesi */

                    case E_DImode:
                      if (pattern198 (x15, 
E_DImode) != 0)
                        return -1;
                      return 91; /* atomic_exchangedi */

                    default:
                      return -1;
                    }

                case VEC_MERGE:
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x7 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x7) != CLOBBER)
                    return -1;
                  switch (pattern110 (x1))
                    {
                    case 0:
                      return 1590; /* addv2di3_sext_dup2_exec */

                    case 1:
                      return 1591; /* addv4di3_sext_dup2_exec */

                    case 2:
                      return 1592; /* addv8di3_sext_dup2_exec */

                    case 3:
                      return 1593; /* addv16di3_sext_dup2_exec */

                    case 4:
                      return 1594; /* addv32di3_sext_dup2_exec */

                    case 5:
                      return 1595; /* addv64di3_sext_dup2_exec */

                    case 6:
                      return 2187; /* sminv2di3_exec */

                    case 7:
                      return 2191; /* sminv4di3_exec */

                    case 8:
                      return 2195; /* sminv8di3_exec */

                    case 9:
                      return 2199; /* sminv16di3_exec */

                    case 10:
                      return 2203; /* sminv32di3_exec */

                    case 11:
                      return 2207; /* sminv64di3_exec */

                    case 12:
                      return 2188; /* smaxv2di3_exec */

                    case 13:
                      return 2192; /* smaxv4di3_exec */

                    case 14:
                      return 2196; /* smaxv8di3_exec */

                    case 15:
                      return 2200; /* smaxv16di3_exec */

                    case 16:
                      return 2204; /* smaxv32di3_exec */

                    case 17:
                      return 2208; /* smaxv64di3_exec */

                    case 18:
                      return 2189; /* uminv2di3_exec */

                    case 19:
                      return 2193; /* uminv4di3_exec */

                    case 20:
                      return 2197; /* uminv8di3_exec */

                    case 21:
                      return 2201; /* uminv16di3_exec */

                    case 22:
                      return 2205; /* uminv32di3_exec */

                    case 23:
                      return 2209; /* uminv64di3_exec */

                    case 24:
                      return 2190; /* umaxv2di3_exec */

                    case 25:
                      return 2194; /* umaxv4di3_exec */

                    case 26:
                      return 2198; /* umaxv8di3_exec */

                    case 27:
                      return 2202; /* umaxv16di3_exec */

                    case 28:
                      return 2206; /* umaxv32di3_exec */

                    case 29:
                      return 2210; /* umaxv64di3_exec */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x4 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x4) != SET)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          x9 = XEXP (x4, 1);
          switch (GET_CODE (x9))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[1] = x9;
              x5 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x5))
                {
                case CLOBBER:
                  x14 = XEXP (x5, 0);
                  if (GET_CODE (x14) != REG
                      || !nonimmediate_operand (operands[0], E_DImode)
                      || !general_operand (operands[1], E_DImode)
                      || GET_MODE (x14) != E_BImode)
                    return -1;
                  switch (REGNO (x14))
                    {
                    case 129:
                      if (!
#line 912 "../../gcc/config/gcn/gcn.md"
(GET_CODE (operands[1]) == SYMBOL_REF || GET_CODE (operands[1]) == LABEL_REF))
                        return -1;
                      return 17; /* movdi_symbol */

                    case 22:
                      if (!
#line 935 "../../gcc/config/gcn/gcn.md"
((GET_CODE (operands[1]) == SYMBOL_REF || GET_CODE (operands[1]) == LABEL_REF)
  && (lra_in_progress || reload_completed)))
                        return -1;
                      return 18; /* movdi_symbol_save_scc */

                    default:
                      return -1;
                    }

                case SET:
                  x15 = XEXP (x5, 1);
                  if (GET_CODE (x15) != UNSPEC_VOLATILE
                      || XVECLEN (x15, 0) != 1
                      || XINT (x15, 1) != 3)
                    return -1;
                  x16 = XVECEXP (x15, 0, 0);
                  operands[2] = x16;
                  x14 = XEXP (x5, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern187 (x15, 
E_DImode, 
E_SImode) != 0)
                        return -1;
                      return 82; /* sync_compare_and_swapsi_insn */

                    case E_DImode:
                      if (pattern187 (x15, 
E_TImode, 
E_DImode) != 0)
                        return -1;
                      return 83; /* sync_compare_and_swapdi_insn */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PLUS:
              return recog_89 (x1, insn, pnum_clobbers);

            case MINUS:
              return recog_93 (x1, insn, pnum_clobbers);

            case MULT:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x14 = XEXP (x5, 0);
              operands[3] = x14;
              x11 = XEXP (x9, 0);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                  operands[1] = x11;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern173 (x9, 
E_BImode, 
E_SImode) != 0)
                        return -1;
                      return 41; /* mulsi3 */

                    case E_V2DImode:
                      if (pattern173 (x9, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      return 1719; /* mulv2di3 */

                    case E_V4DImode:
                      if (pattern173 (x9, 
E_V4SImode, 
E_V4DImode) != 0)
                        return -1;
                      return 1720; /* mulv4di3 */

                    case E_V8DImode:
                      if (pattern173 (x9, 
E_V8SImode, 
E_V8DImode) != 0)
                        return -1;
                      return 1721; /* mulv8di3 */

                    case E_V16DImode:
                      if (pattern173 (x9, 
E_V16SImode, 
E_V16DImode) != 0)
                        return -1;
                      return 1722; /* mulv16di3 */

                    case E_V32DImode:
                      if (pattern173 (x9, 
E_V32SImode, 
E_V32DImode) != 0)
                        return -1;
                      return 1723; /* mulv32di3 */

                    case E_V64DImode:
                      if (pattern173 (x9, 
E_V64SImode, 
E_V64DImode) != 0)
                        return -1;
                      return 1724; /* mulv64di3 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern127 (x9))
                    {
                    case 0:
                      return 1731; /* mulv2di3_zext */

                    case 1:
                      return 1732; /* mulv4di3_zext */

                    case 2:
                      return 1733; /* mulv8di3_zext */

                    case 3:
                      return 1734; /* mulv16di3_zext */

                    case 4:
                      return 1735; /* mulv32di3_zext */

                    case 5:
                      return 1736; /* mulv64di3_zext */

                    case 6:
                      return 1743; /* mulv2di3_zext_dup2 */

                    case 7:
                      return 1744; /* mulv4di3_zext_dup2 */

                    case 8:
                      return 1745; /* mulv8di3_zext_dup2 */

                    case 9:
                      return 1746; /* mulv16di3_zext_dup2 */

                    case 10:
                      return 1747; /* mulv32di3_zext_dup2 */

                    case 11:
                      return 1748; /* mulv64di3_zext_dup2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case NOT:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              x14 = XEXP (x5, 0);
              operands[2] = x14;
              if (!scratch_operand (operands[2], E_BImode))
                return -1;
              switch (pattern81 (x9))
                {
                case 0:
                  return 55; /* one_cmplsi2 */

                case 1:
                  return 73; /* one_cmpldi2 */

                default:
                  return -1;
                }

            case POPCOUNT:
              if (pattern77 (x1, 
E_SImode) != 0)
                return -1;
              return 56; /* popcountsi2 */

            case AND:
              return recog_91 (x1, insn, pnum_clobbers);

            case IOR:
              switch (pattern80 (x1))
                {
                case 0:
                  return 64; /* iorsi3 */

                case 1:
                  return 75; /* iordi3 */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern80 (x1))
                {
                case 0:
                  return 65; /* xorsi3 */

                case 1:
                  return 76; /* xordi3 */

                default:
                  return -1;
                }

            case SMIN:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (gcn_valu_src0_operand (operands[1], E_SImode)
                  && pattern128 (x1) == 0)
                return 66; /* sminsi3 */
              x14 = XEXP (x5, 0);
              if (GET_CODE (x14) != REG)
                return -1;
              switch (pattern129 (x1))
                {
                case 0:
                  return 2163; /* sminv2di3 */

                case 1:
                  return 2167; /* sminv4di3 */

                case 2:
                  return 2171; /* sminv8di3 */

                case 3:
                  return 2175; /* sminv16di3 */

                case 4:
                  return 2179; /* sminv32di3 */

                case 5:
                  return 2183; /* sminv64di3 */

                default:
                  return -1;
                }

            case SMAX:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (gcn_valu_src0_operand (operands[1], E_SImode)
                  && pattern128 (x1) == 0)
                return 67; /* smaxsi3 */
              x14 = XEXP (x5, 0);
              if (GET_CODE (x14) != REG)
                return -1;
              switch (pattern129 (x1))
                {
                case 0:
                  return 2164; /* smaxv2di3 */

                case 1:
                  return 2168; /* smaxv4di3 */

                case 2:
                  return 2172; /* smaxv8di3 */

                case 3:
                  return 2176; /* smaxv16di3 */

                case 4:
                  return 2180; /* smaxv32di3 */

                case 5:
                  return 2184; /* smaxv64di3 */

                default:
                  return -1;
                }

            case UMIN:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (gcn_valu_src0_operand (operands[1], E_SImode)
                  && pattern128 (x1) == 0)
                return 68; /* uminsi3 */
              x14 = XEXP (x5, 0);
              if (GET_CODE (x14) != REG)
                return -1;
              switch (pattern129 (x1))
                {
                case 0:
                  return 2165; /* uminv2di3 */

                case 1:
                  return 2169; /* uminv4di3 */

                case 2:
                  return 2173; /* uminv8di3 */

                case 3:
                  return 2177; /* uminv16di3 */

                case 4:
                  return 2181; /* uminv32di3 */

                case 5:
                  return 2185; /* uminv64di3 */

                default:
                  return -1;
                }

            case UMAX:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (gcn_valu_src0_operand (operands[1], E_SImode)
                  && pattern128 (x1) == 0)
                return 69; /* umaxsi3 */
              x14 = XEXP (x5, 0);
              if (GET_CODE (x14) != REG)
                return -1;
              switch (pattern129 (x1))
                {
                case 0:
                  return 2166; /* umaxv2di3 */

                case 1:
                  return 2170; /* umaxv4di3 */

                case 2:
                  return 2174; /* umaxv8di3 */

                case 3:
                  return 2178; /* umaxv16di3 */

                case 4:
                  return 2182; /* umaxv32di3 */

                case 5:
                  return 2186; /* umaxv64di3 */

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern82 (x1))
                {
                case 0:
                  return 70; /* ashlsi3 */

                case 1:
                  return 77; /* ashldi3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern82 (x1))
                {
                case 0:
                  return 71; /* lshrsi3 */

                case 1:
                  return 78; /* lshrdi3 */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern82 (x1))
                {
                case 0:
                  return 72; /* ashrsi3 */

                case 1:
                  return 79; /* ashrdi3 */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x9, 0) != 1
                  || XINT (x9, 1) != 3)
                return -1;
              x17 = XVECEXP (x9, 0, 0);
              operands[1] = x17;
              x5 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x5))
                {
                case SET:
                  x15 = XEXP (x5, 1);
                  if (GET_CODE (x15) != UNSPEC_VOLATILE
                      || XVECLEN (x15, 0) != 2
                      || XINT (x15, 1) != 3)
                    return -1;
                  x16 = XVECEXP (x15, 0, 0);
                  operands[2] = x16;
                  x18 = XVECEXP (x15, 0, 1);
                  operands[3] = x18;
                  x14 = XEXP (x5, 0);
                  if (!rtx_equal_p (x14, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern200 (x1, 
E_SImode) != 0)
                        return -1;
                      return 84; /* sync_compare_and_swapsi_lds_insn */

                    case E_DImode:
                      if (pattern200 (x1, 
E_DImode) != 0)
                        return -1;
                      return 85; /* sync_compare_and_swapdi_lds_insn */

                    default:
                      return -1;
                    }

                case USE:
                  x14 = XEXP (x5, 0);
                  operands[2] = x14;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (GET_MODE (x9) != E_SImode
                          || !immediate_operand (operands[2], E_SImode))
                        return -1;
                      if (register_operand (operands[0], E_SImode)
                          && memory_operand (operands[1], E_SImode))
                        return 86; /* atomic_loadsi */
                      if (!memory_operand (operands[0], E_SImode)
                          || !register_operand (operands[1], E_SImode))
                        return -1;
                      return 88; /* atomic_storesi */

                    case E_DImode:
                      if (GET_MODE (x9) != E_DImode
                          || !immediate_operand (operands[2], E_DImode))
                        return -1;
                      if (register_operand (operands[0], E_DImode)
                          && memory_operand (operands[1], E_DImode))
                        return 87; /* atomic_loaddi */
                      if (!memory_operand (operands[0], E_DImode)
                          || !register_operand (operands[1], E_DImode))
                        return -1;
                      return 89; /* atomic_storedi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case VEC_MERGE:
              return recog_90 (x1, insn, pnum_clobbers);

            case UNSPEC:
              return recog_88 (x1, insn, pnum_clobbers);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case LTGT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              return recog_92 (x1, insn, pnum_clobbers);

            default:
              return -1;
            }

        case 4:
          if (pattern34 (x1) != 0)
            return -1;
          return 50; /* muldi3 */

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != MEM)
        return -1;
      x19 = XEXP (x2, 0);
      operands[0] = x19;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_CODE (operands[0]))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (!immediate_operand (operands[0], E_VOIDmode)
              || !const_int_operand (operands[1], E_VOIDmode))
            return -1;
          *pnum_clobbers = 2;
          return 16; /* gcn_simple_call */

        case REG:
        case SUBREG:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          *pnum_clobbers = 2;
          return 19; /* gcn_indirect_call */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
