/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x1, pnum_clobbers); /* [-1, 0] */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V2QImode:
      if (pattern2 (x1, 
E_V2QImode) != 0)
        return -1;
      return 2;

    case E_V2HImode:
      if (pattern2 (x1, 
E_V2HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern2 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4QImode:
      if (pattern2 (x1, 
E_V4QImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern2 (x1, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern2 (x1, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V8QImode:
      if (pattern2 (x1, 
E_V8QImode) != 0)
        return -1;
      return 8;

    case E_V8HImode:
      if (pattern2 (x1, 
E_V8HImode) != 0)
        return -1;
      return 9;

    case E_V8SImode:
      if (pattern2 (x1, 
E_V8SImode) != 0)
        return -1;
      return 10;

    case E_V16QImode:
      if (pattern2 (x1, 
E_V16QImode) != 0)
        return -1;
      return 11;

    case E_V16HImode:
      if (pattern2 (x1, 
E_V16HImode) != 0)
        return -1;
      return 12;

    case E_V16SImode:
      if (pattern2 (x1, 
E_V16SImode) != 0)
        return -1;
      return 13;

    case E_V32QImode:
      if (pattern2 (x1, 
E_V32QImode) != 0)
        return -1;
      return 14;

    case E_V32HImode:
      if (pattern2 (x1, 
E_V32HImode) != 0)
        return -1;
      return 15;

    case E_V32SImode:
      if (pattern2 (x1, 
E_V32SImode) != 0)
        return -1;
      return 16;

    case E_V64QImode:
      if (pattern2 (x1, 
E_V64QImode) != 0)
        return -1;
      return 17;

    case E_V64HImode:
      if (pattern2 (x1, 
E_V64HImode) != 0)
        return -1;
      return 18;

    case E_V64SImode:
      if (pattern2 (x1, 
E_V64SImode) != 0)
        return -1;
      return 19;

    case E_V2DImode:
      if (pattern2 (x1, 
E_V2DImode) != 0)
        return -1;
      return 20;

    case E_V4DImode:
      if (pattern2 (x1, 
E_V4DImode) != 0)
        return -1;
      return 21;

    case E_V8DImode:
      if (pattern2 (x1, 
E_V8DImode) != 0)
        return -1;
      return 22;

    case E_V16DImode:
      if (pattern2 (x1, 
E_V16DImode) != 0)
        return -1;
      return 23;

    case E_V32DImode:
      if (pattern2 (x1, 
E_V32DImode) != 0)
        return -1;
      return 24;

    case E_V64DImode:
      if (pattern2 (x1, 
E_V64DImode) != 0)
        return -1;
      return 25;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern2 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern2 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern2 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern2 (x1, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern2 (x1, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern2 (x1, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  if (!gcn_exec_reg_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      return pattern49 (x1, 
E_V2HFmode); /* [-1, 0] */

    case E_V2SFmode:
      if (pattern49 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern49 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    case E_V4HFmode:
      if (pattern49 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern49 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    case E_V4DFmode:
      if (pattern49 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 5;

    case E_V8HFmode:
      if (pattern49 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern49 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V8DFmode:
      if (pattern49 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 8;

    case E_V16HFmode:
      if (pattern49 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 9;

    case E_V16SFmode:
      if (pattern49 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 10;

    case E_V16DFmode:
      if (pattern49 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      if (pattern49 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 12;

    case E_V32SFmode:
      if (pattern49 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 13;

    case E_V32DFmode:
      if (pattern49 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 14;

    case E_V64HFmode:
      if (pattern49 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 15;

    case E_V64SFmode:
      if (pattern49 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 16;

    case E_V64DFmode:
      if (pattern49 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!gcn_alu_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V32SFmode:
      if (!gcn_alu_operand (operands[1], E_V32SFmode))
        return -1;
      return 1;

    case E_V32DFmode:
      if (!gcn_alu_operand (operands[1], E_V32DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern69 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  return pattern79 (x1); /* [-1, 1] */
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern78 (x5, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern78 (x5, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern78 (x5, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern78 (x5, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern78 (x5, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern78 (x5, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern92 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern92 (x1, 
E_HImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern92 (x1, 
E_QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    case E_V8DImode:
      if (!gcn_alu_operand (operands[1], E_V8DImode))
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern86 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern86 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern86 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern86 (x1, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern86 (x1, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern86 (x1, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 2);
  operands[4] = x7;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  x10 = XEXP (x5, 0);
  switch (GET_CODE (x10))
    {
    case PLUS:
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != SIGN_EXTEND)
        return -1;
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != VEC_DUPLICATE)
        return -1;
      x13 = XEXP (x11, 0);
      operands[1] = x13;
      return pattern107 (x5); /* [-1, 5] */

    case SMIN:
      res = pattern109 (x5);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case SMAX:
      res = pattern109 (x5);
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case UMIN:
      res = pattern109 (x5);
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    case UMAX:
      res = pattern109 (x5);
      if (res >= 0)
        return res + 24; /* [24, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 106
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern78 (x5, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern78 (x5, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern78 (x5, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern78 (x5, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern78 (x5, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern78 (x5, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      return 0;

    case E_V2HImode:
      return 1;

    case E_V2SImode:
      return 2;

    case E_V4QImode:
      return 3;

    case E_V4HImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V8QImode:
      return 6;

    case E_V8HImode:
      return 7;

    case E_V8SImode:
      return 8;

    case E_V16QImode:
      return 9;

    case E_V16HImode:
      return 10;

    case E_V16SImode:
      return 11;

    case E_V32QImode:
      return 12;

    case E_V32HImode:
      return 13;

    case E_V32SImode:
      return 14;

    case E_V64QImode:
      return 15;

    case E_V64HImode:
      return 16;

    case E_V64SImode:
      return 17;

    case E_V2DImode:
      return 18;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          return pattern163 (x5, 
E_V2SImode, 
E_V2DImode); /* [-1, 0] */

        case E_V4DImode:
          if (pattern163 (x5, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern163 (x5, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 2;

        case E_V16DImode:
          if (pattern163 (x5, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 3;

        case E_V32DImode:
          if (pattern163 (x5, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 4;

        case E_V64DImode:
          if (pattern163 (x5, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern164 (x5, 
E_V2SImode, 
E_V2DImode) != 0)
                return -1;
              return 6;

            case E_V4DImode:
              if (pattern164 (x5, 
E_V4SImode, 
E_V4DImode) != 0)
                return -1;
              return 7;

            case E_V8DImode:
              if (pattern164 (x5, 
E_V8SImode, 
E_V8DImode) != 0)
                return -1;
              return 8;

            case E_V16DImode:
              if (pattern164 (x5, 
E_V16SImode, 
E_V16DImode) != 0)
                return -1;
              return 9;

            case E_V32DImode:
              if (pattern164 (x5, 
E_V32SImode, 
E_V32DImode) != 0)
                return -1;
              return 10;

            case E_V64DImode:
              if (pattern164 (x5, 
E_V64SImode, 
E_V64DImode) != 0)
                return -1;
              return 11;

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          res = pattern107 (x5);
          if (res >= 0)
            return res + 12; /* [12, 17] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V8DImode)
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V8SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V64QImode:
      if (!register_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[2], E_V64HImode))
        return -1;
      return 1;

    case E_V64HFmode:
      if (!register_operand (operands[2], E_V64HFmode))
        return -1;
      return 2;

    case E_V64SImode:
      if (!register_operand (operands[2], E_V64SImode))
        return -1;
      return 3;

    case E_V64SFmode:
      if (!register_operand (operands[2], E_V64SFmode))
        return -1;
      return 4;

    case E_V64DImode:
      if (!register_operand (operands[2], E_V64DImode))
        return -1;
      return 5;

    case E_V64DFmode:
      if (!register_operand (operands[2], E_V64DFmode))
        return -1;
      return 6;

    case E_V64TImode:
      if (!register_operand (operands[2], E_V64TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V64DImode)
        return -1;
      return 0;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V64SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XEXP (x15, 1);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x11, 1);
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_MODE (x22) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (pattern86 (x2, 
E_V2QImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9183; /* *plus_carry_dpp_shr_v2qi */

    case E_V2HImode:
      if (pattern86 (x2, 
E_V2HImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9184; /* *plus_carry_dpp_shr_v2hi */

    case E_V2SImode:
      if (pattern86 (x2, 
E_V2SImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9185; /* *plus_carry_dpp_shr_v2si */

    case E_V4QImode:
      if (pattern86 (x2, 
E_V4QImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9186; /* *plus_carry_dpp_shr_v4qi */

    case E_V4HImode:
      if (pattern86 (x2, 
E_V4HImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9187; /* *plus_carry_dpp_shr_v4hi */

    case E_V4SImode:
      if (pattern86 (x2, 
E_V4SImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9188; /* *plus_carry_dpp_shr_v4si */

    case E_V8QImode:
      if (pattern86 (x2, 
E_V8QImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9189; /* *plus_carry_dpp_shr_v8qi */

    case E_V8HImode:
      if (pattern86 (x2, 
E_V8HImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9190; /* *plus_carry_dpp_shr_v8hi */

    case E_V8SImode:
      if (pattern86 (x2, 
E_V8SImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9191; /* *plus_carry_dpp_shr_v8si */

    case E_V16QImode:
      if (pattern86 (x2, 
E_V16QImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9192; /* *plus_carry_dpp_shr_v16qi */

    case E_V16HImode:
      if (pattern86 (x2, 
E_V16HImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9193; /* *plus_carry_dpp_shr_v16hi */

    case E_V16SImode:
      if (pattern86 (x2, 
E_V16SImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9194; /* *plus_carry_dpp_shr_v16si */

    case E_V32QImode:
      if (pattern86 (x2, 
E_V32QImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9195; /* *plus_carry_dpp_shr_v32qi */

    case E_V32HImode:
      if (pattern86 (x2, 
E_V32HImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9196; /* *plus_carry_dpp_shr_v32hi */

    case E_V32SImode:
      if (pattern86 (x2, 
E_V32SImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9197; /* *plus_carry_dpp_shr_v32si */

    case E_V64QImode:
      if (pattern86 (x2, 
E_V64QImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9198; /* *plus_carry_dpp_shr_v64qi */

    case E_V64HImode:
      if (pattern86 (x2, 
E_V64HImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9199; /* *plus_carry_dpp_shr_v64hi */

    case E_V64SImode:
      if (pattern86 (x2, 
E_V64SImode) != 0
          || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      *pnum_clobbers = 1;
      return 9200; /* *plus_carry_dpp_shr_v64si */

    case E_V2DImode:
      if (pattern86 (x2, 
E_V2DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 9207; /* *plus_carry_dpp_shr_v2di */

    case E_V4DImode:
      if (pattern86 (x2, 
E_V4DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 9208; /* *plus_carry_dpp_shr_v4di */

    case E_V8DImode:
      if (pattern86 (x2, 
E_V8DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 9209; /* *plus_carry_dpp_shr_v8di */

    case E_V16DImode:
      if (pattern86 (x2, 
E_V16DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 9210; /* *plus_carry_dpp_shr_v16di */

    case E_V32DImode:
      if (pattern86 (x2, 
E_V32DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 9211; /* *plus_carry_dpp_shr_v32di */

    case E_V64DImode:
      if (pattern86 (x2, 
E_V64DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 9212; /* *plus_carry_dpp_shr_v64di */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 25:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != PLUS)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != VEC_DUPLICATE)
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_BLKmode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != SCRATCH)
        return -1;
      x7 = XEXP (x4, 0);
      if (!immediate_operand (x7, E_VOIDmode))
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (!immediate_operand (x8, E_VOIDmode))
        return -1;
      x9 = XVECEXP (x2, 0, 2);
      if (!immediate_operand (x9, E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          return recog_7 (x1, insn, pnum_clobbers);

        case PLUS:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != VEC_DUPLICATE)
            return -1;
          x12 = XEXP (x10, 1);
          if (GET_CODE (x12) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x11, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x14 = XEXP (x12, 0);
          operands[2] = x14;
          operands[3] = x7;
          operands[4] = x8;
          operands[5] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern223 (x2, 
E_V2QImode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 810; /* gatherv2qi_insn_2offsets */

            case E_V2HImode:
              if (pattern223 (x2, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 812; /* gatherv2hi_insn_2offsets */

            case E_V2HFmode:
              if (pattern223 (x2, 
E_V2HFmode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 814; /* gatherv2hf_insn_2offsets */

            case E_V2SImode:
              if (pattern224 (x2, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 816; /* gatherv2si_insn_2offsets */

            case E_V2SFmode:
              if (pattern223 (x2, 
E_V2SFmode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 818; /* gatherv2sf_insn_2offsets */

            case E_V2DImode:
              if (pattern224 (x2, 
E_V2DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 820; /* gatherv2di_insn_2offsets */

            case E_V2DFmode:
              if (pattern223 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 822; /* gatherv2df_insn_2offsets */

            case E_V2TImode:
              if (pattern223 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 824; /* gatherv2ti_insn_2offsets */

            case E_V4QImode:
              if (pattern223 (x2, 
E_V4QImode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 826; /* gatherv4qi_insn_2offsets */

            case E_V4HImode:
              if (pattern223 (x2, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 828; /* gatherv4hi_insn_2offsets */

            case E_V4HFmode:
              if (pattern223 (x2, 
E_V4HFmode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 830; /* gatherv4hf_insn_2offsets */

            case E_V4SImode:
              if (pattern225 (x2, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 832; /* gatherv4si_insn_2offsets */

            case E_V4SFmode:
              if (pattern223 (x2, 
E_V4SFmode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 834; /* gatherv4sf_insn_2offsets */

            case E_V4DImode:
              if (pattern225 (x2, 
E_V4DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 836; /* gatherv4di_insn_2offsets */

            case E_V4DFmode:
              if (pattern223 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 838; /* gatherv4df_insn_2offsets */

            case E_V4TImode:
              if (pattern223 (x2, 
E_V4TImode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 840; /* gatherv4ti_insn_2offsets */

            case E_V8QImode:
              if (pattern223 (x2, 
E_V8QImode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 842; /* gatherv8qi_insn_2offsets */

            case E_V8HImode:
              if (pattern223 (x2, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 844; /* gatherv8hi_insn_2offsets */

            case E_V8HFmode:
              if (pattern223 (x2, 
E_V8HFmode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 846; /* gatherv8hf_insn_2offsets */

            case E_V8SImode:
              if (pattern226 (x2, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 848; /* gatherv8si_insn_2offsets */

            case E_V8SFmode:
              if (pattern223 (x2, 
E_V8SFmode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 850; /* gatherv8sf_insn_2offsets */

            case E_V8DImode:
              if (pattern226 (x2, 
E_V8DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 852; /* gatherv8di_insn_2offsets */

            case E_V8DFmode:
              if (pattern223 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 854; /* gatherv8df_insn_2offsets */

            case E_V8TImode:
              if (pattern223 (x2, 
E_V8TImode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 856; /* gatherv8ti_insn_2offsets */

            case E_V16QImode:
              if (pattern223 (x2, 
E_V16QImode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 858; /* gatherv16qi_insn_2offsets */

            case E_V16HImode:
              if (pattern223 (x2, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 860; /* gatherv16hi_insn_2offsets */

            case E_V16HFmode:
              if (pattern223 (x2, 
E_V16HFmode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 862; /* gatherv16hf_insn_2offsets */

            case E_V16SImode:
              if (pattern227 (x2, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 864; /* gatherv16si_insn_2offsets */

            case E_V16SFmode:
              if (pattern223 (x2, 
E_V16SFmode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 866; /* gatherv16sf_insn_2offsets */

            case E_V16DImode:
              if (pattern227 (x2, 
E_V16DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 868; /* gatherv16di_insn_2offsets */

            case E_V16DFmode:
              if (pattern223 (x2, 
E_V16DFmode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 870; /* gatherv16df_insn_2offsets */

            case E_V16TImode:
              if (pattern223 (x2, 
E_V16TImode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 872; /* gatherv16ti_insn_2offsets */

            case E_V32QImode:
              if (pattern223 (x2, 
E_V32QImode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 874; /* gatherv32qi_insn_2offsets */

            case E_V32HImode:
              if (pattern223 (x2, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 876; /* gatherv32hi_insn_2offsets */

            case E_V32HFmode:
              if (pattern223 (x2, 
E_V32HFmode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 878; /* gatherv32hf_insn_2offsets */

            case E_V32SImode:
              if (pattern228 (x2, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 880; /* gatherv32si_insn_2offsets */

            case E_V32SFmode:
              if (pattern223 (x2, 
E_V32SFmode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 882; /* gatherv32sf_insn_2offsets */

            case E_V32DImode:
              if (pattern228 (x2, 
E_V32DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 884; /* gatherv32di_insn_2offsets */

            case E_V32DFmode:
              if (pattern223 (x2, 
E_V32DFmode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 886; /* gatherv32df_insn_2offsets */

            case E_V32TImode:
              if (pattern223 (x2, 
E_V32TImode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 888; /* gatherv32ti_insn_2offsets */

            case E_V64QImode:
              if (pattern223 (x2, 
E_V64QImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 890; /* gatherv64qi_insn_2offsets */

            case E_V64HImode:
              if (pattern223 (x2, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 892; /* gatherv64hi_insn_2offsets */

            case E_V64HFmode:
              if (pattern223 (x2, 
E_V64HFmode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 894; /* gatherv64hf_insn_2offsets */

            case E_V64SImode:
              if (pattern223 (x2, 
E_V64SImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 896; /* gatherv64si_insn_2offsets */

            case E_V64SFmode:
              if (pattern223 (x2, 
E_V64SFmode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 898; /* gatherv64sf_insn_2offsets */

            case E_V64DImode:
              if (pattern223 (x2, 
E_V64DImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 900; /* gatherv64di_insn_2offsets */

            case E_V64DFmode:
              if (pattern223 (x2, 
E_V64DFmode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 902; /* gatherv64df_insn_2offsets */

            case E_V64TImode:
              if (pattern223 (x2, 
E_V64TImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 904; /* gatherv64ti_insn_2offsets */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 11:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 2);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      operands[4] = x5;
      if (!register_operand (operands[4], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern86 (x2, 
E_V2SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          *pnum_clobbers = 1;
          return 9201; /* *plus_carry_in_dpp_shr_v2si */

        case E_V4SImode:
          if (pattern86 (x2, 
E_V4SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          *pnum_clobbers = 1;
          return 9202; /* *plus_carry_in_dpp_shr_v4si */

        case E_V8SImode:
          if (pattern86 (x2, 
E_V8SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          *pnum_clobbers = 1;
          return 9203; /* *plus_carry_in_dpp_shr_v8si */

        case E_V16SImode:
          if (pattern86 (x2, 
E_V16SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          *pnum_clobbers = 1;
          return 9204; /* *plus_carry_in_dpp_shr_v16si */

        case E_V32SImode:
          if (pattern86 (x2, 
E_V32SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          *pnum_clobbers = 1;
          return 9205; /* *plus_carry_in_dpp_shr_v32si */

        case E_V64SImode:
          if (pattern86 (x2, 
E_V64SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          *pnum_clobbers = 1;
          return 9206; /* *plus_carry_in_dpp_shr_v64si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern145 (x2, 
E_V64HImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5932; /* *truncv2qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8452; /* *truncv2qiv64hi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5936; /* *truncv2hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8458; /* *truncv2hiv64hi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5940; /* *truncv2siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8464; /* *truncv2siv64hi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5944; /* *truncv4qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8470; /* *truncv4qiv64hi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5948; /* *truncv4hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8476; /* *truncv4hiv64hi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5952; /* *truncv4siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8482; /* *truncv4siv64hi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5956; /* *truncv8qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8488; /* *truncv8qiv64hi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5960; /* *truncv8hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8494; /* *truncv8hiv64hi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5964; /* *truncv8siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8500; /* *truncv8siv64hi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5968; /* *truncv16qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8506; /* *truncv16qiv64hi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5972; /* *truncv16hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8512; /* *truncv16hiv64hi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5976; /* *truncv16siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8518; /* *truncv16siv64hi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5980; /* *truncv32qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8524; /* *truncv32qiv64hi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5984; /* *truncv32hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8530; /* *truncv32hiv64hi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5988; /* *truncv32siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8536; /* *truncv32siv64hi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5992; /* *truncv64qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8542; /* *truncv64qiv64hi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5996; /* *truncv64hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8548; /* *truncv64hiv64hi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6000; /* *truncv64siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8554; /* *truncv64siv64hi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V64DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V64HImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8701; /* truncv64div64hi2_exec */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern143 (x2, 
E_V16SImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5572; /* *truncv2qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7912; /* *truncv2qiv16si_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5576; /* *truncv2hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7918; /* *truncv2hiv16si_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5580; /* *truncv2siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7924; /* *truncv2siv16si_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5584; /* *truncv4qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7930; /* *truncv4qiv16si_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5588; /* *truncv4hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7936; /* *truncv4hiv16si_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5592; /* *truncv4siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7942; /* *truncv4siv16si_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5596; /* *truncv8qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7948; /* *truncv8qiv16si_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5600; /* *truncv8hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7954; /* *truncv8hiv16si_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5604; /* *truncv8siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7960; /* *truncv8siv16si_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5608; /* *truncv16qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7966; /* *truncv16qiv16si_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5612; /* *truncv16hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7972; /* *truncv16hiv16si_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5616; /* *truncv16siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7978; /* *truncv16siv16si_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5620; /* *truncv32qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7984; /* *truncv32qiv16si_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5624; /* *truncv32hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7990; /* *truncv32hiv16si_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5628; /* *truncv32siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7996; /* *truncv32siv16si_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5632; /* *truncv64qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8002; /* *truncv64qiv16si_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5636; /* *truncv64hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8008; /* *truncv64hiv16si_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5640; /* *truncv64siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8014; /* *truncv64siv16si_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V16DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V16SImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8696; /* truncv16div16si2_exec */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern141 (x2, 
E_V4SImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5140; /* *truncv2qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7264; /* *truncv2qiv4si_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5144; /* *truncv2hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7270; /* *truncv2hiv4si_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5148; /* *truncv2siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7276; /* *truncv2siv4si_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5152; /* *truncv4qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7282; /* *truncv4qiv4si_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5156; /* *truncv4hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7288; /* *truncv4hiv4si_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5160; /* *truncv4siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7294; /* *truncv4siv4si_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5164; /* *truncv8qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7300; /* *truncv8qiv4si_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5168; /* *truncv8hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7306; /* *truncv8hiv4si_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5172; /* *truncv8siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7312; /* *truncv8siv4si_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5176; /* *truncv16qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7318; /* *truncv16qiv4si_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5180; /* *truncv16hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7324; /* *truncv16hiv4si_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5184; /* *truncv16siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7330; /* *truncv16siv4si_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5188; /* *truncv32qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7336; /* *truncv32qiv4si_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5192; /* *truncv32hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7342; /* *truncv32hiv4si_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5196; /* *truncv32siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7348; /* *truncv32siv4si_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5200; /* *truncv64qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7354; /* *truncv64qiv4si_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5204; /* *truncv64hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7360; /* *truncv64hiv4si_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5208; /* *truncv64siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7366; /* *truncv64siv4si_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V4DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V4SImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8690; /* truncv4div4si2_exec */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern63 (x2))
    {
    case 0:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3278; /* truncv2hiv2hf2_exec */

    case 1:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3290; /* truncv2siv2hf2_exec */

    case 2:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3302; /* truncv2hfv2hf2_exec */

    case 3:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3314; /* truncv2sfv2hf2_exec */

    case 4:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3326; /* truncv2dfv2hf2_exec */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3338; /* truncv2hiv2sf2_exec */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3350; /* truncv2siv2sf2_exec */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3362; /* truncv2hfv2sf2_exec */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3374; /* truncv2sfv2sf2_exec */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3386; /* truncv2dfv2sf2_exec */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3398; /* truncv2hiv2df2_exec */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3410; /* truncv2siv2df2_exec */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3422; /* truncv2hfv2df2_exec */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3434; /* truncv2sfv2df2_exec */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3446; /* truncv2dfv2df2_exec */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3458; /* truncv4hiv4hf2_exec */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3470; /* truncv4siv4hf2_exec */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3482; /* truncv4hfv4hf2_exec */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3494; /* truncv4sfv4hf2_exec */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3506; /* truncv4dfv4hf2_exec */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3518; /* truncv4hiv4sf2_exec */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3530; /* truncv4siv4sf2_exec */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3542; /* truncv4hfv4sf2_exec */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3554; /* truncv4sfv4sf2_exec */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3566; /* truncv4dfv4sf2_exec */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3578; /* truncv4hiv4df2_exec */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3590; /* truncv4siv4df2_exec */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3602; /* truncv4hfv4df2_exec */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3614; /* truncv4sfv4df2_exec */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3626; /* truncv4dfv4df2_exec */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3638; /* truncv8hiv8hf2_exec */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3650; /* truncv8siv8hf2_exec */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3662; /* truncv8hfv8hf2_exec */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3674; /* truncv8sfv8hf2_exec */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3686; /* truncv8dfv8hf2_exec */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3698; /* truncv8hiv8sf2_exec */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3710; /* truncv8siv8sf2_exec */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3722; /* truncv8hfv8sf2_exec */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3734; /* truncv8sfv8sf2_exec */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3746; /* truncv8dfv8sf2_exec */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3758; /* truncv8hiv8df2_exec */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3770; /* truncv8siv8df2_exec */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3782; /* truncv8hfv8df2_exec */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3794; /* truncv8sfv8df2_exec */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3806; /* truncv8dfv8df2_exec */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3818; /* truncv16hiv16hf2_exec */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3830; /* truncv16siv16hf2_exec */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3842; /* truncv16hfv16hf2_exec */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3854; /* truncv16sfv16hf2_exec */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3866; /* truncv16dfv16hf2_exec */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3878; /* truncv16hiv16sf2_exec */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3890; /* truncv16siv16sf2_exec */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3902; /* truncv16hfv16sf2_exec */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3914; /* truncv16sfv16sf2_exec */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3926; /* truncv16dfv16sf2_exec */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3938; /* truncv16hiv16df2_exec */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3950; /* truncv16siv16df2_exec */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3962; /* truncv16hfv16df2_exec */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3974; /* truncv16sfv16df2_exec */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3986; /* truncv16dfv16df2_exec */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 3998; /* truncv32hiv32hf2_exec */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4010; /* truncv32siv32hf2_exec */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4022; /* truncv32hfv32hf2_exec */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4034; /* truncv32sfv32hf2_exec */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4046; /* truncv32dfv32hf2_exec */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4058; /* truncv32hiv32sf2_exec */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4070; /* truncv32siv32sf2_exec */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4082; /* truncv32hfv32sf2_exec */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4094; /* truncv32sfv32sf2_exec */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4106; /* truncv32dfv32sf2_exec */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4118; /* truncv32hiv32df2_exec */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4130; /* truncv32siv32df2_exec */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4142; /* truncv32hfv32df2_exec */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4154; /* truncv32sfv32df2_exec */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4166; /* truncv32dfv32df2_exec */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4178; /* truncv64hiv64hf2_exec */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4190; /* truncv64siv64hf2_exec */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4202; /* truncv64hfv64hf2_exec */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4214; /* truncv64sfv64hf2_exec */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4226; /* truncv64dfv64hf2_exec */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4238; /* truncv64hiv64sf2_exec */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4250; /* truncv64siv64sf2_exec */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4262; /* truncv64hfv64sf2_exec */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4274; /* truncv64sfv64sf2_exec */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4286; /* truncv64dfv64sf2_exec */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4298; /* truncv64hiv64df2_exec */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4310; /* truncv64siv64df2_exec */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4322; /* truncv64hfv64df2_exec */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4334; /* truncv64sfv64df2_exec */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4346; /* truncv64dfv64df2_exec */

    case 90:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       trunc_cvt)))
        return -1;
      return 4358; /* truncv2hfv2hi2_exec */

    case 91:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       trunc_cvt)))
        return -1;
      return 4370; /* truncv2sfv2hi2_exec */

    case 92:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       trunc_cvt)))
        return -1;
      return 4382; /* truncv2dfv2hi2_exec */

    case 93:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       trunc_cvt)))
        return -1;
      return 4394; /* truncv2hfv2si2_exec */

    case 94:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       trunc_cvt)))
        return -1;
      return 4406; /* truncv2sfv2si2_exec */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       trunc_cvt)))
        return -1;
      return 4418; /* truncv2dfv2si2_exec */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       trunc_cvt)))
        return -1;
      return 4430; /* truncv4hfv4hi2_exec */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       trunc_cvt)))
        return -1;
      return 4442; /* truncv4sfv4hi2_exec */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       trunc_cvt)))
        return -1;
      return 4454; /* truncv4dfv4hi2_exec */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       trunc_cvt)))
        return -1;
      return 4466; /* truncv4hfv4si2_exec */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       trunc_cvt)))
        return -1;
      return 4478; /* truncv4sfv4si2_exec */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       trunc_cvt)))
        return -1;
      return 4490; /* truncv4dfv4si2_exec */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       trunc_cvt)))
        return -1;
      return 4502; /* truncv8hfv8hi2_exec */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       trunc_cvt)))
        return -1;
      return 4514; /* truncv8sfv8hi2_exec */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       trunc_cvt)))
        return -1;
      return 4526; /* truncv8dfv8hi2_exec */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       trunc_cvt)))
        return -1;
      return 4538; /* truncv8hfv8si2_exec */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       trunc_cvt)))
        return -1;
      return 4550; /* truncv8sfv8si2_exec */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       trunc_cvt)))
        return -1;
      return 4562; /* truncv8dfv8si2_exec */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       trunc_cvt)))
        return -1;
      return 4574; /* truncv16hfv16hi2_exec */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       trunc_cvt)))
        return -1;
      return 4586; /* truncv16sfv16hi2_exec */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       trunc_cvt)))
        return -1;
      return 4598; /* truncv16dfv16hi2_exec */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       trunc_cvt)))
        return -1;
      return 4610; /* truncv16hfv16si2_exec */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       trunc_cvt)))
        return -1;
      return 4622; /* truncv16sfv16si2_exec */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       trunc_cvt)))
        return -1;
      return 4634; /* truncv16dfv16si2_exec */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       trunc_cvt)))
        return -1;
      return 4646; /* truncv32hfv32hi2_exec */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       trunc_cvt)))
        return -1;
      return 4658; /* truncv32sfv32hi2_exec */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       trunc_cvt)))
        return -1;
      return 4670; /* truncv32dfv32hi2_exec */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       trunc_cvt)))
        return -1;
      return 4682; /* truncv32hfv32si2_exec */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       trunc_cvt)))
        return -1;
      return 4694; /* truncv32sfv32si2_exec */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       trunc_cvt)))
        return -1;
      return 4706; /* truncv32dfv32si2_exec */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       trunc_cvt)))
        return -1;
      return 4718; /* truncv64hfv64hi2_exec */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       trunc_cvt)))
        return -1;
      return 4730; /* truncv64sfv64hi2_exec */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       trunc_cvt)))
        return -1;
      return 4742; /* truncv64dfv64hi2_exec */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       trunc_cvt)))
        return -1;
      return 4754; /* truncv64hfv64si2_exec */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       trunc_cvt)))
        return -1;
      return 4766; /* truncv64sfv64si2_exec */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       trunc_cvt)))
        return -1;
      return 4778; /* truncv64dfv64si2_exec */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 2);
  operands[5] = x6;
  if (!gcn_exec_reg_operand (operands[5], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x7;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern183 (x2, 
E_V2HFmode) != 0)
                return -1;
              return 2832; /* fmav2hf4_exec */

            case E_V2SFmode:
              if (pattern183 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 2834; /* fmav2sf4_exec */

            case E_V2DFmode:
              if (pattern183 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 2836; /* fmav2df4_exec */

            case E_V4HFmode:
              if (pattern183 (x2, 
E_V4HFmode) != 0)
                return -1;
              return 2838; /* fmav4hf4_exec */

            case E_V4SFmode:
              if (pattern183 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 2840; /* fmav4sf4_exec */

            case E_V4DFmode:
              if (pattern183 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 2842; /* fmav4df4_exec */

            case E_V8HFmode:
              if (pattern183 (x2, 
E_V8HFmode) != 0)
                return -1;
              return 2844; /* fmav8hf4_exec */

            case E_V8SFmode:
              if (pattern183 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 2846; /* fmav8sf4_exec */

            case E_V8DFmode:
              if (pattern183 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 2848; /* fmav8df4_exec */

            case E_V16HFmode:
              if (pattern183 (x2, 
E_V16HFmode) != 0)
                return -1;
              return 2850; /* fmav16hf4_exec */

            case E_V16SFmode:
              if (pattern183 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 2852; /* fmav16sf4_exec */

            case E_V16DFmode:
              if (pattern183 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 2854; /* fmav16df4_exec */

            case E_V32HFmode:
              if (pattern183 (x2, 
E_V32HFmode) != 0)
                return -1;
              return 2856; /* fmav32hf4_exec */

            case E_V32SFmode:
              if (pattern183 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 2858; /* fmav32sf4_exec */

            case E_V32DFmode:
              if (pattern183 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 2860; /* fmav32df4_exec */

            case E_V64HFmode:
              if (pattern183 (x2, 
E_V64HFmode) != 0)
                return -1;
              return 2862; /* fmav64hf4_exec */

            case E_V64SFmode:
              if (pattern183 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 2864; /* fmav64sf4_exec */

            case E_V64DFmode:
              if (pattern183 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 2866; /* fmav64df4_exec */

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern184 (x2, 
E_V2HFmode) != 0)
                return -1;
              return 2910; /* fmsv2hf4_exec */

            case E_V2SFmode:
              if (pattern184 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 2912; /* fmsv2sf4_exec */

            case E_V2DFmode:
              if (pattern184 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 2914; /* fmsv2df4_exec */

            case E_V4HFmode:
              if (pattern184 (x2, 
E_V4HFmode) != 0)
                return -1;
              return 2916; /* fmsv4hf4_exec */

            case E_V4SFmode:
              if (pattern184 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 2918; /* fmsv4sf4_exec */

            case E_V4DFmode:
              if (pattern184 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 2920; /* fmsv4df4_exec */

            case E_V8HFmode:
              if (pattern184 (x2, 
E_V8HFmode) != 0)
                return -1;
              return 2922; /* fmsv8hf4_exec */

            case E_V8SFmode:
              if (pattern184 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 2924; /* fmsv8sf4_exec */

            case E_V8DFmode:
              if (pattern184 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 2926; /* fmsv8df4_exec */

            case E_V16HFmode:
              if (pattern184 (x2, 
E_V16HFmode) != 0)
                return -1;
              return 2928; /* fmsv16hf4_exec */

            case E_V16SFmode:
              if (pattern184 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 2930; /* fmsv16sf4_exec */

            case E_V16DFmode:
              if (pattern184 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 2932; /* fmsv16df4_exec */

            case E_V32HFmode:
              if (pattern184 (x2, 
E_V32HFmode) != 0)
                return -1;
              return 2934; /* fmsv32hf4_exec */

            case E_V32SFmode:
              if (pattern184 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 2936; /* fmsv32sf4_exec */

            case E_V32DFmode:
              if (pattern184 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 2938; /* fmsv32df4_exec */

            case E_V64HFmode:
              if (pattern184 (x2, 
E_V64HFmode) != 0)
                return -1;
              return 2940; /* fmsv64hf4_exec */

            case E_V64SFmode:
              if (pattern184 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 2942; /* fmsv64sf4_exec */

            case E_V64DFmode:
              if (pattern184 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 2944; /* fmsv64df4_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern185 (x2, 
E_V2HFmode) != 0)
                return -1;
              return 2868; /* fmav2hf4_negop2_exec */

            case E_V2SFmode:
              if (pattern185 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 2870; /* fmav2sf4_negop2_exec */

            case E_V2DFmode:
              if (pattern185 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 2872; /* fmav2df4_negop2_exec */

            case E_V4HFmode:
              if (pattern185 (x2, 
E_V4HFmode) != 0)
                return -1;
              return 2874; /* fmav4hf4_negop2_exec */

            case E_V4SFmode:
              if (pattern185 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 2876; /* fmav4sf4_negop2_exec */

            case E_V4DFmode:
              if (pattern185 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 2878; /* fmav4df4_negop2_exec */

            case E_V8HFmode:
              if (pattern185 (x2, 
E_V8HFmode) != 0)
                return -1;
              return 2880; /* fmav8hf4_negop2_exec */

            case E_V8SFmode:
              if (pattern185 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 2882; /* fmav8sf4_negop2_exec */

            case E_V8DFmode:
              if (pattern185 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 2884; /* fmav8df4_negop2_exec */

            case E_V16HFmode:
              if (pattern185 (x2, 
E_V16HFmode) != 0)
                return -1;
              return 2886; /* fmav16hf4_negop2_exec */

            case E_V16SFmode:
              if (pattern185 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 2888; /* fmav16sf4_negop2_exec */

            case E_V16DFmode:
              if (pattern185 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 2890; /* fmav16df4_negop2_exec */

            case E_V32HFmode:
              if (pattern185 (x2, 
E_V32HFmode) != 0)
                return -1;
              return 2892; /* fmav32hf4_negop2_exec */

            case E_V32SFmode:
              if (pattern185 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 2894; /* fmav32sf4_negop2_exec */

            case E_V32DFmode:
              if (pattern185 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 2896; /* fmav32df4_negop2_exec */

            case E_V64HFmode:
              if (pattern185 (x2, 
E_V64HFmode) != 0)
                return -1;
              return 2898; /* fmav64hf4_negop2_exec */

            case E_V64SFmode:
              if (pattern185 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 2900; /* fmav64sf4_negop2_exec */

            case E_V64DFmode:
              if (pattern185 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 2902; /* fmav64df4_negop2_exec */

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern186 (x2, 
E_V2HFmode) != 0)
                return -1;
              return 2946; /* fmsv2hf4_negop2_exec */

            case E_V2SFmode:
              if (pattern186 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 2948; /* fmsv2sf4_negop2_exec */

            case E_V2DFmode:
              if (pattern186 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 2950; /* fmsv2df4_negop2_exec */

            case E_V4HFmode:
              if (pattern186 (x2, 
E_V4HFmode) != 0)
                return -1;
              return 2952; /* fmsv4hf4_negop2_exec */

            case E_V4SFmode:
              if (pattern186 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 2954; /* fmsv4sf4_negop2_exec */

            case E_V4DFmode:
              if (pattern186 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 2956; /* fmsv4df4_negop2_exec */

            case E_V8HFmode:
              if (pattern186 (x2, 
E_V8HFmode) != 0)
                return -1;
              return 2958; /* fmsv8hf4_negop2_exec */

            case E_V8SFmode:
              if (pattern186 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 2960; /* fmsv8sf4_negop2_exec */

            case E_V8DFmode:
              if (pattern186 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 2962; /* fmsv8df4_negop2_exec */

            case E_V16HFmode:
              if (pattern186 (x2, 
E_V16HFmode) != 0)
                return -1;
              return 2964; /* fmsv16hf4_negop2_exec */

            case E_V16SFmode:
              if (pattern186 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 2966; /* fmsv16sf4_negop2_exec */

            case E_V16DFmode:
              if (pattern186 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 2968; /* fmsv16df4_negop2_exec */

            case E_V32HFmode:
              if (pattern186 (x2, 
E_V32HFmode) != 0)
                return -1;
              return 2970; /* fmsv32hf4_negop2_exec */

            case E_V32SFmode:
              if (pattern186 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 2972; /* fmsv32sf4_negop2_exec */

            case E_V32DFmode:
              if (pattern186 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 2974; /* fmsv32df4_negop2_exec */

            case E_V64HFmode:
              if (pattern186 (x2, 
E_V64HFmode) != 0)
                return -1;
              return 2976; /* fmsv64hf4_negop2_exec */

            case E_V64SFmode:
              if (pattern186 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 2978; /* fmsv64sf4_negop2_exec */

            case E_V64DFmode:
              if (pattern186 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 2980; /* fmsv64df4_negop2_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern25 (x1))
    {
    case 0:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HImode,
		    trunc_cvt)))
        return 3122; /* trunchihi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HImode,
		    trunc_cvt)))
        return 3128; /* truncsihi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HImode,
		    trunc_cvt)))
        return 3134; /* trunchfhi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HImode,
		    trunc_cvt)))
        return 3140; /* truncsfhi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HImode,
		    trunc_cvt)))
        return -1;
      return 3146; /* truncdfhi2 */

    case 1:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SImode,
		    trunc_cvt)))
        return 3152; /* trunchisi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SImode,
		    trunc_cvt)))
        return 3158; /* truncsisi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SImode,
		    trunc_cvt)))
        return 3164; /* trunchfsi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SImode,
		    trunc_cvt)))
        return 3170; /* truncsfsi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SImode,
		    trunc_cvt)))
        return -1;
      return 3176; /* truncdfsi2 */

    case 2:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HFmode,
		    trunc_cvt)))
        return 3182; /* trunchihf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HFmode,
		    trunc_cvt)))
        return 3188; /* truncsihf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HFmode,
		    trunc_cvt)))
        return 3194; /* trunchfhf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HFmode,
		    trunc_cvt)))
        return 3200; /* truncsfhf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HFmode,
		    trunc_cvt)))
        return -1;
      return 3206; /* truncdfhf2 */

    case 3:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SFmode,
		    trunc_cvt)))
        return 3212; /* trunchisf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SFmode,
		    trunc_cvt)))
        return 3218; /* truncsisf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SFmode,
		    trunc_cvt)))
        return 3224; /* trunchfsf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SFmode,
		    trunc_cvt)))
        return 3230; /* truncsfsf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SFmode,
		    trunc_cvt)))
        return -1;
      return 3236; /* truncdfsf2 */

    case 4:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, DFmode,
		    trunc_cvt)))
        return 3242; /* trunchidf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, DFmode,
		    trunc_cvt)))
        return 3248; /* truncsidf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, DFmode,
		    trunc_cvt)))
        return 3254; /* trunchfdf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, DFmode,
		    trunc_cvt)))
        return 3260; /* truncsfdf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, DFmode,
		    trunc_cvt)))
        return -1;
      return 3266; /* truncdfdf2 */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3277; /* truncv2hiv2hf2 */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3289; /* truncv2siv2hf2 */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3301; /* truncv2hfv2hf2 */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3313; /* truncv2sfv2hf2 */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       trunc_cvt)))
        return -1;
      return 3325; /* truncv2dfv2hf2 */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3337; /* truncv2hiv2sf2 */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3349; /* truncv2siv2sf2 */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3361; /* truncv2hfv2sf2 */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3373; /* truncv2sfv2sf2 */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       trunc_cvt)))
        return -1;
      return 3385; /* truncv2dfv2sf2 */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3397; /* truncv2hiv2df2 */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3409; /* truncv2siv2df2 */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3421; /* truncv2hfv2df2 */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3433; /* truncv2sfv2df2 */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       trunc_cvt)))
        return -1;
      return 3445; /* truncv2dfv2df2 */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3457; /* truncv4hiv4hf2 */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3469; /* truncv4siv4hf2 */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3481; /* truncv4hfv4hf2 */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3493; /* truncv4sfv4hf2 */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       trunc_cvt)))
        return -1;
      return 3505; /* truncv4dfv4hf2 */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3517; /* truncv4hiv4sf2 */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3529; /* truncv4siv4sf2 */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3541; /* truncv4hfv4sf2 */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3553; /* truncv4sfv4sf2 */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       trunc_cvt)))
        return -1;
      return 3565; /* truncv4dfv4sf2 */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3577; /* truncv4hiv4df2 */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3589; /* truncv4siv4df2 */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3601; /* truncv4hfv4df2 */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3613; /* truncv4sfv4df2 */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       trunc_cvt)))
        return -1;
      return 3625; /* truncv4dfv4df2 */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3637; /* truncv8hiv8hf2 */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3649; /* truncv8siv8hf2 */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3661; /* truncv8hfv8hf2 */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3673; /* truncv8sfv8hf2 */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       trunc_cvt)))
        return -1;
      return 3685; /* truncv8dfv8hf2 */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3697; /* truncv8hiv8sf2 */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3709; /* truncv8siv8sf2 */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3721; /* truncv8hfv8sf2 */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3733; /* truncv8sfv8sf2 */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       trunc_cvt)))
        return -1;
      return 3745; /* truncv8dfv8sf2 */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3757; /* truncv8hiv8df2 */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3769; /* truncv8siv8df2 */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3781; /* truncv8hfv8df2 */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3793; /* truncv8sfv8df2 */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       trunc_cvt)))
        return -1;
      return 3805; /* truncv8dfv8df2 */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3817; /* truncv16hiv16hf2 */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3829; /* truncv16siv16hf2 */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3841; /* truncv16hfv16hf2 */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3853; /* truncv16sfv16hf2 */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       trunc_cvt)))
        return -1;
      return 3865; /* truncv16dfv16hf2 */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3877; /* truncv16hiv16sf2 */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3889; /* truncv16siv16sf2 */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3901; /* truncv16hfv16sf2 */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3913; /* truncv16sfv16sf2 */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       trunc_cvt)))
        return -1;
      return 3925; /* truncv16dfv16sf2 */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3937; /* truncv16hiv16df2 */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3949; /* truncv16siv16df2 */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3961; /* truncv16hfv16df2 */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3973; /* truncv16sfv16df2 */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       trunc_cvt)))
        return -1;
      return 3985; /* truncv16dfv16df2 */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 3997; /* truncv32hiv32hf2 */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4009; /* truncv32siv32hf2 */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4021; /* truncv32hfv32hf2 */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4033; /* truncv32sfv32hf2 */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       trunc_cvt)))
        return -1;
      return 4045; /* truncv32dfv32hf2 */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4057; /* truncv32hiv32sf2 */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4069; /* truncv32siv32sf2 */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4081; /* truncv32hfv32sf2 */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4093; /* truncv32sfv32sf2 */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       trunc_cvt)))
        return -1;
      return 4105; /* truncv32dfv32sf2 */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4117; /* truncv32hiv32df2 */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4129; /* truncv32siv32df2 */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4141; /* truncv32hfv32df2 */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4153; /* truncv32sfv32df2 */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       trunc_cvt)))
        return -1;
      return 4165; /* truncv32dfv32df2 */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4177; /* truncv64hiv64hf2 */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4189; /* truncv64siv64hf2 */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4201; /* truncv64hfv64hf2 */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4213; /* truncv64sfv64hf2 */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       trunc_cvt)))
        return -1;
      return 4225; /* truncv64dfv64hf2 */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4237; /* truncv64hiv64sf2 */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4249; /* truncv64siv64sf2 */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4261; /* truncv64hfv64sf2 */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4273; /* truncv64sfv64sf2 */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       trunc_cvt)))
        return -1;
      return 4285; /* truncv64dfv64sf2 */

    case 90:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4297; /* truncv64hiv64df2 */

    case 91:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4309; /* truncv64siv64df2 */

    case 92:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4321; /* truncv64hfv64df2 */

    case 93:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4333; /* truncv64sfv64df2 */

    case 94:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       trunc_cvt)))
        return -1;
      return 4345; /* truncv64dfv64df2 */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       trunc_cvt)))
        return -1;
      return 4357; /* truncv2hfv2hi2 */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       trunc_cvt)))
        return -1;
      return 4369; /* truncv2sfv2hi2 */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       trunc_cvt)))
        return -1;
      return 4381; /* truncv2dfv2hi2 */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       trunc_cvt)))
        return -1;
      return 4393; /* truncv2hfv2si2 */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       trunc_cvt)))
        return -1;
      return 4405; /* truncv2sfv2si2 */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       trunc_cvt)))
        return -1;
      return 4417; /* truncv2dfv2si2 */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       trunc_cvt)))
        return -1;
      return 4429; /* truncv4hfv4hi2 */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       trunc_cvt)))
        return -1;
      return 4441; /* truncv4sfv4hi2 */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       trunc_cvt)))
        return -1;
      return 4453; /* truncv4dfv4hi2 */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       trunc_cvt)))
        return -1;
      return 4465; /* truncv4hfv4si2 */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       trunc_cvt)))
        return -1;
      return 4477; /* truncv4sfv4si2 */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       trunc_cvt)))
        return -1;
      return 4489; /* truncv4dfv4si2 */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       trunc_cvt)))
        return -1;
      return 4501; /* truncv8hfv8hi2 */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       trunc_cvt)))
        return -1;
      return 4513; /* truncv8sfv8hi2 */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       trunc_cvt)))
        return -1;
      return 4525; /* truncv8dfv8hi2 */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       trunc_cvt)))
        return -1;
      return 4537; /* truncv8hfv8si2 */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       trunc_cvt)))
        return -1;
      return 4549; /* truncv8sfv8si2 */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       trunc_cvt)))
        return -1;
      return 4561; /* truncv8dfv8si2 */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       trunc_cvt)))
        return -1;
      return 4573; /* truncv16hfv16hi2 */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       trunc_cvt)))
        return -1;
      return 4585; /* truncv16sfv16hi2 */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       trunc_cvt)))
        return -1;
      return 4597; /* truncv16dfv16hi2 */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       trunc_cvt)))
        return -1;
      return 4609; /* truncv16hfv16si2 */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       trunc_cvt)))
        return -1;
      return 4621; /* truncv16sfv16si2 */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       trunc_cvt)))
        return -1;
      return 4633; /* truncv16dfv16si2 */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       trunc_cvt)))
        return -1;
      return 4645; /* truncv32hfv32hi2 */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       trunc_cvt)))
        return -1;
      return 4657; /* truncv32sfv32hi2 */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       trunc_cvt)))
        return -1;
      return 4669; /* truncv32dfv32hi2 */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       trunc_cvt)))
        return -1;
      return 4681; /* truncv32hfv32si2 */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       trunc_cvt)))
        return -1;
      return 4693; /* truncv32sfv32si2 */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       trunc_cvt)))
        return -1;
      return 4705; /* truncv32dfv32si2 */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       trunc_cvt)))
        return -1;
      return 4717; /* truncv64hfv64hi2 */

    case 126:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       trunc_cvt)))
        return -1;
      return 4729; /* truncv64sfv64hi2 */

    case 127:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       trunc_cvt)))
        return -1;
      return 4741; /* truncv64dfv64hi2 */

    case 128:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       trunc_cvt)))
        return -1;
      return 4753; /* truncv64hfv64si2 */

    case 129:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       trunc_cvt)))
        return -1;
      return 4765; /* truncv64sfv64si2 */

    case 130:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       trunc_cvt)))
        return -1;
      return 4777; /* truncv64dfv64si2 */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern25 (x1))
    {
    case 0:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HImode,
		    fix_trunc_cvt)))
        return 3117; /* fix_trunchihi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HImode,
		    fix_trunc_cvt)))
        return 3123; /* fix_truncsihi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HImode,
		    fix_trunc_cvt)))
        return 3129; /* fix_trunchfhi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HImode,
		    fix_trunc_cvt)))
        return 3135; /* fix_truncsfhi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HImode,
		    fix_trunc_cvt)))
        return -1;
      return 3141; /* fix_truncdfhi2 */

    case 1:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SImode,
		    fix_trunc_cvt)))
        return 3147; /* fix_trunchisi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SImode,
		    fix_trunc_cvt)))
        return 3153; /* fix_truncsisi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SImode,
		    fix_trunc_cvt)))
        return 3159; /* fix_trunchfsi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SImode,
		    fix_trunc_cvt)))
        return 3165; /* fix_truncsfsi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SImode,
		    fix_trunc_cvt)))
        return -1;
      return 3171; /* fix_truncdfsi2 */

    case 2:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HFmode,
		    fix_trunc_cvt)))
        return 3177; /* fix_trunchihf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HFmode,
		    fix_trunc_cvt)))
        return 3183; /* fix_truncsihf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HFmode,
		    fix_trunc_cvt)))
        return 3189; /* fix_trunchfhf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HFmode,
		    fix_trunc_cvt)))
        return 3195; /* fix_truncsfhf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HFmode,
		    fix_trunc_cvt)))
        return -1;
      return 3201; /* fix_truncdfhf2 */

    case 3:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SFmode,
		    fix_trunc_cvt)))
        return 3207; /* fix_trunchisf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SFmode,
		    fix_trunc_cvt)))
        return 3213; /* fix_truncsisf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SFmode,
		    fix_trunc_cvt)))
        return 3219; /* fix_trunchfsf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SFmode,
		    fix_trunc_cvt)))
        return 3225; /* fix_truncsfsf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SFmode,
		    fix_trunc_cvt)))
        return -1;
      return 3231; /* fix_truncdfsf2 */

    case 4:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, DFmode,
		    fix_trunc_cvt)))
        return 3237; /* fix_trunchidf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, DFmode,
		    fix_trunc_cvt)))
        return 3243; /* fix_truncsidf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, DFmode,
		    fix_trunc_cvt)))
        return 3249; /* fix_trunchfdf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, DFmode,
		    fix_trunc_cvt)))
        return 3255; /* fix_truncsfdf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, DFmode,
		    fix_trunc_cvt)))
        return -1;
      return 3261; /* fix_truncdfdf2 */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3267; /* fix_truncv2hiv2hf2 */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3279; /* fix_truncv2siv2hf2 */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3291; /* fix_truncv2hfv2hf2 */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3303; /* fix_truncv2sfv2hf2 */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3315; /* fix_truncv2dfv2hf2 */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3327; /* fix_truncv2hiv2sf2 */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3339; /* fix_truncv2siv2sf2 */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3351; /* fix_truncv2hfv2sf2 */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3363; /* fix_truncv2sfv2sf2 */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3375; /* fix_truncv2dfv2sf2 */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3387; /* fix_truncv2hiv2df2 */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3399; /* fix_truncv2siv2df2 */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3411; /* fix_truncv2hfv2df2 */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3423; /* fix_truncv2sfv2df2 */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3435; /* fix_truncv2dfv2df2 */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3447; /* fix_truncv4hiv4hf2 */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3459; /* fix_truncv4siv4hf2 */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3471; /* fix_truncv4hfv4hf2 */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3483; /* fix_truncv4sfv4hf2 */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3495; /* fix_truncv4dfv4hf2 */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3507; /* fix_truncv4hiv4sf2 */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3519; /* fix_truncv4siv4sf2 */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3531; /* fix_truncv4hfv4sf2 */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3543; /* fix_truncv4sfv4sf2 */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3555; /* fix_truncv4dfv4sf2 */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3567; /* fix_truncv4hiv4df2 */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3579; /* fix_truncv4siv4df2 */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3591; /* fix_truncv4hfv4df2 */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3603; /* fix_truncv4sfv4df2 */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3615; /* fix_truncv4dfv4df2 */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3627; /* fix_truncv8hiv8hf2 */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3639; /* fix_truncv8siv8hf2 */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3651; /* fix_truncv8hfv8hf2 */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3663; /* fix_truncv8sfv8hf2 */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3675; /* fix_truncv8dfv8hf2 */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3687; /* fix_truncv8hiv8sf2 */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3699; /* fix_truncv8siv8sf2 */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3711; /* fix_truncv8hfv8sf2 */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3723; /* fix_truncv8sfv8sf2 */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3735; /* fix_truncv8dfv8sf2 */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3747; /* fix_truncv8hiv8df2 */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3759; /* fix_truncv8siv8df2 */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3771; /* fix_truncv8hfv8df2 */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3783; /* fix_truncv8sfv8df2 */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3795; /* fix_truncv8dfv8df2 */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3807; /* fix_truncv16hiv16hf2 */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3819; /* fix_truncv16siv16hf2 */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3831; /* fix_truncv16hfv16hf2 */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3843; /* fix_truncv16sfv16hf2 */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3855; /* fix_truncv16dfv16hf2 */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3867; /* fix_truncv16hiv16sf2 */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3879; /* fix_truncv16siv16sf2 */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3891; /* fix_truncv16hfv16sf2 */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3903; /* fix_truncv16sfv16sf2 */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3915; /* fix_truncv16dfv16sf2 */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3927; /* fix_truncv16hiv16df2 */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3939; /* fix_truncv16siv16df2 */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3951; /* fix_truncv16hfv16df2 */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3963; /* fix_truncv16sfv16df2 */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3975; /* fix_truncv16dfv16df2 */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3987; /* fix_truncv32hiv32hf2 */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 3999; /* fix_truncv32siv32hf2 */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4011; /* fix_truncv32hfv32hf2 */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4023; /* fix_truncv32sfv32hf2 */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4035; /* fix_truncv32dfv32hf2 */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4047; /* fix_truncv32hiv32sf2 */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4059; /* fix_truncv32siv32sf2 */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4071; /* fix_truncv32hfv32sf2 */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4083; /* fix_truncv32sfv32sf2 */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4095; /* fix_truncv32dfv32sf2 */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4107; /* fix_truncv32hiv32df2 */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4119; /* fix_truncv32siv32df2 */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4131; /* fix_truncv32hfv32df2 */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4143; /* fix_truncv32sfv32df2 */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4155; /* fix_truncv32dfv32df2 */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4167; /* fix_truncv64hiv64hf2 */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4179; /* fix_truncv64siv64hf2 */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4191; /* fix_truncv64hfv64hf2 */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4203; /* fix_truncv64sfv64hf2 */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4215; /* fix_truncv64dfv64hf2 */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4227; /* fix_truncv64hiv64sf2 */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4239; /* fix_truncv64siv64sf2 */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4251; /* fix_truncv64hfv64sf2 */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4263; /* fix_truncv64sfv64sf2 */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4275; /* fix_truncv64dfv64sf2 */

    case 90:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4287; /* fix_truncv64hiv64df2 */

    case 91:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4299; /* fix_truncv64siv64df2 */

    case 92:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4311; /* fix_truncv64hfv64df2 */

    case 93:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4323; /* fix_truncv64sfv64df2 */

    case 94:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       fix_trunc_cvt)))
        return -1;
      return 4335; /* fix_truncv64dfv64df2 */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4347; /* fix_truncv2hfv2hi2 */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4359; /* fix_truncv2sfv2hi2 */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4371; /* fix_truncv2dfv2hi2 */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4383; /* fix_truncv2hfv2si2 */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4395; /* fix_truncv2sfv2si2 */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4407; /* fix_truncv2dfv2si2 */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4419; /* fix_truncv4hfv4hi2 */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4431; /* fix_truncv4sfv4hi2 */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4443; /* fix_truncv4dfv4hi2 */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4455; /* fix_truncv4hfv4si2 */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4467; /* fix_truncv4sfv4si2 */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4479; /* fix_truncv4dfv4si2 */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4491; /* fix_truncv8hfv8hi2 */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4503; /* fix_truncv8sfv8hi2 */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4515; /* fix_truncv8dfv8hi2 */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4527; /* fix_truncv8hfv8si2 */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4539; /* fix_truncv8sfv8si2 */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4551; /* fix_truncv8dfv8si2 */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4563; /* fix_truncv16hfv16hi2 */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4575; /* fix_truncv16sfv16hi2 */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4587; /* fix_truncv16dfv16hi2 */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4599; /* fix_truncv16hfv16si2 */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4611; /* fix_truncv16sfv16si2 */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4623; /* fix_truncv16dfv16si2 */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4635; /* fix_truncv32hfv32hi2 */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4647; /* fix_truncv32sfv32hi2 */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4659; /* fix_truncv32dfv32hi2 */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4671; /* fix_truncv32hfv32si2 */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4683; /* fix_truncv32sfv32si2 */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4695; /* fix_truncv32dfv32si2 */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4707; /* fix_truncv64hfv64hi2 */

    case 126:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4719; /* fix_truncv64sfv64hi2 */

    case 127:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       fix_trunc_cvt)))
        return -1;
      return 4731; /* fix_truncv64dfv64hi2 */

    case 128:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4743; /* fix_truncv64hfv64si2 */

    case 129:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4755; /* fix_truncv64sfv64si2 */

    case 130:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       fix_trunc_cvt)))
        return -1;
      return 4767; /* fix_truncv64dfv64si2 */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!gcn_fp_compare_operator (operands[1], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER
      || !register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x4, 0);
  operands[4] = x6;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x7;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!gcn_alu_operand (operands[2], E_V2HImode)
              || !gcn_vop3_operand (operands[3], E_V2HImode))
            return -1;
          return 8775; /* vec_cmpv2hidi */

        case E_V2HFmode:
          if (!gcn_alu_operand (operands[2], E_V2HFmode)
              || !gcn_vop3_operand (operands[3], E_V2HFmode))
            return -1;
          return 8776; /* vec_cmpv2hfdi */

        case E_V2SImode:
          if (!gcn_alu_operand (operands[2], E_V2SImode)
              || !gcn_vop3_operand (operands[3], E_V2SImode))
            return -1;
          return 8777; /* vec_cmpv2sidi */

        case E_V2SFmode:
          if (!gcn_alu_operand (operands[2], E_V2SFmode)
              || !gcn_vop3_operand (operands[3], E_V2SFmode))
            return -1;
          return 8778; /* vec_cmpv2sfdi */

        case E_V2DImode:
          if (!gcn_alu_operand (operands[2], E_V2DImode)
              || !gcn_vop3_operand (operands[3], E_V2DImode))
            return -1;
          return 8779; /* vec_cmpv2didi */

        case E_V2DFmode:
          if (!gcn_alu_operand (operands[2], E_V2DFmode)
              || !gcn_vop3_operand (operands[3], E_V2DFmode))
            return -1;
          return 8780; /* vec_cmpv2dfdi */

        case E_V4HImode:
          if (!gcn_alu_operand (operands[2], E_V4HImode)
              || !gcn_vop3_operand (operands[3], E_V4HImode))
            return -1;
          return 8781; /* vec_cmpv4hidi */

        case E_V4HFmode:
          if (!gcn_alu_operand (operands[2], E_V4HFmode)
              || !gcn_vop3_operand (operands[3], E_V4HFmode))
            return -1;
          return 8782; /* vec_cmpv4hfdi */

        case E_V4SImode:
          if (!gcn_alu_operand (operands[2], E_V4SImode)
              || !gcn_vop3_operand (operands[3], E_V4SImode))
            return -1;
          return 8783; /* vec_cmpv4sidi */

        case E_V4SFmode:
          if (!gcn_alu_operand (operands[2], E_V4SFmode)
              || !gcn_vop3_operand (operands[3], E_V4SFmode))
            return -1;
          return 8784; /* vec_cmpv4sfdi */

        case E_V4DImode:
          if (!gcn_alu_operand (operands[2], E_V4DImode)
              || !gcn_vop3_operand (operands[3], E_V4DImode))
            return -1;
          return 8785; /* vec_cmpv4didi */

        case E_V4DFmode:
          if (!gcn_alu_operand (operands[2], E_V4DFmode)
              || !gcn_vop3_operand (operands[3], E_V4DFmode))
            return -1;
          return 8786; /* vec_cmpv4dfdi */

        case E_V8HImode:
          if (!gcn_alu_operand (operands[2], E_V8HImode)
              || !gcn_vop3_operand (operands[3], E_V8HImode))
            return -1;
          return 8787; /* vec_cmpv8hidi */

        case E_V8HFmode:
          if (!gcn_alu_operand (operands[2], E_V8HFmode)
              || !gcn_vop3_operand (operands[3], E_V8HFmode))
            return -1;
          return 8788; /* vec_cmpv8hfdi */

        case E_V8SImode:
          if (!gcn_alu_operand (operands[2], E_V8SImode)
              || !gcn_vop3_operand (operands[3], E_V8SImode))
            return -1;
          return 8789; /* vec_cmpv8sidi */

        case E_V8SFmode:
          if (!gcn_alu_operand (operands[2], E_V8SFmode)
              || !gcn_vop3_operand (operands[3], E_V8SFmode))
            return -1;
          return 8790; /* vec_cmpv8sfdi */

        case E_V8DImode:
          if (!gcn_alu_operand (operands[2], E_V8DImode)
              || !gcn_vop3_operand (operands[3], E_V8DImode))
            return -1;
          return 8791; /* vec_cmpv8didi */

        case E_V8DFmode:
          if (!gcn_alu_operand (operands[2], E_V8DFmode)
              || !gcn_vop3_operand (operands[3], E_V8DFmode))
            return -1;
          return 8792; /* vec_cmpv8dfdi */

        case E_V16HImode:
          if (!gcn_alu_operand (operands[2], E_V16HImode)
              || !gcn_vop3_operand (operands[3], E_V16HImode))
            return -1;
          return 8793; /* vec_cmpv16hidi */

        case E_V16HFmode:
          if (!gcn_alu_operand (operands[2], E_V16HFmode)
              || !gcn_vop3_operand (operands[3], E_V16HFmode))
            return -1;
          return 8794; /* vec_cmpv16hfdi */

        case E_V16SImode:
          if (!gcn_alu_operand (operands[2], E_V16SImode)
              || !gcn_vop3_operand (operands[3], E_V16SImode))
            return -1;
          return 8795; /* vec_cmpv16sidi */

        case E_V16SFmode:
          if (!gcn_alu_operand (operands[2], E_V16SFmode)
              || !gcn_vop3_operand (operands[3], E_V16SFmode))
            return -1;
          return 8796; /* vec_cmpv16sfdi */

        case E_V16DImode:
          if (!gcn_alu_operand (operands[2], E_V16DImode)
              || !gcn_vop3_operand (operands[3], E_V16DImode))
            return -1;
          return 8797; /* vec_cmpv16didi */

        case E_V16DFmode:
          if (!gcn_alu_operand (operands[2], E_V16DFmode)
              || !gcn_vop3_operand (operands[3], E_V16DFmode))
            return -1;
          return 8798; /* vec_cmpv16dfdi */

        case E_V32HImode:
          if (!gcn_alu_operand (operands[2], E_V32HImode)
              || !gcn_vop3_operand (operands[3], E_V32HImode))
            return -1;
          return 8799; /* vec_cmpv32hidi */

        case E_V32HFmode:
          if (!gcn_alu_operand (operands[2], E_V32HFmode)
              || !gcn_vop3_operand (operands[3], E_V32HFmode))
            return -1;
          return 8800; /* vec_cmpv32hfdi */

        case E_V32SImode:
          if (!gcn_alu_operand (operands[2], E_V32SImode)
              || !gcn_vop3_operand (operands[3], E_V32SImode))
            return -1;
          return 8801; /* vec_cmpv32sidi */

        case E_V32SFmode:
          if (!gcn_alu_operand (operands[2], E_V32SFmode)
              || !gcn_vop3_operand (operands[3], E_V32SFmode))
            return -1;
          return 8802; /* vec_cmpv32sfdi */

        case E_V32DImode:
          if (!gcn_alu_operand (operands[2], E_V32DImode)
              || !gcn_vop3_operand (operands[3], E_V32DImode))
            return -1;
          return 8803; /* vec_cmpv32didi */

        case E_V32DFmode:
          if (!gcn_alu_operand (operands[2], E_V32DFmode)
              || !gcn_vop3_operand (operands[3], E_V32DFmode))
            return -1;
          return 8804; /* vec_cmpv32dfdi */

        case E_V64HImode:
          if (!gcn_alu_operand (operands[2], E_V64HImode)
              || !gcn_vop3_operand (operands[3], E_V64HImode))
            return -1;
          return 8805; /* vec_cmpv64hidi */

        case E_V64HFmode:
          if (!gcn_alu_operand (operands[2], E_V64HFmode)
              || !gcn_vop3_operand (operands[3], E_V64HFmode))
            return -1;
          return 8806; /* vec_cmpv64hfdi */

        case E_V64SImode:
          if (!gcn_alu_operand (operands[2], E_V64SImode)
              || !gcn_vop3_operand (operands[3], E_V64SImode))
            return -1;
          return 8807; /* vec_cmpv64sidi */

        case E_V64SFmode:
          if (!gcn_alu_operand (operands[2], E_V64SFmode)
              || !gcn_vop3_operand (operands[3], E_V64SFmode))
            return -1;
          return 8808; /* vec_cmpv64sfdi */

        case E_V64DImode:
          if (!gcn_alu_operand (operands[2], E_V64DImode)
              || !gcn_vop3_operand (operands[3], E_V64DImode))
            return -1;
          return 8809; /* vec_cmpv64didi */

        case E_V64DFmode:
          if (!gcn_alu_operand (operands[2], E_V64DFmode)
              || !gcn_vop3_operand (operands[3], E_V64DFmode))
            return -1;
          return 8810; /* vec_cmpv64dfdi */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (x7))
        {
        case E_V2HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V2HImode))
            return -1;
          return 8847; /* vec_cmpv2hidi_dup */

        case E_V2HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V2HFmode))
            return -1;
          return 8848; /* vec_cmpv2hfdi_dup */

        case E_V2SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V2SImode))
            return -1;
          return 8849; /* vec_cmpv2sidi_dup */

        case E_V2SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V2SFmode))
            return -1;
          return 8850; /* vec_cmpv2sfdi_dup */

        case E_V2DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V2DImode))
            return -1;
          return 8851; /* vec_cmpv2didi_dup */

        case E_V2DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V2DFmode))
            return -1;
          return 8852; /* vec_cmpv2dfdi_dup */

        case E_V4HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V4HImode))
            return -1;
          return 8853; /* vec_cmpv4hidi_dup */

        case E_V4HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V4HFmode))
            return -1;
          return 8854; /* vec_cmpv4hfdi_dup */

        case E_V4SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V4SImode))
            return -1;
          return 8855; /* vec_cmpv4sidi_dup */

        case E_V4SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V4SFmode))
            return -1;
          return 8856; /* vec_cmpv4sfdi_dup */

        case E_V4DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V4DImode))
            return -1;
          return 8857; /* vec_cmpv4didi_dup */

        case E_V4DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V4DFmode))
            return -1;
          return 8858; /* vec_cmpv4dfdi_dup */

        case E_V8HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V8HImode))
            return -1;
          return 8859; /* vec_cmpv8hidi_dup */

        case E_V8HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V8HFmode))
            return -1;
          return 8860; /* vec_cmpv8hfdi_dup */

        case E_V8SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V8SImode))
            return -1;
          return 8861; /* vec_cmpv8sidi_dup */

        case E_V8SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V8SFmode))
            return -1;
          return 8862; /* vec_cmpv8sfdi_dup */

        case E_V8DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V8DImode))
            return -1;
          return 8863; /* vec_cmpv8didi_dup */

        case E_V8DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V8DFmode))
            return -1;
          return 8864; /* vec_cmpv8dfdi_dup */

        case E_V16HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V16HImode))
            return -1;
          return 8865; /* vec_cmpv16hidi_dup */

        case E_V16HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V16HFmode))
            return -1;
          return 8866; /* vec_cmpv16hfdi_dup */

        case E_V16SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V16SImode))
            return -1;
          return 8867; /* vec_cmpv16sidi_dup */

        case E_V16SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V16SFmode))
            return -1;
          return 8868; /* vec_cmpv16sfdi_dup */

        case E_V16DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V16DImode))
            return -1;
          return 8869; /* vec_cmpv16didi_dup */

        case E_V16DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V16DFmode))
            return -1;
          return 8870; /* vec_cmpv16dfdi_dup */

        case E_V32HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V32HImode))
            return -1;
          return 8871; /* vec_cmpv32hidi_dup */

        case E_V32HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V32HFmode))
            return -1;
          return 8872; /* vec_cmpv32hfdi_dup */

        case E_V32SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V32SImode))
            return -1;
          return 8873; /* vec_cmpv32sidi_dup */

        case E_V32SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V32SFmode))
            return -1;
          return 8874; /* vec_cmpv32sfdi_dup */

        case E_V32DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V32DImode))
            return -1;
          return 8875; /* vec_cmpv32didi_dup */

        case E_V32DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V32DFmode))
            return -1;
          return 8876; /* vec_cmpv32dfdi_dup */

        case E_V64HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V64HImode))
            return -1;
          return 8877; /* vec_cmpv64hidi_dup */

        case E_V64HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V64HFmode))
            return -1;
          return 8878; /* vec_cmpv64hfdi_dup */

        case E_V64SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V64SImode))
            return -1;
          return 8879; /* vec_cmpv64sidi_dup */

        case E_V64SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V64SFmode))
            return -1;
          return 8880; /* vec_cmpv64sfdi_dup */

        case E_V64DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V64DImode))
            return -1;
          return 8881; /* vec_cmpv64didi_dup */

        case E_V64DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V64DFmode))
            return -1;
          return 8882; /* vec_cmpv64dfdi_dup */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64DImode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64DImode)
      && general_operand (operands[1], E_V64DImode))
    return gen_split_68 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64DImode)
      || !memory_operand (operands[1], E_V64DImode))
    return NULL;
  return gen_split_164 (insn, operands);
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64SImode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64SImode)
      && general_operand (operands[1], E_V64SImode))
    return gen_split_66 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64SImode)
      || !memory_operand (operands[1], E_V64SImode))
    return NULL;
  return gen_split_162 (insn, operands);
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64HImode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64HImode)
      && general_operand (operands[1], E_V64HImode))
    return gen_split_64 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64HImode)
      || !memory_operand (operands[1], E_V64HImode))
    return NULL;
  return gen_split_160 (insn, operands);
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32TImode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32TImode)
      && general_operand (operands[1], E_V32TImode))
    return gen_split_62 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32TImode)
      || !memory_operand (operands[1], E_V32TImode))
    return NULL;
  return gen_split_158 (insn, operands);
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32SFmode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32SFmode)
      && general_operand (operands[1], E_V32SFmode))
    return gen_split_59 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32SFmode)
      || !memory_operand (operands[1], E_V32SFmode))
    return NULL;
  return gen_split_155 (insn, operands);
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 3)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (GET_MODE (x3) != E_V2QImode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2QImode)
          && general_operand (operands[1], E_V2QImode))
        return gen_split_23 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !memory_operand (operands[1], E_V2QImode))
        return NULL;
      return gen_split_119 (insn, operands);

    case E_V2HImode:
      if (GET_MODE (x3) != E_V2HImode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2HImode)
          && general_operand (operands[1], E_V2HImode))
        return gen_split_24 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !memory_operand (operands[1], E_V2HImode))
        return NULL;
      return gen_split_120 (insn, operands);

    case E_V2HFmode:
      if (GET_MODE (x3) != E_V2HFmode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2HFmode)
          && general_operand (operands[1], E_V2HFmode))
        return gen_split_25 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2HFmode)
          || !memory_operand (operands[1], E_V2HFmode))
        return NULL;
      return gen_split_121 (insn, operands);

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode))
        return gen_split_26 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !memory_operand (operands[1], E_V2SImode))
        return NULL;
      return gen_split_122 (insn, operands);

    case E_V2SFmode:
      if (GET_MODE (x3) != E_V2SFmode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2SFmode)
          && general_operand (operands[1], E_V2SFmode))
        return gen_split_27 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !memory_operand (operands[1], E_V2SFmode))
        return NULL;
      return gen_split_123 (insn, operands);

    case E_V2DImode:
      if (GET_MODE (x3) != E_V2DImode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        return gen_split_28 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return NULL;
      return gen_split_124 (insn, operands);

    case E_V2DFmode:
      if (GET_MODE (x3) != E_V2DFmode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        return gen_split_29 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return NULL;
      return gen_split_125 (insn, operands);

    case E_V2TImode:
      if (GET_MODE (x3) != E_V2TImode
          || !scratch_operand (operands[2], E_V2DImode))
        return NULL;
      if (memory_operand (operands[0], E_V2TImode)
          && general_operand (operands[1], E_V2TImode))
        return gen_split_30 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !memory_operand (operands[1], E_V2TImode))
        return NULL;
      return gen_split_126 (insn, operands);

    case E_V4QImode:
      if (GET_MODE (x3) != E_V4QImode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4QImode)
          && general_operand (operands[1], E_V4QImode))
        return gen_split_31 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !memory_operand (operands[1], E_V4QImode))
        return NULL;
      return gen_split_127 (insn, operands);

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode))
        return gen_split_32 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !memory_operand (operands[1], E_V4HImode))
        return NULL;
      return gen_split_128 (insn, operands);

    case E_V4HFmode:
      if (GET_MODE (x3) != E_V4HFmode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4HFmode)
          && general_operand (operands[1], E_V4HFmode))
        return gen_split_33 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !memory_operand (operands[1], E_V4HFmode))
        return NULL;
      return gen_split_129 (insn, operands);

    case E_V4SImode:
      if (GET_MODE (x3) != E_V4SImode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        return gen_split_34 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return NULL;
      return gen_split_130 (insn, operands);

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        return gen_split_35 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return NULL;
      return gen_split_131 (insn, operands);

    case E_V4DImode:
      if (GET_MODE (x3) != E_V4DImode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4DImode)
          && general_operand (operands[1], E_V4DImode))
        return gen_split_36 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4DImode)
          || !memory_operand (operands[1], E_V4DImode))
        return NULL;
      return gen_split_132 (insn, operands);

    case E_V4DFmode:
      if (GET_MODE (x3) != E_V4DFmode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4DFmode)
          && general_operand (operands[1], E_V4DFmode))
        return gen_split_37 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !memory_operand (operands[1], E_V4DFmode))
        return NULL;
      return gen_split_133 (insn, operands);

    case E_V4TImode:
      if (GET_MODE (x3) != E_V4TImode
          || !scratch_operand (operands[2], E_V4DImode))
        return NULL;
      if (memory_operand (operands[0], E_V4TImode)
          && general_operand (operands[1], E_V4TImode))
        return gen_split_38 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V4TImode)
          || !memory_operand (operands[1], E_V4TImode))
        return NULL;
      return gen_split_134 (insn, operands);

    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8QImode)
          && general_operand (operands[1], E_V8QImode))
        return gen_split_39 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !memory_operand (operands[1], E_V8QImode))
        return NULL;
      return gen_split_135 (insn, operands);

    case E_V8HImode:
      if (GET_MODE (x3) != E_V8HImode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        return gen_split_40 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return NULL;
      return gen_split_136 (insn, operands);

    case E_V8HFmode:
      if (GET_MODE (x3) != E_V8HFmode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8HFmode)
          && general_operand (operands[1], E_V8HFmode))
        return gen_split_41 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !memory_operand (operands[1], E_V8HFmode))
        return NULL;
      return gen_split_137 (insn, operands);

    case E_V8SImode:
      if (GET_MODE (x3) != E_V8SImode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8SImode)
          && general_operand (operands[1], E_V8SImode))
        return gen_split_42 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || !memory_operand (operands[1], E_V8SImode))
        return NULL;
      return gen_split_138 (insn, operands);

    case E_V8SFmode:
      if (GET_MODE (x3) != E_V8SFmode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8SFmode)
          && general_operand (operands[1], E_V8SFmode))
        return gen_split_43 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !memory_operand (operands[1], E_V8SFmode))
        return NULL;
      return gen_split_139 (insn, operands);

    case E_V8DImode:
      if (GET_MODE (x3) != E_V8DImode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8DImode)
          && general_operand (operands[1], E_V8DImode))
        return gen_split_44 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8DImode)
          || !memory_operand (operands[1], E_V8DImode))
        return NULL;
      return gen_split_140 (insn, operands);

    case E_V8DFmode:
      if (GET_MODE (x3) != E_V8DFmode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8DFmode)
          && general_operand (operands[1], E_V8DFmode))
        return gen_split_45 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !memory_operand (operands[1], E_V8DFmode))
        return NULL;
      return gen_split_141 (insn, operands);

    case E_V8TImode:
      if (GET_MODE (x3) != E_V8TImode
          || !scratch_operand (operands[2], E_V8DImode))
        return NULL;
      if (memory_operand (operands[0], E_V8TImode)
          && general_operand (operands[1], E_V8TImode))
        return gen_split_46 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V8TImode)
          || !memory_operand (operands[1], E_V8TImode))
        return NULL;
      return gen_split_142 (insn, operands);

    case E_V16QImode:
      if (GET_MODE (x3) != E_V16QImode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        return gen_split_47 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return NULL;
      return gen_split_143 (insn, operands);

    case E_V16HImode:
      if (GET_MODE (x3) != E_V16HImode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16HImode)
          && general_operand (operands[1], E_V16HImode))
        return gen_split_48 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || !memory_operand (operands[1], E_V16HImode))
        return NULL;
      return gen_split_144 (insn, operands);

    case E_V16HFmode:
      if (GET_MODE (x3) != E_V16HFmode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16HFmode)
          && general_operand (operands[1], E_V16HFmode))
        return gen_split_49 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !memory_operand (operands[1], E_V16HFmode))
        return NULL;
      return gen_split_145 (insn, operands);

    case E_V16SImode:
      if (GET_MODE (x3) != E_V16SImode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16SImode)
          && general_operand (operands[1], E_V16SImode))
        return gen_split_50 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16SImode)
          || !memory_operand (operands[1], E_V16SImode))
        return NULL;
      return gen_split_146 (insn, operands);

    case E_V16SFmode:
      if (GET_MODE (x3) != E_V16SFmode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16SFmode)
          && general_operand (operands[1], E_V16SFmode))
        return gen_split_51 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !memory_operand (operands[1], E_V16SFmode))
        return NULL;
      return gen_split_147 (insn, operands);

    case E_V16DImode:
      if (GET_MODE (x3) != E_V16DImode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16DImode)
          && general_operand (operands[1], E_V16DImode))
        return gen_split_52 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16DImode)
          || !memory_operand (operands[1], E_V16DImode))
        return NULL;
      return gen_split_148 (insn, operands);

    case E_V16DFmode:
      if (GET_MODE (x3) != E_V16DFmode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16DFmode)
          && general_operand (operands[1], E_V16DFmode))
        return gen_split_53 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16DFmode)
          || !memory_operand (operands[1], E_V16DFmode))
        return NULL;
      return gen_split_149 (insn, operands);

    case E_V16TImode:
      if (GET_MODE (x3) != E_V16TImode
          || !scratch_operand (operands[2], E_V16DImode))
        return NULL;
      if (memory_operand (operands[0], E_V16TImode)
          && general_operand (operands[1], E_V16TImode))
        return gen_split_54 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V16TImode)
          || !memory_operand (operands[1], E_V16TImode))
        return NULL;
      return gen_split_150 (insn, operands);

    case E_V32QImode:
      if (GET_MODE (x3) != E_V32QImode
          || !scratch_operand (operands[2], E_V32DImode))
        return NULL;
      if (memory_operand (operands[0], E_V32QImode)
          && general_operand (operands[1], E_V32QImode))
        return gen_split_55 (insn, operands);
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || !memory_operand (operands[1], E_V32QImode))
        return NULL;
      return gen_split_151 (insn, operands);

    case E_V32HImode:
      return split_17 (x1, insn);

    case E_V32HFmode:
      return split_16 (x1, insn);

    case E_V32SImode:
      return split_15 (x1, insn);

    case E_V32SFmode:
      return split_14 (x1, insn);

    case E_V32DImode:
      return split_13 (x1, insn);

    case E_V32DFmode:
      return split_12 (x1, insn);

    case E_V32TImode:
      return split_11 (x1, insn);

    case E_V64QImode:
      return split_10 (x1, insn);

    case E_V64HImode:
      return split_9 (x1, insn);

    case E_V64HFmode:
      return split_8 (x1, insn);

    case E_V64SImode:
      return split_7 (x1, insn);

    case E_V64SFmode:
      return split_6 (x1, insn);

    case E_V64DImode:
      return split_5 (x1, insn);

    case E_V64DFmode:
      return split_4 (x1, insn);

    case E_V64TImode:
      return split_3 (x1, insn);

    default:
      return NULL;
    }
}
