/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, pnum_clobbers); /* [-1, 0] */

    case E_V2SImode:
      if (pattern2 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern2 (x3, 
E_V8SImode) != 0)
        return -1;
      return 3;

    case E_V16SImode:
      if (pattern2 (x3, 
E_V16SImode) != 0)
        return -1;
      return 4;

    case E_V32SImode:
      if (pattern2 (x3, 
E_V32SImode) != 0)
        return -1;
      return 5;

    case E_V64SImode:
      if (pattern2 (x3, 
E_V64SImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V4DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V4DImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V8DImode) != 0)
        return -1;
      return 9;

    case E_V16DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V16DImode) != 0)
        return -1;
      return 10;

    case E_V32DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V32DImode) != 0)
        return -1;
      return 11;

    case E_V64DImode:
      if (pnum_clobbers == NULL
          || pattern1 (x3, 
E_V64DImode) != 0)
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern39 (x1, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern39 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern39 (x1, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16SImode:
      if (pattern39 (x1, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32SImode:
      if (pattern39 (x1, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64SImode:
      if (pattern39 (x1, 
E_V64SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_V4DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V4DImode) != 0)
        return -1;
      return 7;

    case E_V8DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V8DImode) != 0)
        return -1;
      return 8;

    case E_V16DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V16DImode) != 0)
        return -1;
      return 9;

    case E_V32DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V32DImode) != 0)
        return -1;
      return 10;

    case E_V64DImode:
      if (pnum_clobbers == NULL
          || pattern44 (x1, 
E_V64DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!gcn_alu_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!gcn_alu_operand (operands[1], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!gcn_alu_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1)
      || !gcn_exec_reg_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !gcn_alu_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !gcn_alu_operand (operands[1], E_V2SFmode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !gcn_alu_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !gcn_alu_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !gcn_alu_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !gcn_alu_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !gcn_alu_operand (operands[1], E_V16HFmode))
        return -1;
      return 6;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !gcn_alu_operand (operands[1], E_V16SFmode))
        return -1;
      return 7;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !gcn_alu_operand (operands[1], E_V32HFmode))
        return -1;
      return 8;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !gcn_alu_operand (operands[1], E_V32SFmode))
        return -1;
      return 9;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !gcn_alu_operand (operands[1], E_V64HFmode))
        return -1;
      return 10;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !gcn_alu_operand (operands[1], E_V64SFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    case E_V32DImode:
      if (!gcn_alu_operand (operands[1], E_V32DImode))
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          return pattern124 (x1, 
E_V2SImode, 
E_V2DImode); /* [-1, 0] */

        case E_V4DImode:
          if (pattern124 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern124 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 2;

        case E_V16DImode:
          if (pattern124 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 3;

        case E_V32DImode:
          if (pattern124 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 4;

        case E_V64DImode:
          if (pattern124 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern126 (x1);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      return 0;

    case E_V2HImode:
      return 1;

    case E_V2SImode:
      return 2;

    case E_V4QImode:
      return 3;

    case E_V4HImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V8QImode:
      return 6;

    case E_V8HImode:
      return 7;

    case E_V8SImode:
      return 8;

    case E_V16QImode:
      return 9;

    case E_V16HImode:
      return 10;

    case E_V16SImode:
      return 11;

    case E_V32QImode:
      return 12;

    case E_V32HImode:
      return 13;

    case E_V32SImode:
      return 14;

    case E_V64QImode:
      return 15;

    case E_V64HImode:
      return 16;

    case E_V64SImode:
      return 17;

    case E_V64DImode:
      return 18;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern162 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 106
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 1);
      operands[3] = x6;
      x7 = XEXP (x5, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          return 0;

        case E_V2HImode:
          return 1;

        case E_V2SImode:
          return 2;

        case E_V4QImode:
          return 3;

        case E_V4HImode:
          return 4;

        case E_V4SImode:
          return 5;

        case E_V8QImode:
          return 6;

        case E_V8HImode:
          return 7;

        case E_V8SImode:
          return 8;

        case E_V16QImode:
          return 9;

        case E_V16HImode:
          return 10;

        case E_V16SImode:
          return 11;

        case E_V32QImode:
          return 12;

        case E_V32HImode:
          return 13;

        case E_V32SImode:
          return 14;

        case E_V64QImode:
          return 15;

        case E_V64HImode:
          return 16;

        case E_V64SImode:
          return 17;

        case E_V2DImode:
          return 18;

        case E_V4DImode:
          return 19;

        case E_V8DImode:
          return 20;

        case E_V16DImode:
          return 21;

        case E_V32DImode:
          return 22;

        case E_V64DImode:
          return 23;

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != AND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != i2
          || GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x8, 1);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 126
          || GET_MODE (x11) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 1);
      operands[4] = x6;
      x7 = XEXP (x5, 2);
      operands[5] = x7;
      x3 = XEXP (x2, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x10, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x14 = XEXP (x9, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          return 24;

        case E_V4SImode:
          return 25;

        case E_V8SImode:
          return 26;

        case E_V16SImode:
          return 27;

        case E_V32SImode:
          return 28;

        case E_V64SImode:
          return 29;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V2QImode:
      if (!register_operand (operands[2], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      return 1;

    case E_V2HFmode:
      if (!register_operand (operands[2], E_V2HFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!register_operand (operands[2], E_V2SImode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      return 6;

    case E_V2TImode:
      if (!register_operand (operands[2], E_V2TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  return pattern222 (x2, 
E_V2DImode, 
E_V2SImode); /* [-1, 0] */
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V8DImode)
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V8SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern240 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_MERGE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_DUPLICATE)
    return -1;
  x8 = XEXP (x7, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x6, 1);
  if (GET_CODE (x9) != VEC_DUPLICATE)
    return -1;
  x10 = XEXP (x9, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 0);
  x12 = XEXP (x11, 1);
  x13 = XEXP (x12, 0);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 2);
  operands[3] = x15;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 35:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!gcn_alu_operand (operands[2], E_SImode))
        return -1;
      switch (pattern85 (x3))
        {
        case 0:
          return 2714; /* ldexphf3 */

        case 1:
          return 2715; /* ldexpsf3 */

        case 2:
          return 2716; /* ldexpdf3 */

        default:
          return -1;
        }

    case 39:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != PLUS)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!register_operand (operands[4], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern181 (x3, 
E_SFmode) != 0)
            return -1;
          return 3052; /* div_fmassf */

        case E_DFmode:
          if (pattern181 (x3, 
E_DFmode) != 0)
            return -1;
          return 3053; /* div_fmasdf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern88 (x2))
    {
    case 0:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8925; /* *ior_dpp_shr_v2qi */

    case 1:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8933; /* *ior_dpp_shr_v2hi */

    case 2:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8941; /* *ior_dpp_shr_v2si */

    case 3:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8949; /* *ior_dpp_shr_v2hf */

    case 4:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8957; /* *ior_dpp_shr_v2sf */

    case 5:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8965; /* *ior_dpp_shr_v4qi */

    case 6:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8973; /* *ior_dpp_shr_v4hi */

    case 7:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8981; /* *ior_dpp_shr_v4si */

    case 8:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8989; /* *ior_dpp_shr_v4hf */

    case 9:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8997; /* *ior_dpp_shr_v4sf */

    case 10:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9005; /* *ior_dpp_shr_v8qi */

    case 11:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9013; /* *ior_dpp_shr_v8hi */

    case 12:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9021; /* *ior_dpp_shr_v8si */

    case 13:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9029; /* *ior_dpp_shr_v8hf */

    case 14:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9037; /* *ior_dpp_shr_v8sf */

    case 15:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9045; /* *ior_dpp_shr_v16qi */

    case 16:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9053; /* *ior_dpp_shr_v16hi */

    case 17:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9061; /* *ior_dpp_shr_v16si */

    case 18:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9069; /* *ior_dpp_shr_v16hf */

    case 19:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9077; /* *ior_dpp_shr_v16sf */

    case 20:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9085; /* *ior_dpp_shr_v32qi */

    case 21:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9093; /* *ior_dpp_shr_v32hi */

    case 22:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9101; /* *ior_dpp_shr_v32si */

    case 23:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9109; /* *ior_dpp_shr_v32hf */

    case 24:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9117; /* *ior_dpp_shr_v32sf */

    case 25:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9125; /* *ior_dpp_shr_v64qi */

    case 26:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9133; /* *ior_dpp_shr_v64hi */

    case 27:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9141; /* *ior_dpp_shr_v64si */

    case 28:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9149; /* *ior_dpp_shr_v64hf */

    case 29:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9157; /* *ior_dpp_shr_v64sf */

    case 30:
      return 9161; /* *ior_dpp_shr_v2di */

    case 31:
      return 9165; /* *ior_dpp_shr_v4di */

    case 32:
      return 9169; /* *ior_dpp_shr_v8di */

    case 33:
      return 9173; /* *ior_dpp_shr_v16di */

    case 34:
      return 9177; /* *ior_dpp_shr_v32di */

    case 35:
      return 9181; /* *ior_dpp_shr_v64di */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      return recog_14 (x1, insn, pnum_clobbers);

    case 3:
      return recog_13 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x2, 1))
        {
        case 15:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          x4 = XVECEXP (x2, 0, 1);
          operands[2] = x4;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (pattern89 (x2))
            {
            case 0:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1236; /* dpp_movev2hf */

            case 1:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1237; /* dpp_movev2si */

            case 2:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1238; /* dpp_movev2sf */

            case 3:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1239; /* dpp_movev2di */

            case 4:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1240; /* dpp_movev2df */

            case 5:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1241; /* dpp_movev4hf */

            case 6:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1242; /* dpp_movev4si */

            case 7:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1243; /* dpp_movev4sf */

            case 8:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1244; /* dpp_movev4di */

            case 9:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1245; /* dpp_movev4df */

            case 10:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1246; /* dpp_movev8hf */

            case 11:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1247; /* dpp_movev8si */

            case 12:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1248; /* dpp_movev8sf */

            case 13:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1249; /* dpp_movev8di */

            case 14:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1250; /* dpp_movev8df */

            case 15:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1251; /* dpp_movev16hf */

            case 16:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1252; /* dpp_movev16si */

            case 17:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1253; /* dpp_movev16sf */

            case 18:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1254; /* dpp_movev16di */

            case 19:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1255; /* dpp_movev16df */

            case 20:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1256; /* dpp_movev32hf */

            case 21:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1257; /* dpp_movev32si */

            case 22:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1258; /* dpp_movev32sf */

            case 23:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1259; /* dpp_movev32di */

            case 24:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1260; /* dpp_movev32df */

            case 25:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1261; /* dpp_movev64hf */

            case 26:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1262; /* dpp_movev64si */

            case 27:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1263; /* dpp_movev64sf */

            case 28:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1264; /* dpp_movev64di */

            case 29:
              if (!
#line 1408 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 1265; /* dpp_movev64df */

            default:
              return -1;
            }

        case 35:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          x4 = XVECEXP (x2, 0, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern117 (x2, 
E_V2HFmode, 
E_V2SImode) != 0)
                return -1;
              return 2717; /* ldexpv2hf3 */

            case E_V2SFmode:
              if (pattern117 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
                return -1;
              return 2719; /* ldexpv2sf3 */

            case E_V2DFmode:
              if (pattern117 (x2, 
E_V2DFmode, 
E_V2SImode) != 0)
                return -1;
              return 2721; /* ldexpv2df3 */

            case E_V4HFmode:
              if (pattern117 (x2, 
E_V4HFmode, 
E_V4SImode) != 0)
                return -1;
              return 2723; /* ldexpv4hf3 */

            case E_V4SFmode:
              if (pattern117 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
                return -1;
              return 2725; /* ldexpv4sf3 */

            case E_V4DFmode:
              if (pattern117 (x2, 
E_V4DFmode, 
E_V4SImode) != 0)
                return -1;
              return 2727; /* ldexpv4df3 */

            case E_V8HFmode:
              if (pattern117 (x2, 
E_V8HFmode, 
E_V8SImode) != 0)
                return -1;
              return 2729; /* ldexpv8hf3 */

            case E_V8SFmode:
              if (pattern117 (x2, 
E_V8SFmode, 
E_V8SImode) != 0)
                return -1;
              return 2731; /* ldexpv8sf3 */

            case E_V8DFmode:
              if (pattern117 (x2, 
E_V8DFmode, 
E_V8SImode) != 0)
                return -1;
              return 2733; /* ldexpv8df3 */

            case E_V16HFmode:
              if (pattern117 (x2, 
E_V16HFmode, 
E_V16SImode) != 0)
                return -1;
              return 2735; /* ldexpv16hf3 */

            case E_V16SFmode:
              if (pattern117 (x2, 
E_V16SFmode, 
E_V16SImode) != 0)
                return -1;
              return 2737; /* ldexpv16sf3 */

            case E_V16DFmode:
              if (pattern117 (x2, 
E_V16DFmode, 
E_V16SImode) != 0)
                return -1;
              return 2739; /* ldexpv16df3 */

            case E_V32HFmode:
              if (pattern117 (x2, 
E_V32HFmode, 
E_V32SImode) != 0)
                return -1;
              return 2741; /* ldexpv32hf3 */

            case E_V32SFmode:
              if (pattern117 (x2, 
E_V32SFmode, 
E_V32SImode) != 0)
                return -1;
              return 2743; /* ldexpv32sf3 */

            case E_V32DFmode:
              if (pattern117 (x2, 
E_V32DFmode, 
E_V32SImode) != 0)
                return -1;
              return 2745; /* ldexpv32df3 */

            case E_V64HFmode:
              if (pattern117 (x2, 
E_V64HFmode, 
E_V64SImode) != 0)
                return -1;
              return 2747; /* ldexpv64hf3 */

            case E_V64SFmode:
              if (pattern117 (x2, 
E_V64SFmode, 
E_V64SImode) != 0)
                return -1;
              return 2749; /* ldexpv64sf3 */

            case E_V64DFmode:
              if (pattern117 (x2, 
E_V64DFmode, 
E_V64SImode) != 0)
                return -1;
              return 2751; /* ldexpv64df3 */

            default:
              return -1;
            }

        case 39:
          x3 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x3) != PLUS)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MULT)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          x4 = XVECEXP (x2, 0, 1);
          operands[4] = x4;
          if (!register_operand (operands[4], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern181 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 3054; /* div_fmasv2sf */

            case E_V2DFmode:
              if (pattern181 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 3056; /* div_fmasv2df */

            case E_V4SFmode:
              if (pattern181 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 3058; /* div_fmasv4sf */

            case E_V4DFmode:
              if (pattern181 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 3060; /* div_fmasv4df */

            case E_V8SFmode:
              if (pattern181 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 3062; /* div_fmasv8sf */

            case E_V8DFmode:
              if (pattern181 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 3064; /* div_fmasv8df */

            case E_V16SFmode:
              if (pattern181 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 3066; /* div_fmasv16sf */

            case E_V16DFmode:
              if (pattern181 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 3068; /* div_fmasv16df */

            case E_V32SFmode:
              if (pattern181 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 3070; /* div_fmasv32sf */

            case E_V32DFmode:
              if (pattern181 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 3072; /* div_fmasv32df */

            case E_V64SFmode:
              if (pattern181 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 3074; /* div_fmasv64sf */

            case E_V64DFmode:
              if (pattern181 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 3076; /* div_fmasv64df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (XINT (x2, 1))
        {
        case 16:
          switch (pattern89 (x2))
            {
            case 0:
              return 1266; /* dpp_swap_pairsv2hf */

            case 1:
              return 1267; /* dpp_swap_pairsv2si */

            case 2:
              return 1268; /* dpp_swap_pairsv2sf */

            case 3:
              return 1269; /* dpp_swap_pairsv2di */

            case 4:
              return 1270; /* dpp_swap_pairsv2df */

            case 5:
              return 1271; /* dpp_swap_pairsv4hf */

            case 6:
              return 1272; /* dpp_swap_pairsv4si */

            case 7:
              return 1273; /* dpp_swap_pairsv4sf */

            case 8:
              return 1274; /* dpp_swap_pairsv4di */

            case 9:
              return 1275; /* dpp_swap_pairsv4df */

            case 10:
              return 1276; /* dpp_swap_pairsv8hf */

            case 11:
              return 1277; /* dpp_swap_pairsv8si */

            case 12:
              return 1278; /* dpp_swap_pairsv8sf */

            case 13:
              return 1279; /* dpp_swap_pairsv8di */

            case 14:
              return 1280; /* dpp_swap_pairsv8df */

            case 15:
              return 1281; /* dpp_swap_pairsv16hf */

            case 16:
              return 1282; /* dpp_swap_pairsv16si */

            case 17:
              return 1283; /* dpp_swap_pairsv16sf */

            case 18:
              return 1284; /* dpp_swap_pairsv16di */

            case 19:
              return 1285; /* dpp_swap_pairsv16df */

            case 20:
              return 1286; /* dpp_swap_pairsv32hf */

            case 21:
              return 1287; /* dpp_swap_pairsv32si */

            case 22:
              return 1288; /* dpp_swap_pairsv32sf */

            case 23:
              return 1289; /* dpp_swap_pairsv32di */

            case 24:
              return 1290; /* dpp_swap_pairsv32df */

            case 25:
              return 1291; /* dpp_swap_pairsv64hf */

            case 26:
              return 1292; /* dpp_swap_pairsv64si */

            case 27:
              return 1293; /* dpp_swap_pairsv64sf */

            case 28:
              return 1294; /* dpp_swap_pairsv64di */

            case 29:
              return 1295; /* dpp_swap_pairsv64df */

            default:
              return -1;
            }

        case 17:
          switch (pattern89 (x2))
            {
            case 0:
              return 1296; /* dpp_distribute_evenv2hf */

            case 1:
              return 1297; /* dpp_distribute_evenv2si */

            case 2:
              return 1298; /* dpp_distribute_evenv2sf */

            case 3:
              return 1299; /* dpp_distribute_evenv2di */

            case 4:
              return 1300; /* dpp_distribute_evenv2df */

            case 5:
              return 1301; /* dpp_distribute_evenv4hf */

            case 6:
              return 1302; /* dpp_distribute_evenv4si */

            case 7:
              return 1303; /* dpp_distribute_evenv4sf */

            case 8:
              return 1304; /* dpp_distribute_evenv4di */

            case 9:
              return 1305; /* dpp_distribute_evenv4df */

            case 10:
              return 1306; /* dpp_distribute_evenv8hf */

            case 11:
              return 1307; /* dpp_distribute_evenv8si */

            case 12:
              return 1308; /* dpp_distribute_evenv8sf */

            case 13:
              return 1309; /* dpp_distribute_evenv8di */

            case 14:
              return 1310; /* dpp_distribute_evenv8df */

            case 15:
              return 1311; /* dpp_distribute_evenv16hf */

            case 16:
              return 1312; /* dpp_distribute_evenv16si */

            case 17:
              return 1313; /* dpp_distribute_evenv16sf */

            case 18:
              return 1314; /* dpp_distribute_evenv16di */

            case 19:
              return 1315; /* dpp_distribute_evenv16df */

            case 20:
              return 1316; /* dpp_distribute_evenv32hf */

            case 21:
              return 1317; /* dpp_distribute_evenv32si */

            case 22:
              return 1318; /* dpp_distribute_evenv32sf */

            case 23:
              return 1319; /* dpp_distribute_evenv32di */

            case 24:
              return 1320; /* dpp_distribute_evenv32df */

            case 25:
              return 1321; /* dpp_distribute_evenv64hf */

            case 26:
              return 1322; /* dpp_distribute_evenv64si */

            case 27:
              return 1323; /* dpp_distribute_evenv64sf */

            case 28:
              return 1324; /* dpp_distribute_evenv64di */

            case 29:
              return 1325; /* dpp_distribute_evenv64df */

            default:
              return -1;
            }

        case 29:
          switch (pattern90 (x2))
            {
            case 0:
              return 2538; /* floorv2hf2 */

            case 1:
              return 2542; /* floorv2sf2 */

            case 2:
              return 2546; /* floorv2df2 */

            case 3:
              return 2550; /* floorv4hf2 */

            case 4:
              return 2554; /* floorv4sf2 */

            case 5:
              return 2558; /* floorv4df2 */

            case 6:
              return 2562; /* floorv8hf2 */

            case 7:
              return 2566; /* floorv8sf2 */

            case 8:
              return 2570; /* floorv8df2 */

            case 9:
              return 2574; /* floorv16hf2 */

            case 10:
              return 2578; /* floorv16sf2 */

            case 11:
              return 2582; /* floorv16df2 */

            case 12:
              return 2586; /* floorv32hf2 */

            case 13:
              return 2590; /* floorv32sf2 */

            case 14:
              return 2594; /* floorv32df2 */

            case 15:
              return 2598; /* floorv64hf2 */

            case 16:
              return 2602; /* floorv64sf2 */

            case 17:
              return 2606; /* floorv64df2 */

            default:
              return -1;
            }

        case 30:
          switch (pattern90 (x2))
            {
            case 0:
              return 2540; /* ceilv2hf2 */

            case 1:
              return 2544; /* ceilv2sf2 */

            case 2:
              return 2548; /* ceilv2df2 */

            case 3:
              return 2552; /* ceilv4hf2 */

            case 4:
              return 2556; /* ceilv4sf2 */

            case 5:
              return 2560; /* ceilv4df2 */

            case 6:
              return 2564; /* ceilv8hf2 */

            case 7:
              return 2568; /* ceilv8sf2 */

            case 8:
              return 2572; /* ceilv8df2 */

            case 9:
              return 2576; /* ceilv16hf2 */

            case 10:
              return 2580; /* ceilv16sf2 */

            case 11:
              return 2584; /* ceilv16df2 */

            case 12:
              return 2588; /* ceilv32hf2 */

            case 13:
              return 2592; /* ceilv32sf2 */

            case 14:
              return 2596; /* ceilv32df2 */

            case 15:
              return 2600; /* ceilv64hf2 */

            case 16:
              return 2604; /* ceilv64sf2 */

            case 17:
              return 2608; /* ceilv64df2 */

            default:
              return -1;
            }

        case 33:
          switch (pattern91 (x2))
            {
            case 0:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2614; /* exp2v2hf2 */

            case 1:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2618; /* exp2v2sf2 */

            case 2:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2622; /* exp2v4hf2 */

            case 3:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2626; /* exp2v4sf2 */

            case 4:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2630; /* exp2v8hf2 */

            case 5:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2634; /* exp2v8sf2 */

            case 6:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2638; /* exp2v16hf2 */

            case 7:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2642; /* exp2v16sf2 */

            case 8:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2646; /* exp2v32hf2 */

            case 9:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2650; /* exp2v32sf2 */

            case 10:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2654; /* exp2v64hf2 */

            case 11:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2658; /* exp2v64sf2 */

            default:
              return -1;
            }

        case 34:
          switch (pattern91 (x2))
            {
            case 0:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2616; /* log2v2hf2 */

            case 1:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2620; /* log2v2sf2 */

            case 2:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2624; /* log2v4hf2 */

            case 3:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2628; /* log2v4sf2 */

            case 4:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2632; /* log2v8hf2 */

            case 5:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2636; /* log2v8sf2 */

            case 6:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2640; /* log2v16hf2 */

            case 7:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2644; /* log2v16sf2 */

            case 8:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2648; /* log2v32hf2 */

            case 9:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2652; /* log2v32sf2 */

            case 10:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2656; /* log2v64hf2 */

            case 11:
              if (!
#line 3132 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2660; /* log2v64sf2 */

            default:
              return -1;
            }

        case 31:
          switch (pattern91 (x2))
            {
            case 0:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2666; /* *sinv2hf2_insn */

            case 1:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2670; /* *sinv2sf2_insn */

            case 2:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2674; /* *sinv4hf2_insn */

            case 3:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2678; /* *sinv4sf2_insn */

            case 4:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2682; /* *sinv8hf2_insn */

            case 5:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2686; /* *sinv8sf2_insn */

            case 6:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2690; /* *sinv16hf2_insn */

            case 7:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2694; /* *sinv16sf2_insn */

            case 8:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2698; /* *sinv32hf2_insn */

            case 9:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2702; /* *sinv32sf2_insn */

            case 10:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2706; /* *sinv64hf2_insn */

            case 11:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2710; /* *sinv64sf2_insn */

            default:
              return -1;
            }

        case 32:
          switch (pattern91 (x2))
            {
            case 0:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2668; /* *cosv2hf2_insn */

            case 1:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2672; /* *cosv2sf2_insn */

            case 2:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2676; /* *cosv4hf2_insn */

            case 3:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2680; /* *cosv4sf2_insn */

            case 4:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2684; /* *cosv8hf2_insn */

            case 5:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2688; /* *cosv8sf2_insn */

            case 6:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2692; /* *cosv16hf2_insn */

            case 7:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2696; /* *cosv16sf2_insn */

            case 8:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2700; /* *cosv32hf2_insn */

            case 9:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2704; /* *cosv32sf2_insn */

            case 10:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2708; /* *cosv64hf2_insn */

            case 11:
              if (!
#line 3152 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 2712; /* *cosv64sf2_insn */

            default:
              return -1;
            }

        case 36:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x2) != E_V2SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2HFmode:
                  if (!gcn_alu_operand (operands[1], E_V2HFmode))
                    return -1;
                  return 2759; /* frexpv2hf_exp2 */

                case E_V2SFmode:
                  if (!gcn_alu_operand (operands[1], E_V2SFmode))
                    return -1;
                  return 2761; /* frexpv2sf_exp2 */

                case E_V2DFmode:
                  if (!gcn_alu_operand (operands[1], E_V2DFmode))
                    return -1;
                  return 2763; /* frexpv2df_exp2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x2) != E_V4SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (!gcn_alu_operand (operands[1], E_V4HFmode))
                    return -1;
                  return 2765; /* frexpv4hf_exp2 */

                case E_V4SFmode:
                  if (!gcn_alu_operand (operands[1], E_V4SFmode))
                    return -1;
                  return 2767; /* frexpv4sf_exp2 */

                case E_V4DFmode:
                  if (!gcn_alu_operand (operands[1], E_V4DFmode))
                    return -1;
                  return 2769; /* frexpv4df_exp2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x2) != E_V8SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (!gcn_alu_operand (operands[1], E_V8HFmode))
                    return -1;
                  return 2771; /* frexpv8hf_exp2 */

                case E_V8SFmode:
                  if (!gcn_alu_operand (operands[1], E_V8SFmode))
                    return -1;
                  return 2773; /* frexpv8sf_exp2 */

                case E_V8DFmode:
                  if (!gcn_alu_operand (operands[1], E_V8DFmode))
                    return -1;
                  return 2775; /* frexpv8df_exp2 */

                default:
                  return -1;
                }

            case E_V16SImode:
              if (!register_operand (operands[0], E_V16SImode)
                  || GET_MODE (x2) != E_V16SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16HFmode:
                  if (!gcn_alu_operand (operands[1], E_V16HFmode))
                    return -1;
                  return 2777; /* frexpv16hf_exp2 */

                case E_V16SFmode:
                  if (!gcn_alu_operand (operands[1], E_V16SFmode))
                    return -1;
                  return 2779; /* frexpv16sf_exp2 */

                case E_V16DFmode:
                  if (!gcn_alu_operand (operands[1], E_V16DFmode))
                    return -1;
                  return 2781; /* frexpv16df_exp2 */

                default:
                  return -1;
                }

            case E_V32SImode:
              if (!register_operand (operands[0], E_V32SImode)
                  || GET_MODE (x2) != E_V32SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V32HFmode:
                  if (!gcn_alu_operand (operands[1], E_V32HFmode))
                    return -1;
                  return 2783; /* frexpv32hf_exp2 */

                case E_V32SFmode:
                  if (!gcn_alu_operand (operands[1], E_V32SFmode))
                    return -1;
                  return 2785; /* frexpv32sf_exp2 */

                case E_V32DFmode:
                  if (!gcn_alu_operand (operands[1], E_V32DFmode))
                    return -1;
                  return 2787; /* frexpv32df_exp2 */

                default:
                  return -1;
                }

            case E_V64SImode:
              if (!register_operand (operands[0], E_V64SImode)
                  || GET_MODE (x2) != E_V64SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V64HFmode:
                  if (!gcn_alu_operand (operands[1], E_V64HFmode))
                    return -1;
                  return 2789; /* frexpv64hf_exp2 */

                case E_V64SFmode:
                  if (!gcn_alu_operand (operands[1], E_V64SFmode))
                    return -1;
                  return 2791; /* frexpv64sf_exp2 */

                case E_V64DFmode:
                  if (!gcn_alu_operand (operands[1], E_V64DFmode))
                    return -1;
                  return 2793; /* frexpv64df_exp2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 37:
          switch (pattern90 (x2))
            {
            case 0:
              return 2795; /* frexpv2hf_mant2 */

            case 1:
              return 2797; /* frexpv2sf_mant2 */

            case 2:
              return 2799; /* frexpv2df_mant2 */

            case 3:
              return 2801; /* frexpv4hf_mant2 */

            case 4:
              return 2803; /* frexpv4sf_mant2 */

            case 5:
              return 2805; /* frexpv4df_mant2 */

            case 6:
              return 2807; /* frexpv8hf_mant2 */

            case 7:
              return 2809; /* frexpv8sf_mant2 */

            case 8:
              return 2811; /* frexpv8df_mant2 */

            case 9:
              return 2813; /* frexpv16hf_mant2 */

            case 10:
              return 2815; /* frexpv16sf_mant2 */

            case 11:
              return 2817; /* frexpv16df_mant2 */

            case 12:
              return 2819; /* frexpv32hf_mant2 */

            case 13:
              return 2821; /* frexpv32sf_mant2 */

            case 14:
              return 2823; /* frexpv32df_mant2 */

            case 15:
              return 2825; /* frexpv64hf_mant2 */

            case 16:
              return 2827; /* frexpv64sf_mant2 */

            case 17:
              return 2829; /* frexpv64df_mant2 */

            default:
              return -1;
            }

        case 27:
          switch (pattern90 (x2))
            {
            case 0:
              return 2990; /* recipv2hf2 */

            case 1:
              return 2992; /* recipv2sf2 */

            case 2:
              return 2994; /* recipv2df2 */

            case 3:
              return 2996; /* recipv4hf2 */

            case 4:
              return 2998; /* recipv4sf2 */

            case 5:
              return 3000; /* recipv4df2 */

            case 6:
              return 3002; /* recipv8hf2 */

            case 7:
              return 3004; /* recipv8sf2 */

            case 8:
              return 3006; /* recipv8df2 */

            case 9:
              return 3008; /* recipv16hf2 */

            case 10:
              return 3010; /* recipv16sf2 */

            case 11:
              return 3012; /* recipv16df2 */

            case 12:
              return 3014; /* recipv32hf2 */

            case 13:
              return 3016; /* recipv32sf2 */

            case 14:
              return 3018; /* recipv32df2 */

            case 15:
              return 3020; /* recipv64hf2 */

            case 16:
              return 3022; /* recipv64sf2 */

            case 17:
              return 3024; /* recipv64df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern143 (x2, 
E_V16QImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5428; /* *truncv2qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7696; /* *truncv2qiv16qi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5432; /* *truncv2hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7702; /* *truncv2hiv16qi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5436; /* *truncv2siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7708; /* *truncv2siv16qi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5440; /* *truncv4qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7714; /* *truncv4qiv16qi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5444; /* *truncv4hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7720; /* *truncv4hiv16qi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5448; /* *truncv4siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7726; /* *truncv4siv16qi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5452; /* *truncv8qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7732; /* *truncv8qiv16qi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5456; /* *truncv8hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7738; /* *truncv8hiv16qi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5460; /* *truncv8siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7744; /* *truncv8siv16qi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5464; /* *truncv16qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7750; /* *truncv16qiv16qi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5468; /* *truncv16hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7756; /* *truncv16hiv16qi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5472; /* *truncv16siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7762; /* *truncv16siv16qi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5476; /* *truncv32qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7768; /* *truncv32qiv16qi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5480; /* *truncv32hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7774; /* *truncv32hiv16qi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5484; /* *truncv32siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7780; /* *truncv32siv16qi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5488; /* *truncv64qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7786; /* *truncv64qiv16qi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5492; /* *truncv64hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7792; /* *truncv64hiv16qi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5496; /* *truncv64siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7798; /* *truncv64siv16qi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V16DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V16QImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8694; /* truncv16div16qi2_exec */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern71 (x2))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4782; /* *zero_extendv2qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6726; /* *zero_extendv2qiv2qi_shift_exec */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4786; /* *zero_extendv2hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6732; /* *zero_extendv2hiv2qi_shift_exec */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4790; /* *zero_extendv2siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6738; /* *zero_extendv2siv2qi_shift_exec */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4794; /* *zero_extendv4qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6744; /* *zero_extendv4qiv2qi_shift_exec */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4798; /* *zero_extendv4hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6750; /* *zero_extendv4hiv2qi_shift_exec */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4802; /* *zero_extendv4siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6756; /* *zero_extendv4siv2qi_shift_exec */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4806; /* *zero_extendv8qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6762; /* *zero_extendv8qiv2qi_shift_exec */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4810; /* *zero_extendv8hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6768; /* *zero_extendv8hiv2qi_shift_exec */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4814; /* *zero_extendv8siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6774; /* *zero_extendv8siv2qi_shift_exec */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4818; /* *zero_extendv16qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6780; /* *zero_extendv16qiv2qi_shift_exec */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4822; /* *zero_extendv16hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6786; /* *zero_extendv16hiv2qi_shift_exec */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4826; /* *zero_extendv16siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6792; /* *zero_extendv16siv2qi_shift_exec */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4830; /* *zero_extendv32qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6798; /* *zero_extendv32qiv2qi_shift_exec */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4834; /* *zero_extendv32hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6804; /* *zero_extendv32hiv2qi_shift_exec */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4838; /* *zero_extendv32siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6810; /* *zero_extendv32siv2qi_shift_exec */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4842; /* *zero_extendv64qiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6816; /* *zero_extendv64qiv2qi_shift_exec */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4846; /* *zero_extendv64hiv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6822; /* *zero_extendv64hiv2qi_shift_exec */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4850; /* *zero_extendv64siv2qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6828; /* *zero_extendv64siv2qi_shift_exec */

    case 18:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4854; /* *zero_extendv2qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6834; /* *zero_extendv2qiv2hi_shift_exec */

    case 19:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4858; /* *zero_extendv2hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6840; /* *zero_extendv2hiv2hi_shift_exec */

    case 20:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4862; /* *zero_extendv2siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6846; /* *zero_extendv2siv2hi_shift_exec */

    case 21:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4866; /* *zero_extendv4qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6852; /* *zero_extendv4qiv2hi_shift_exec */

    case 22:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4870; /* *zero_extendv4hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6858; /* *zero_extendv4hiv2hi_shift_exec */

    case 23:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4874; /* *zero_extendv4siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6864; /* *zero_extendv4siv2hi_shift_exec */

    case 24:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4878; /* *zero_extendv8qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6870; /* *zero_extendv8qiv2hi_shift_exec */

    case 25:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4882; /* *zero_extendv8hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6876; /* *zero_extendv8hiv2hi_shift_exec */

    case 26:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4886; /* *zero_extendv8siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6882; /* *zero_extendv8siv2hi_shift_exec */

    case 27:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4890; /* *zero_extendv16qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6888; /* *zero_extendv16qiv2hi_shift_exec */

    case 28:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4894; /* *zero_extendv16hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6894; /* *zero_extendv16hiv2hi_shift_exec */

    case 29:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4898; /* *zero_extendv16siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6900; /* *zero_extendv16siv2hi_shift_exec */

    case 30:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4902; /* *zero_extendv32qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6906; /* *zero_extendv32qiv2hi_shift_exec */

    case 31:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4906; /* *zero_extendv32hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6912; /* *zero_extendv32hiv2hi_shift_exec */

    case 32:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4910; /* *zero_extendv32siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6918; /* *zero_extendv32siv2hi_shift_exec */

    case 33:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4914; /* *zero_extendv64qiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6924; /* *zero_extendv64qiv2hi_shift_exec */

    case 34:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4918; /* *zero_extendv64hiv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6930; /* *zero_extendv64hiv2hi_shift_exec */

    case 35:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4922; /* *zero_extendv64siv2hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6936; /* *zero_extendv64siv2hi_shift_exec */

    case 36:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4926; /* *zero_extendv2qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6942; /* *zero_extendv2qiv2si_shift_exec */

    case 37:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4930; /* *zero_extendv2hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6948; /* *zero_extendv2hiv2si_shift_exec */

    case 38:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4934; /* *zero_extendv2siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6954; /* *zero_extendv2siv2si_shift_exec */

    case 39:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4938; /* *zero_extendv4qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6960; /* *zero_extendv4qiv2si_shift_exec */

    case 40:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4942; /* *zero_extendv4hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6966; /* *zero_extendv4hiv2si_shift_exec */

    case 41:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4946; /* *zero_extendv4siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6972; /* *zero_extendv4siv2si_shift_exec */

    case 42:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4950; /* *zero_extendv8qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6978; /* *zero_extendv8qiv2si_shift_exec */

    case 43:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4954; /* *zero_extendv8hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6984; /* *zero_extendv8hiv2si_shift_exec */

    case 44:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4958; /* *zero_extendv8siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6990; /* *zero_extendv8siv2si_shift_exec */

    case 45:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4962; /* *zero_extendv16qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6996; /* *zero_extendv16qiv2si_shift_exec */

    case 46:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4966; /* *zero_extendv16hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7002; /* *zero_extendv16hiv2si_shift_exec */

    case 47:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4970; /* *zero_extendv16siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7008; /* *zero_extendv16siv2si_shift_exec */

    case 48:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4974; /* *zero_extendv32qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7014; /* *zero_extendv32qiv2si_shift_exec */

    case 49:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4978; /* *zero_extendv32hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7020; /* *zero_extendv32hiv2si_shift_exec */

    case 50:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4982; /* *zero_extendv32siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7026; /* *zero_extendv32siv2si_shift_exec */

    case 51:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4986; /* *zero_extendv64qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7032; /* *zero_extendv64qiv2si_shift_exec */

    case 52:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4990; /* *zero_extendv64hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7038; /* *zero_extendv64hiv2si_shift_exec */

    case 53:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4994; /* *zero_extendv64siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7044; /* *zero_extendv64siv2si_shift_exec */

    case 54:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4998; /* *zero_extendv2qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7050; /* *zero_extendv2qiv4qi_shift_exec */

    case 55:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5002; /* *zero_extendv2hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7056; /* *zero_extendv2hiv4qi_shift_exec */

    case 56:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5006; /* *zero_extendv2siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7062; /* *zero_extendv2siv4qi_shift_exec */

    case 57:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5010; /* *zero_extendv4qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7068; /* *zero_extendv4qiv4qi_shift_exec */

    case 58:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5014; /* *zero_extendv4hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7074; /* *zero_extendv4hiv4qi_shift_exec */

    case 59:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5018; /* *zero_extendv4siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7080; /* *zero_extendv4siv4qi_shift_exec */

    case 60:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5022; /* *zero_extendv8qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7086; /* *zero_extendv8qiv4qi_shift_exec */

    case 61:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5026; /* *zero_extendv8hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7092; /* *zero_extendv8hiv4qi_shift_exec */

    case 62:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5030; /* *zero_extendv8siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7098; /* *zero_extendv8siv4qi_shift_exec */

    case 63:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5034; /* *zero_extendv16qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7104; /* *zero_extendv16qiv4qi_shift_exec */

    case 64:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5038; /* *zero_extendv16hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7110; /* *zero_extendv16hiv4qi_shift_exec */

    case 65:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5042; /* *zero_extendv16siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7116; /* *zero_extendv16siv4qi_shift_exec */

    case 66:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5046; /* *zero_extendv32qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7122; /* *zero_extendv32qiv4qi_shift_exec */

    case 67:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5050; /* *zero_extendv32hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7128; /* *zero_extendv32hiv4qi_shift_exec */

    case 68:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5054; /* *zero_extendv32siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7134; /* *zero_extendv32siv4qi_shift_exec */

    case 69:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5058; /* *zero_extendv64qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7140; /* *zero_extendv64qiv4qi_shift_exec */

    case 70:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5062; /* *zero_extendv64hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7146; /* *zero_extendv64hiv4qi_shift_exec */

    case 71:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5066; /* *zero_extendv64siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7152; /* *zero_extendv64siv4qi_shift_exec */

    case 72:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5070; /* *zero_extendv2qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7158; /* *zero_extendv2qiv4hi_shift_exec */

    case 73:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5074; /* *zero_extendv2hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7164; /* *zero_extendv2hiv4hi_shift_exec */

    case 74:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5078; /* *zero_extendv2siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7170; /* *zero_extendv2siv4hi_shift_exec */

    case 75:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5082; /* *zero_extendv4qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7176; /* *zero_extendv4qiv4hi_shift_exec */

    case 76:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5086; /* *zero_extendv4hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7182; /* *zero_extendv4hiv4hi_shift_exec */

    case 77:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5090; /* *zero_extendv4siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7188; /* *zero_extendv4siv4hi_shift_exec */

    case 78:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5094; /* *zero_extendv8qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7194; /* *zero_extendv8qiv4hi_shift_exec */

    case 79:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5098; /* *zero_extendv8hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7200; /* *zero_extendv8hiv4hi_shift_exec */

    case 80:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5102; /* *zero_extendv8siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7206; /* *zero_extendv8siv4hi_shift_exec */

    case 81:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5106; /* *zero_extendv16qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7212; /* *zero_extendv16qiv4hi_shift_exec */

    case 82:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5110; /* *zero_extendv16hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7218; /* *zero_extendv16hiv4hi_shift_exec */

    case 83:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5114; /* *zero_extendv16siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7224; /* *zero_extendv16siv4hi_shift_exec */

    case 84:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5118; /* *zero_extendv32qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7230; /* *zero_extendv32qiv4hi_shift_exec */

    case 85:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5122; /* *zero_extendv32hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7236; /* *zero_extendv32hiv4hi_shift_exec */

    case 86:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5126; /* *zero_extendv32siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7242; /* *zero_extendv32siv4hi_shift_exec */

    case 87:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5130; /* *zero_extendv64qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7248; /* *zero_extendv64qiv4hi_shift_exec */

    case 88:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5134; /* *zero_extendv64hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7254; /* *zero_extendv64hiv4hi_shift_exec */

    case 89:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5138; /* *zero_extendv64siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7260; /* *zero_extendv64siv4hi_shift_exec */

    case 90:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5142; /* *zero_extendv2qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7266; /* *zero_extendv2qiv4si_shift_exec */

    case 91:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5146; /* *zero_extendv2hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7272; /* *zero_extendv2hiv4si_shift_exec */

    case 92:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5150; /* *zero_extendv2siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7278; /* *zero_extendv2siv4si_shift_exec */

    case 93:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5154; /* *zero_extendv4qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7284; /* *zero_extendv4qiv4si_shift_exec */

    case 94:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5158; /* *zero_extendv4hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7290; /* *zero_extendv4hiv4si_shift_exec */

    case 95:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5162; /* *zero_extendv4siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7296; /* *zero_extendv4siv4si_shift_exec */

    case 96:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5166; /* *zero_extendv8qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7302; /* *zero_extendv8qiv4si_shift_exec */

    case 97:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5170; /* *zero_extendv8hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7308; /* *zero_extendv8hiv4si_shift_exec */

    case 98:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5174; /* *zero_extendv8siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7314; /* *zero_extendv8siv4si_shift_exec */

    case 99:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5178; /* *zero_extendv16qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7320; /* *zero_extendv16qiv4si_shift_exec */

    case 100:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5182; /* *zero_extendv16hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7326; /* *zero_extendv16hiv4si_shift_exec */

    case 101:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5186; /* *zero_extendv16siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7332; /* *zero_extendv16siv4si_shift_exec */

    case 102:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5190; /* *zero_extendv32qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7338; /* *zero_extendv32qiv4si_shift_exec */

    case 103:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5194; /* *zero_extendv32hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7344; /* *zero_extendv32hiv4si_shift_exec */

    case 104:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5198; /* *zero_extendv32siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7350; /* *zero_extendv32siv4si_shift_exec */

    case 105:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5202; /* *zero_extendv64qiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7356; /* *zero_extendv64qiv4si_shift_exec */

    case 106:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5206; /* *zero_extendv64hiv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7362; /* *zero_extendv64hiv4si_shift_exec */

    case 107:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5210; /* *zero_extendv64siv4si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7368; /* *zero_extendv64siv4si_shift_exec */

    case 108:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5214; /* *zero_extendv2qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7374; /* *zero_extendv2qiv8qi_shift_exec */

    case 109:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5218; /* *zero_extendv2hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7380; /* *zero_extendv2hiv8qi_shift_exec */

    case 110:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5222; /* *zero_extendv2siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7386; /* *zero_extendv2siv8qi_shift_exec */

    case 111:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5226; /* *zero_extendv4qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7392; /* *zero_extendv4qiv8qi_shift_exec */

    case 112:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5230; /* *zero_extendv4hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7398; /* *zero_extendv4hiv8qi_shift_exec */

    case 113:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5234; /* *zero_extendv4siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7404; /* *zero_extendv4siv8qi_shift_exec */

    case 114:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5238; /* *zero_extendv8qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7410; /* *zero_extendv8qiv8qi_shift_exec */

    case 115:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5242; /* *zero_extendv8hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7416; /* *zero_extendv8hiv8qi_shift_exec */

    case 116:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5246; /* *zero_extendv8siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7422; /* *zero_extendv8siv8qi_shift_exec */

    case 117:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5250; /* *zero_extendv16qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7428; /* *zero_extendv16qiv8qi_shift_exec */

    case 118:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5254; /* *zero_extendv16hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7434; /* *zero_extendv16hiv8qi_shift_exec */

    case 119:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5258; /* *zero_extendv16siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7440; /* *zero_extendv16siv8qi_shift_exec */

    case 120:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5262; /* *zero_extendv32qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7446; /* *zero_extendv32qiv8qi_shift_exec */

    case 121:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5266; /* *zero_extendv32hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7452; /* *zero_extendv32hiv8qi_shift_exec */

    case 122:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5270; /* *zero_extendv32siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7458; /* *zero_extendv32siv8qi_shift_exec */

    case 123:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5274; /* *zero_extendv64qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7464; /* *zero_extendv64qiv8qi_shift_exec */

    case 124:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5278; /* *zero_extendv64hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7470; /* *zero_extendv64hiv8qi_shift_exec */

    case 125:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5282; /* *zero_extendv64siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7476; /* *zero_extendv64siv8qi_shift_exec */

    case 126:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5286; /* *zero_extendv2qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7482; /* *zero_extendv2qiv8hi_shift_exec */

    case 127:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5290; /* *zero_extendv2hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7488; /* *zero_extendv2hiv8hi_shift_exec */

    case 128:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5294; /* *zero_extendv2siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7494; /* *zero_extendv2siv8hi_shift_exec */

    case 129:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5298; /* *zero_extendv4qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7500; /* *zero_extendv4qiv8hi_shift_exec */

    case 130:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5302; /* *zero_extendv4hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7506; /* *zero_extendv4hiv8hi_shift_exec */

    case 131:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5306; /* *zero_extendv4siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7512; /* *zero_extendv4siv8hi_shift_exec */

    case 132:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5310; /* *zero_extendv8qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7518; /* *zero_extendv8qiv8hi_shift_exec */

    case 133:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5314; /* *zero_extendv8hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7524; /* *zero_extendv8hiv8hi_shift_exec */

    case 134:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5318; /* *zero_extendv8siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7530; /* *zero_extendv8siv8hi_shift_exec */

    case 135:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5322; /* *zero_extendv16qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7536; /* *zero_extendv16qiv8hi_shift_exec */

    case 136:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5326; /* *zero_extendv16hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7542; /* *zero_extendv16hiv8hi_shift_exec */

    case 137:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5330; /* *zero_extendv16siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7548; /* *zero_extendv16siv8hi_shift_exec */

    case 138:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5334; /* *zero_extendv32qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7554; /* *zero_extendv32qiv8hi_shift_exec */

    case 139:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5338; /* *zero_extendv32hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7560; /* *zero_extendv32hiv8hi_shift_exec */

    case 140:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5342; /* *zero_extendv32siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7566; /* *zero_extendv32siv8hi_shift_exec */

    case 141:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5346; /* *zero_extendv64qiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7572; /* *zero_extendv64qiv8hi_shift_exec */

    case 142:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5350; /* *zero_extendv64hiv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7578; /* *zero_extendv64hiv8hi_shift_exec */

    case 143:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5354; /* *zero_extendv64siv8hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7584; /* *zero_extendv64siv8hi_shift_exec */

    case 144:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5358; /* *zero_extendv2qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7590; /* *zero_extendv2qiv8si_shift_exec */

    case 145:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5362; /* *zero_extendv2hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7596; /* *zero_extendv2hiv8si_shift_exec */

    case 146:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5366; /* *zero_extendv2siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7602; /* *zero_extendv2siv8si_shift_exec */

    case 147:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5370; /* *zero_extendv4qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7608; /* *zero_extendv4qiv8si_shift_exec */

    case 148:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5374; /* *zero_extendv4hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7614; /* *zero_extendv4hiv8si_shift_exec */

    case 149:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5378; /* *zero_extendv4siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7620; /* *zero_extendv4siv8si_shift_exec */

    case 150:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5382; /* *zero_extendv8qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7626; /* *zero_extendv8qiv8si_shift_exec */

    case 151:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5386; /* *zero_extendv8hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7632; /* *zero_extendv8hiv8si_shift_exec */

    case 152:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5390; /* *zero_extendv8siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7638; /* *zero_extendv8siv8si_shift_exec */

    case 153:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5394; /* *zero_extendv16qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7644; /* *zero_extendv16qiv8si_shift_exec */

    case 154:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5398; /* *zero_extendv16hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7650; /* *zero_extendv16hiv8si_shift_exec */

    case 155:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5402; /* *zero_extendv16siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7656; /* *zero_extendv16siv8si_shift_exec */

    case 156:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5406; /* *zero_extendv32qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7662; /* *zero_extendv32qiv8si_shift_exec */

    case 157:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5410; /* *zero_extendv32hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7668; /* *zero_extendv32hiv8si_shift_exec */

    case 158:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5414; /* *zero_extendv32siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7674; /* *zero_extendv32siv8si_shift_exec */

    case 159:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5418; /* *zero_extendv64qiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7680; /* *zero_extendv64qiv8si_shift_exec */

    case 160:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5422; /* *zero_extendv64hiv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7686; /* *zero_extendv64hiv8si_shift_exec */

    case 161:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5426; /* *zero_extendv64siv8si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7692; /* *zero_extendv64siv8si_shift_exec */

    case 162:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5430; /* *zero_extendv2qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7698; /* *zero_extendv2qiv16qi_shift_exec */

    case 163:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5434; /* *zero_extendv2hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7704; /* *zero_extendv2hiv16qi_shift_exec */

    case 164:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5438; /* *zero_extendv2siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7710; /* *zero_extendv2siv16qi_shift_exec */

    case 165:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5442; /* *zero_extendv4qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7716; /* *zero_extendv4qiv16qi_shift_exec */

    case 166:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5446; /* *zero_extendv4hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7722; /* *zero_extendv4hiv16qi_shift_exec */

    case 167:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5450; /* *zero_extendv4siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7728; /* *zero_extendv4siv16qi_shift_exec */

    case 168:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5454; /* *zero_extendv8qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7734; /* *zero_extendv8qiv16qi_shift_exec */

    case 169:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5458; /* *zero_extendv8hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7740; /* *zero_extendv8hiv16qi_shift_exec */

    case 170:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5462; /* *zero_extendv8siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7746; /* *zero_extendv8siv16qi_shift_exec */

    case 171:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5466; /* *zero_extendv16qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7752; /* *zero_extendv16qiv16qi_shift_exec */

    case 172:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5470; /* *zero_extendv16hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7758; /* *zero_extendv16hiv16qi_shift_exec */

    case 173:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5474; /* *zero_extendv16siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7764; /* *zero_extendv16siv16qi_shift_exec */

    case 174:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5478; /* *zero_extendv32qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7770; /* *zero_extendv32qiv16qi_shift_exec */

    case 175:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5482; /* *zero_extendv32hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7776; /* *zero_extendv32hiv16qi_shift_exec */

    case 176:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5486; /* *zero_extendv32siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7782; /* *zero_extendv32siv16qi_shift_exec */

    case 177:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5490; /* *zero_extendv64qiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7788; /* *zero_extendv64qiv16qi_shift_exec */

    case 178:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5494; /* *zero_extendv64hiv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7794; /* *zero_extendv64hiv16qi_shift_exec */

    case 179:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5498; /* *zero_extendv64siv16qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7800; /* *zero_extendv64siv16qi_shift_exec */

    case 180:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5502; /* *zero_extendv2qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7806; /* *zero_extendv2qiv16hi_shift_exec */

    case 181:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5506; /* *zero_extendv2hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7812; /* *zero_extendv2hiv16hi_shift_exec */

    case 182:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5510; /* *zero_extendv2siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7818; /* *zero_extendv2siv16hi_shift_exec */

    case 183:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5514; /* *zero_extendv4qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7824; /* *zero_extendv4qiv16hi_shift_exec */

    case 184:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5518; /* *zero_extendv4hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7830; /* *zero_extendv4hiv16hi_shift_exec */

    case 185:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5522; /* *zero_extendv4siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7836; /* *zero_extendv4siv16hi_shift_exec */

    case 186:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5526; /* *zero_extendv8qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7842; /* *zero_extendv8qiv16hi_shift_exec */

    case 187:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5530; /* *zero_extendv8hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7848; /* *zero_extendv8hiv16hi_shift_exec */

    case 188:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5534; /* *zero_extendv8siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7854; /* *zero_extendv8siv16hi_shift_exec */

    case 189:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5538; /* *zero_extendv16qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7860; /* *zero_extendv16qiv16hi_shift_exec */

    case 190:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5542; /* *zero_extendv16hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7866; /* *zero_extendv16hiv16hi_shift_exec */

    case 191:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5546; /* *zero_extendv16siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7872; /* *zero_extendv16siv16hi_shift_exec */

    case 192:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5550; /* *zero_extendv32qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7878; /* *zero_extendv32qiv16hi_shift_exec */

    case 193:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5554; /* *zero_extendv32hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7884; /* *zero_extendv32hiv16hi_shift_exec */

    case 194:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5558; /* *zero_extendv32siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7890; /* *zero_extendv32siv16hi_shift_exec */

    case 195:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5562; /* *zero_extendv64qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7896; /* *zero_extendv64qiv16hi_shift_exec */

    case 196:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5566; /* *zero_extendv64hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7902; /* *zero_extendv64hiv16hi_shift_exec */

    case 197:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5570; /* *zero_extendv64siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7908; /* *zero_extendv64siv16hi_shift_exec */

    case 198:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5574; /* *zero_extendv2qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7914; /* *zero_extendv2qiv16si_shift_exec */

    case 199:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5578; /* *zero_extendv2hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7920; /* *zero_extendv2hiv16si_shift_exec */

    case 200:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5582; /* *zero_extendv2siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7926; /* *zero_extendv2siv16si_shift_exec */

    case 201:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5586; /* *zero_extendv4qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7932; /* *zero_extendv4qiv16si_shift_exec */

    case 202:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5590; /* *zero_extendv4hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7938; /* *zero_extendv4hiv16si_shift_exec */

    case 203:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5594; /* *zero_extendv4siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7944; /* *zero_extendv4siv16si_shift_exec */

    case 204:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5598; /* *zero_extendv8qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7950; /* *zero_extendv8qiv16si_shift_exec */

    case 205:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5602; /* *zero_extendv8hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7956; /* *zero_extendv8hiv16si_shift_exec */

    case 206:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5606; /* *zero_extendv8siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7962; /* *zero_extendv8siv16si_shift_exec */

    case 207:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5610; /* *zero_extendv16qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7968; /* *zero_extendv16qiv16si_shift_exec */

    case 208:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5614; /* *zero_extendv16hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7974; /* *zero_extendv16hiv16si_shift_exec */

    case 209:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5618; /* *zero_extendv16siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7980; /* *zero_extendv16siv16si_shift_exec */

    case 210:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5622; /* *zero_extendv32qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7986; /* *zero_extendv32qiv16si_shift_exec */

    case 211:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5626; /* *zero_extendv32hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7992; /* *zero_extendv32hiv16si_shift_exec */

    case 212:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5630; /* *zero_extendv32siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7998; /* *zero_extendv32siv16si_shift_exec */

    case 213:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5634; /* *zero_extendv64qiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8004; /* *zero_extendv64qiv16si_shift_exec */

    case 214:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5638; /* *zero_extendv64hiv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8010; /* *zero_extendv64hiv16si_shift_exec */

    case 215:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5642; /* *zero_extendv64siv16si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8016; /* *zero_extendv64siv16si_shift_exec */

    case 216:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5646; /* *zero_extendv2qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8022; /* *zero_extendv2qiv32qi_shift_exec */

    case 217:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5650; /* *zero_extendv2hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8028; /* *zero_extendv2hiv32qi_shift_exec */

    case 218:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5654; /* *zero_extendv2siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8034; /* *zero_extendv2siv32qi_shift_exec */

    case 219:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5658; /* *zero_extendv4qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8040; /* *zero_extendv4qiv32qi_shift_exec */

    case 220:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5662; /* *zero_extendv4hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8046; /* *zero_extendv4hiv32qi_shift_exec */

    case 221:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5666; /* *zero_extendv4siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8052; /* *zero_extendv4siv32qi_shift_exec */

    case 222:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5670; /* *zero_extendv8qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8058; /* *zero_extendv8qiv32qi_shift_exec */

    case 223:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5674; /* *zero_extendv8hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8064; /* *zero_extendv8hiv32qi_shift_exec */

    case 224:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5678; /* *zero_extendv8siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8070; /* *zero_extendv8siv32qi_shift_exec */

    case 225:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5682; /* *zero_extendv16qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8076; /* *zero_extendv16qiv32qi_shift_exec */

    case 226:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5686; /* *zero_extendv16hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8082; /* *zero_extendv16hiv32qi_shift_exec */

    case 227:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5690; /* *zero_extendv16siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8088; /* *zero_extendv16siv32qi_shift_exec */

    case 228:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5694; /* *zero_extendv32qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8094; /* *zero_extendv32qiv32qi_shift_exec */

    case 229:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5698; /* *zero_extendv32hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8100; /* *zero_extendv32hiv32qi_shift_exec */

    case 230:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5702; /* *zero_extendv32siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8106; /* *zero_extendv32siv32qi_shift_exec */

    case 231:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5706; /* *zero_extendv64qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8112; /* *zero_extendv64qiv32qi_shift_exec */

    case 232:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5710; /* *zero_extendv64hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8118; /* *zero_extendv64hiv32qi_shift_exec */

    case 233:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5714; /* *zero_extendv64siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8124; /* *zero_extendv64siv32qi_shift_exec */

    case 234:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5718; /* *zero_extendv2qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8130; /* *zero_extendv2qiv32hi_shift_exec */

    case 235:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5722; /* *zero_extendv2hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8136; /* *zero_extendv2hiv32hi_shift_exec */

    case 236:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5726; /* *zero_extendv2siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8142; /* *zero_extendv2siv32hi_shift_exec */

    case 237:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5730; /* *zero_extendv4qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8148; /* *zero_extendv4qiv32hi_shift_exec */

    case 238:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5734; /* *zero_extendv4hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8154; /* *zero_extendv4hiv32hi_shift_exec */

    case 239:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5738; /* *zero_extendv4siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8160; /* *zero_extendv4siv32hi_shift_exec */

    case 240:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5742; /* *zero_extendv8qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8166; /* *zero_extendv8qiv32hi_shift_exec */

    case 241:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5746; /* *zero_extendv8hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8172; /* *zero_extendv8hiv32hi_shift_exec */

    case 242:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5750; /* *zero_extendv8siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8178; /* *zero_extendv8siv32hi_shift_exec */

    case 243:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5754; /* *zero_extendv16qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8184; /* *zero_extendv16qiv32hi_shift_exec */

    case 244:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5758; /* *zero_extendv16hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8190; /* *zero_extendv16hiv32hi_shift_exec */

    case 245:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5762; /* *zero_extendv16siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8196; /* *zero_extendv16siv32hi_shift_exec */

    case 246:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5766; /* *zero_extendv32qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8202; /* *zero_extendv32qiv32hi_shift_exec */

    case 247:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5770; /* *zero_extendv32hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8208; /* *zero_extendv32hiv32hi_shift_exec */

    case 248:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5774; /* *zero_extendv32siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8214; /* *zero_extendv32siv32hi_shift_exec */

    case 249:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5778; /* *zero_extendv64qiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8220; /* *zero_extendv64qiv32hi_shift_exec */

    case 250:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5782; /* *zero_extendv64hiv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8226; /* *zero_extendv64hiv32hi_shift_exec */

    case 251:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5786; /* *zero_extendv64siv32hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8232; /* *zero_extendv64siv32hi_shift_exec */

    case 252:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5790; /* *zero_extendv2qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8238; /* *zero_extendv2qiv32si_shift_exec */

    case 253:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5794; /* *zero_extendv2hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8244; /* *zero_extendv2hiv32si_shift_exec */

    case 254:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5798; /* *zero_extendv2siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8250; /* *zero_extendv2siv32si_shift_exec */

    case 255:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5802; /* *zero_extendv4qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8256; /* *zero_extendv4qiv32si_shift_exec */

    case 256:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5806; /* *zero_extendv4hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8262; /* *zero_extendv4hiv32si_shift_exec */

    case 257:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5810; /* *zero_extendv4siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8268; /* *zero_extendv4siv32si_shift_exec */

    case 258:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5814; /* *zero_extendv8qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8274; /* *zero_extendv8qiv32si_shift_exec */

    case 259:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5818; /* *zero_extendv8hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8280; /* *zero_extendv8hiv32si_shift_exec */

    case 260:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5822; /* *zero_extendv8siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8286; /* *zero_extendv8siv32si_shift_exec */

    case 261:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5826; /* *zero_extendv16qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8292; /* *zero_extendv16qiv32si_shift_exec */

    case 262:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5830; /* *zero_extendv16hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8298; /* *zero_extendv16hiv32si_shift_exec */

    case 263:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5834; /* *zero_extendv16siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8304; /* *zero_extendv16siv32si_shift_exec */

    case 264:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5838; /* *zero_extendv32qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8310; /* *zero_extendv32qiv32si_shift_exec */

    case 265:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5842; /* *zero_extendv32hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8316; /* *zero_extendv32hiv32si_shift_exec */

    case 266:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5846; /* *zero_extendv32siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8322; /* *zero_extendv32siv32si_shift_exec */

    case 267:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5850; /* *zero_extendv64qiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8328; /* *zero_extendv64qiv32si_shift_exec */

    case 268:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5854; /* *zero_extendv64hiv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8334; /* *zero_extendv64hiv32si_shift_exec */

    case 269:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5858; /* *zero_extendv64siv32si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8340; /* *zero_extendv64siv32si_shift_exec */

    case 270:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5862; /* *zero_extendv2qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8346; /* *zero_extendv2qiv64qi_shift_exec */

    case 271:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5866; /* *zero_extendv2hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8352; /* *zero_extendv2hiv64qi_shift_exec */

    case 272:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5870; /* *zero_extendv2siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8358; /* *zero_extendv2siv64qi_shift_exec */

    case 273:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5874; /* *zero_extendv4qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8364; /* *zero_extendv4qiv64qi_shift_exec */

    case 274:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5878; /* *zero_extendv4hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8370; /* *zero_extendv4hiv64qi_shift_exec */

    case 275:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5882; /* *zero_extendv4siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8376; /* *zero_extendv4siv64qi_shift_exec */

    case 276:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5886; /* *zero_extendv8qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8382; /* *zero_extendv8qiv64qi_shift_exec */

    case 277:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5890; /* *zero_extendv8hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8388; /* *zero_extendv8hiv64qi_shift_exec */

    case 278:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5894; /* *zero_extendv8siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8394; /* *zero_extendv8siv64qi_shift_exec */

    case 279:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5898; /* *zero_extendv16qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8400; /* *zero_extendv16qiv64qi_shift_exec */

    case 280:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5902; /* *zero_extendv16hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8406; /* *zero_extendv16hiv64qi_shift_exec */

    case 281:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5906; /* *zero_extendv16siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8412; /* *zero_extendv16siv64qi_shift_exec */

    case 282:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5910; /* *zero_extendv32qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8418; /* *zero_extendv32qiv64qi_shift_exec */

    case 283:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5914; /* *zero_extendv32hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8424; /* *zero_extendv32hiv64qi_shift_exec */

    case 284:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5918; /* *zero_extendv32siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8430; /* *zero_extendv32siv64qi_shift_exec */

    case 285:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5922; /* *zero_extendv64qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8436; /* *zero_extendv64qiv64qi_shift_exec */

    case 286:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5926; /* *zero_extendv64hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8442; /* *zero_extendv64hiv64qi_shift_exec */

    case 287:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5930; /* *zero_extendv64siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8448; /* *zero_extendv64siv64qi_shift_exec */

    case 288:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5934; /* *zero_extendv2qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8454; /* *zero_extendv2qiv64hi_shift_exec */

    case 289:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5938; /* *zero_extendv2hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8460; /* *zero_extendv2hiv64hi_shift_exec */

    case 290:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5942; /* *zero_extendv2siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8466; /* *zero_extendv2siv64hi_shift_exec */

    case 291:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5946; /* *zero_extendv4qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8472; /* *zero_extendv4qiv64hi_shift_exec */

    case 292:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5950; /* *zero_extendv4hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8478; /* *zero_extendv4hiv64hi_shift_exec */

    case 293:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5954; /* *zero_extendv4siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8484; /* *zero_extendv4siv64hi_shift_exec */

    case 294:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5958; /* *zero_extendv8qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8490; /* *zero_extendv8qiv64hi_shift_exec */

    case 295:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5962; /* *zero_extendv8hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8496; /* *zero_extendv8hiv64hi_shift_exec */

    case 296:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5966; /* *zero_extendv8siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8502; /* *zero_extendv8siv64hi_shift_exec */

    case 297:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5970; /* *zero_extendv16qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8508; /* *zero_extendv16qiv64hi_shift_exec */

    case 298:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5974; /* *zero_extendv16hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8514; /* *zero_extendv16hiv64hi_shift_exec */

    case 299:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5978; /* *zero_extendv16siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8520; /* *zero_extendv16siv64hi_shift_exec */

    case 300:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5982; /* *zero_extendv32qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8526; /* *zero_extendv32qiv64hi_shift_exec */

    case 301:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5986; /* *zero_extendv32hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8532; /* *zero_extendv32hiv64hi_shift_exec */

    case 302:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5990; /* *zero_extendv32siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8538; /* *zero_extendv32siv64hi_shift_exec */

    case 303:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5994; /* *zero_extendv64qiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8544; /* *zero_extendv64qiv64hi_shift_exec */

    case 304:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5998; /* *zero_extendv64hiv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8550; /* *zero_extendv64hiv64hi_shift_exec */

    case 305:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6002; /* *zero_extendv64siv64hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8556; /* *zero_extendv64siv64hi_shift_exec */

    case 306:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6006; /* *zero_extendv2qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8562; /* *zero_extendv2qiv64si_shift_exec */

    case 307:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6010; /* *zero_extendv2hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8568; /* *zero_extendv2hiv64si_shift_exec */

    case 308:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6014; /* *zero_extendv2siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8574; /* *zero_extendv2siv64si_shift_exec */

    case 309:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6018; /* *zero_extendv4qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8580; /* *zero_extendv4qiv64si_shift_exec */

    case 310:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6022; /* *zero_extendv4hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8586; /* *zero_extendv4hiv64si_shift_exec */

    case 311:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6026; /* *zero_extendv4siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8592; /* *zero_extendv4siv64si_shift_exec */

    case 312:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6030; /* *zero_extendv8qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8598; /* *zero_extendv8qiv64si_shift_exec */

    case 313:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6034; /* *zero_extendv8hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8604; /* *zero_extendv8hiv64si_shift_exec */

    case 314:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6038; /* *zero_extendv8siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8610; /* *zero_extendv8siv64si_shift_exec */

    case 315:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6042; /* *zero_extendv16qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8616; /* *zero_extendv16qiv64si_shift_exec */

    case 316:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6046; /* *zero_extendv16hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8622; /* *zero_extendv16hiv64si_shift_exec */

    case 317:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6050; /* *zero_extendv16siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8628; /* *zero_extendv16siv64si_shift_exec */

    case 318:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6054; /* *zero_extendv32qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8634; /* *zero_extendv32qiv64si_shift_exec */

    case 319:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6058; /* *zero_extendv32hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8640; /* *zero_extendv32hiv64si_shift_exec */

    case 320:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6062; /* *zero_extendv32siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8646; /* *zero_extendv32siv64si_shift_exec */

    case 321:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6066; /* *zero_extendv64qiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8652; /* *zero_extendv64qiv64si_shift_exec */

    case 322:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6070; /* *zero_extendv64hiv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8658; /* *zero_extendv64hiv64si_shift_exec */

    case 323:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6074; /* *zero_extendv64siv64si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8664; /* *zero_extendv64siv64si_shift_exec */

    case 324:
      return 8740; /* zero_extendv2qiv2di2_exec */

    case 325:
      return 8742; /* zero_extendv2hiv2di2_exec */

    case 326:
      return 8744; /* zero_extendv2siv2di2_exec */

    case 327:
      return 8746; /* zero_extendv4qiv4di2_exec */

    case 328:
      return 8748; /* zero_extendv4hiv4di2_exec */

    case 329:
      return 8750; /* zero_extendv4siv4di2_exec */

    case 330:
      return 8752; /* zero_extendv8qiv8di2_exec */

    case 331:
      return 8754; /* zero_extendv8hiv8di2_exec */

    case 332:
      return 8756; /* zero_extendv8siv8di2_exec */

    case 333:
      return 8758; /* zero_extendv16qiv16di2_exec */

    case 334:
      return 8760; /* zero_extendv16hiv16di2_exec */

    case 335:
      return 8762; /* zero_extendv16siv16di2_exec */

    case 336:
      return 8764; /* zero_extendv32qiv32di2_exec */

    case 337:
      return 8766; /* zero_extendv32hiv32di2_exec */

    case 338:
      return 8768; /* zero_extendv32siv32di2_exec */

    case 339:
      return 8770; /* zero_extendv64qiv64di2_exec */

    case 340:
      return 8772; /* zero_extendv64hiv64di2_exec */

    case 341:
      return 8774; /* zero_extendv64siv64di2_exec */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x5;
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 2;
              return 35; /* subsi3 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 36; /* subdi3 */

            case E_V2QImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V2QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1464; /* subv2qi3 */

            case E_V2HImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V2HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1466; /* subv2hi3 */

            case E_V2SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V2SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1468; /* subv2si3 */

            case E_V4QImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V4QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1470; /* subv4qi3 */

            case E_V4HImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V4HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1472; /* subv4hi3 */

            case E_V4SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V4SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1474; /* subv4si3 */

            case E_V8QImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V8QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1476; /* subv8qi3 */

            case E_V8HImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V8HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1478; /* subv8hi3 */

            case E_V8SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V8SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1480; /* subv8si3 */

            case E_V16QImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V16QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1482; /* subv16qi3 */

            case E_V16HImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V16HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1484; /* subv16hi3 */

            case E_V16SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V16SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1486; /* subv16si3 */

            case E_V32QImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V32QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1488; /* subv32qi3 */

            case E_V32HImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V32HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1490; /* subv32hi3 */

            case E_V32SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V32SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1492; /* subv32si3 */

            case E_V64QImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V64QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1494; /* subv64qi3 */

            case E_V64HImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V64HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1496; /* subv64hi3 */

            case E_V64SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V64SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1498; /* subv64si3 */

            case E_V2DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V2DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1536; /* subv2di3 */

            case E_V4DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V4DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1537; /* subv4di3 */

            case E_V8DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V8DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1538; /* subv8di3 */

            case E_V16DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V16DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1539; /* subv16di3 */

            case E_V32DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V32DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1540; /* subv32di3 */

            case E_V64DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V64DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1541; /* subv64di3 */

            case E_V2DFmode:
              if (pattern1 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2223; /* subv2df3 */

            case E_V4DFmode:
              if (pattern1 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2225; /* subv4df3 */

            case E_V8DFmode:
              if (pattern1 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2227; /* subv8df3 */

            case E_V16DFmode:
              if (pattern1 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2229; /* subv16df3 */

            case E_V32DFmode:
              if (pattern1 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2231; /* subv32df3 */

            case E_V64DFmode:
              if (pattern1 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2233; /* subv64df3 */

            case E_DFmode:
              if (pattern1 (x3, 
E_DFmode) != 0)
                return -1;
              return 2235; /* subdf3 */

            case E_V2HFmode:
              if (pattern1 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2392; /* subv2hf3 */

            case E_V2SFmode:
              if (pattern1 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2394; /* subv2sf3 */

            case E_V4HFmode:
              if (pattern1 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2396; /* subv4hf3 */

            case E_V4SFmode:
              if (pattern1 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2398; /* subv4sf3 */

            case E_V8HFmode:
              if (pattern1 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2400; /* subv8hf3 */

            case E_V8SFmode:
              if (pattern1 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2402; /* subv8sf3 */

            case E_V16HFmode:
              if (pattern1 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2404; /* subv16hf3 */

            case E_V16SFmode:
              if (pattern1 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2406; /* subv16sf3 */

            case E_V32HFmode:
              if (pattern1 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2408; /* subv32hf3 */

            case E_V32SFmode:
              if (pattern1 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2410; /* subv32sf3 */

            case E_V64HFmode:
              if (pattern1 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2412; /* subv64hf3 */

            case E_V64SFmode:
              if (pattern1 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2414; /* subv64sf3 */

            case E_HFmode:
              if (pattern1 (x3, 
E_HFmode) != 0)
                return -1;
              return 2416; /* subhf3 */

            case E_SFmode:
              if (pattern1 (x3, 
E_SFmode) != 0)
                return -1;
              return 2417; /* subsf3 */

            default:
              return -1;
            }

        case MEM:
          operands[1] = x5;
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V64SImode:
              if (pattern118 (x3, 
E_V64SImode) != 0
                  || !
#line 2159 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1614; /* subrv64si3_ds */

            case E_V64SFmode:
              if (pattern118 (x3, 
E_V64SFmode) != 0
                  || !
#line 2159 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1616; /* subrv64sf3_ds */

            case E_V64DImode:
              if (pattern118 (x3, 
E_V64DImode) != 0
                  || !
#line 2159 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1618; /* subrv64di3_ds */

            case E_SImode:
              if (pattern118 (x3, 
E_SImode) != 0
                  || !
#line 2170 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1620; /* subrsi3_ds_scalar */

            case E_SFmode:
              if (pattern118 (x3, 
E_SFmode) != 0
                  || !
#line 2170 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1621; /* subrsf3_ds_scalar */

            case E_DImode:
              if (pattern118 (x3, 
E_DImode) != 0
                  || !
#line 2170 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1622; /* subrdi3_ds_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64SImode:
          if (pattern105 (x3, 
E_V64SImode) != 0
              || !
#line 2138 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1605; /* subv64si3_ds */

        case E_V64SFmode:
          if (pattern105 (x3, 
E_V64SFmode) != 0
              || !
#line 2138 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1607; /* subv64sf3_ds */

        case E_V64DImode:
          if (pattern105 (x3, 
E_V64DImode) != 0
              || !
#line 2138 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1609; /* subv64di3_ds */

        case E_SImode:
          if (pattern105 (x3, 
E_SImode) != 0
              || !
#line 2149 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1611; /* subsi3_ds_scalar */

        case E_SFmode:
          if (pattern105 (x3, 
E_SFmode) != 0
              || !
#line 2149 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1612; /* subsf3_ds_scalar */

        case E_DImode:
          if (pattern105 (x3, 
E_DImode) != 0
              || !
#line 2149 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1613; /* subdi3_ds_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !gcn_alu_operand (operands[1], E_V2HFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2493; /* sqrtv2hf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !gcn_alu_operand (operands[1], E_V2SFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2495; /* sqrtv2sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !gcn_alu_operand (operands[1], E_V2DFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2497; /* sqrtv2df2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !gcn_alu_operand (operands[1], E_V4HFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2499; /* sqrtv4hf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gcn_alu_operand (operands[1], E_V4SFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2501; /* sqrtv4sf2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !gcn_alu_operand (operands[1], E_V4DFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2503; /* sqrtv4df2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !gcn_alu_operand (operands[1], E_V8HFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2505; /* sqrtv8hf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !gcn_alu_operand (operands[1], E_V8SFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2507; /* sqrtv8sf2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !gcn_alu_operand (operands[1], E_V8DFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2509; /* sqrtv8df2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !gcn_alu_operand (operands[1], E_V16HFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2511; /* sqrtv16hf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !gcn_alu_operand (operands[1], E_V16SFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2513; /* sqrtv16sf2 */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !gcn_alu_operand (operands[1], E_V16DFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2515; /* sqrtv16df2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !gcn_alu_operand (operands[1], E_V32HFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2517; /* sqrtv32hf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !gcn_alu_operand (operands[1], E_V32SFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2519; /* sqrtv32sf2 */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !gcn_alu_operand (operands[1], E_V32DFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2521; /* sqrtv32df2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !gcn_alu_operand (operands[1], E_V64HFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2523; /* sqrtv64hf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !gcn_alu_operand (operands[1], E_V64SFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2525; /* sqrtv64sf2 */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !gcn_alu_operand (operands[1], E_V64DFmode)
          || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2527; /* sqrtv64df2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !gcn_alu_operand (operands[1], E_HFmode)
          || !
#line 3065 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2529; /* sqrthf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gcn_alu_operand (operands[1], E_SFmode)
          || !
#line 3065 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2530; /* sqrtsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3065 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
        return -1;
      return 2531; /* sqrtdf2 */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          x7 = XEXP (x6, 1);
          switch (GET_CODE (x7))
            {
            case LTU:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != PLUS)
                return -1;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              x12 = XEXP (x7, 1);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern78 (x3, 
E_SImode) != 0
                      || !register_operand (operands[3], E_BImode)
                      || GET_MODE (x7) != E_BImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  return 30; /* addsi3_scalar_carry */

                case E_V2SImode:
                  if (pattern199 (x1, 
E_V2SImode) != 0)
                    return -1;
                  return 1428; /* addv2si3_vcc */

                case E_V4SImode:
                  if (pattern199 (x1, 
E_V4SImode) != 0)
                    return -1;
                  return 1430; /* addv4si3_vcc */

                case E_V8SImode:
                  if (pattern199 (x1, 
E_V8SImode) != 0)
                    return -1;
                  return 1432; /* addv8si3_vcc */

                case E_V16SImode:
                  if (pattern199 (x1, 
E_V16SImode) != 0)
                    return -1;
                  return 1434; /* addv16si3_vcc */

                case E_V32SImode:
                  if (pattern199 (x1, 
E_V32SImode) != 0)
                    return -1;
                  return 1436; /* addv32si3_vcc */

                case E_V64SImode:
                  if (pattern199 (x1, 
E_V64SImode) != 0)
                    return -1;
                  return 1438; /* addv64si3_vcc */

                default:
                  return -1;
                }

            case GEU:
              if (GET_MODE (x7) != E_BImode)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != PLUS
                  || GET_MODE (x8) != E_SImode
                  || pattern188 (x3) != 0)
                return -1;
              x9 = XEXP (x6, 0);
              operands[4] = x9;
              if (!register_operand (operands[4], E_BImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[3] = x12;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              if (!rtx_equal_p (x11, operands[2])
                  || !
#line 1238 "../../gcc/config/gcn/gcn.md"
(INTVAL (operands[2]) == -INTVAL (operands[3])))
                return -1;
              return 31; /* addsi3_scalar_carry_cst */

            default:
              return -1;
            }

        case CLOBBER:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 106
              || GET_MODE (x9) != E_DImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern189 (x3, 
E_V2QImode) != 0)
                return -1;
              return 1356; /* addv2qi3 */

            case E_V2HImode:
              if (pattern189 (x3, 
E_V2HImode) != 0)
                return -1;
              return 1358; /* addv2hi3 */

            case E_V2SImode:
              if (pattern189 (x3, 
E_V2SImode) != 0)
                return -1;
              return 1360; /* addv2si3 */

            case E_V4QImode:
              if (pattern189 (x3, 
E_V4QImode) != 0)
                return -1;
              return 1362; /* addv4qi3 */

            case E_V4HImode:
              if (pattern189 (x3, 
E_V4HImode) != 0)
                return -1;
              return 1364; /* addv4hi3 */

            case E_V4SImode:
              if (pattern189 (x3, 
E_V4SImode) != 0)
                return -1;
              return 1366; /* addv4si3 */

            case E_V8QImode:
              if (pattern189 (x3, 
E_V8QImode) != 0)
                return -1;
              return 1368; /* addv8qi3 */

            case E_V8HImode:
              if (pattern189 (x3, 
E_V8HImode) != 0)
                return -1;
              return 1370; /* addv8hi3 */

            case E_V8SImode:
              if (pattern189 (x3, 
E_V8SImode) != 0)
                return -1;
              return 1372; /* addv8si3 */

            case E_V16QImode:
              if (pattern189 (x3, 
E_V16QImode) != 0)
                return -1;
              return 1374; /* addv16qi3 */

            case E_V16HImode:
              if (pattern189 (x3, 
E_V16HImode) != 0)
                return -1;
              return 1376; /* addv16hi3 */

            case E_V16SImode:
              if (pattern189 (x3, 
E_V16SImode) != 0)
                return -1;
              return 1378; /* addv16si3 */

            case E_V32QImode:
              if (pattern189 (x3, 
E_V32QImode) != 0)
                return -1;
              return 1380; /* addv32qi3 */

            case E_V32HImode:
              if (pattern189 (x3, 
E_V32HImode) != 0)
                return -1;
              return 1382; /* addv32hi3 */

            case E_V32SImode:
              if (pattern189 (x3, 
E_V32SImode) != 0)
                return -1;
              return 1384; /* addv32si3 */

            case E_V64QImode:
              if (pattern189 (x3, 
E_V64QImode) != 0)
                return -1;
              return 1386; /* addv64qi3 */

            case E_V64HImode:
              if (pattern189 (x3, 
E_V64HImode) != 0)
                return -1;
              return 1388; /* addv64hi3 */

            case E_V64SImode:
              if (pattern189 (x3, 
E_V64SImode) != 0)
                return -1;
              return 1390; /* addv64si3 */

            case E_V2DImode:
              if (pattern189 (x3, 
E_V2DImode) != 0)
                return -1;
              return 1524; /* addv2di3 */

            case E_V4DImode:
              if (pattern189 (x3, 
E_V4DImode) != 0)
                return -1;
              return 1525; /* addv4di3 */

            case E_V8DImode:
              if (pattern189 (x3, 
E_V8DImode) != 0)
                return -1;
              return 1526; /* addv8di3 */

            case E_V16DImode:
              if (pattern189 (x3, 
E_V16DImode) != 0)
                return -1;
              return 1527; /* addv16di3 */

            case E_V32DImode:
              if (pattern189 (x3, 
E_V32DImode) != 0)
                return -1;
              return 1528; /* addv32di3 */

            case E_V64DImode:
              if (pattern189 (x3, 
E_V64DImode) != 0)
                return -1;
              return 1529; /* addv64di3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern101 (x6, 
PLUS, 
LTU) != 0)
        return -1;
      x7 = XEXP (x6, 1);
      x12 = XEXP (x7, 1);
      if (GET_CODE (x12) != LTU)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return -1;
      x14 = XEXP (x4, 1);
      operands[1] = x14;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[4] = x9;
      x8 = XEXP (x7, 0);
      x10 = XEXP (x8, 0);
      x15 = XEXP (x10, 0);
      x16 = XEXP (x15, 1);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x17 = XEXP (x10, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x18 = XEXP (x13, 1);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x12, 1);
      if (!rtx_equal_p (x19, operands[1]))
        return -1;
      switch (pattern197 (x1))
        {
        case 0:
          x20 = XEXP (x15, 0);
          if (GET_CODE (x20) != ZERO_EXTEND
              || GET_MODE (x20) != E_SImode)
            return -1;
          x21 = XEXP (x13, 0);
          if (GET_CODE (x21) != ZERO_EXTEND
              || GET_MODE (x21) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          operands[3] = x23;
          if (!register_operand (operands[3], E_BImode)
              || !gcn_alu_operand (operands[1], E_SImode)
              || !gcn_alu_operand (operands[2], E_SImode)
              || !register_operand (operands[4], E_BImode)
              || pattern243 (x7) != 0
              || GET_MODE (x12) != E_BImode
              || GET_MODE (x13) != E_SImode)
            return -1;
          x24 = XEXP (x20, 0);
          if (!rtx_equal_p (x24, operands[3]))
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[3]))
            return -1;
          return 32; /* addcsi3_scalar */

        case 1:
          if (pattern240 (x1) != 0
              || !register_operand (operands[3], E_DImode)
              || !register_operand (operands[4], E_DImode)
              || GET_MODE (x7) != E_DImode
              || GET_MODE (x8) != E_DImode
              || GET_MODE (x12) != E_DImode)
            return -1;
          x20 = XEXP (x15, 0);
          x26 = XEXP (x20, 2);
          if (!rtx_equal_p (x26, operands[3]))
            return -1;
          x21 = XEXP (x13, 0);
          x27 = XEXP (x21, 2);
          if (!rtx_equal_p (x27, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern246 (x1, 
E_V2SImode) != 0)
                return -1;
              return 1452; /* addcv2si3 */

            case E_V4SImode:
              if (pattern246 (x1, 
E_V4SImode) != 0)
                return -1;
              return 1454; /* addcv4si3 */

            case E_V8SImode:
              if (pattern246 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1456; /* addcv8si3 */

            case E_V16SImode:
              if (pattern246 (x1, 
E_V16SImode) != 0)
                return -1;
              return 1458; /* addcv16si3 */

            case E_V32SImode:
              if (pattern246 (x1, 
E_V32SImode) != 0)
                return -1;
              return 1460; /* addcv32si3 */

            case E_V64SImode:
              if (pattern246 (x1, 
E_V64SImode) != 0)
                return -1;
              return 1462; /* addcv64si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x22 = XEXP (x4, 0);
      switch (GET_CODE (x22))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              x6 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x6))
                {
                case SET:
                  x7 = XEXP (x6, 1);
                  if (pattern153 (x7, 
PLUS, 
LTU) != 0
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || GET_MODE (x4) != E_SImode)
                    return -1;
                  operands[2] = x22;
                  if (!register_operand (operands[2], E_BImode))
                    return -1;
                  operands[1] = x5;
                  if (!gcn_alu_operand (operands[1], E_SImode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  x10 = XEXP (x8, 0);
                  x15 = XEXP (x10, 0);
                  if (!rtx_equal_p (x15, operands[2]))
                    return -1;
                  x11 = XEXP (x8, 1);
                  if (!rtx_equal_p (x11, operands[1]))
                    return -1;
                  x12 = XEXP (x7, 1);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  x9 = XEXP (x6, 0);
                  if (!rtx_equal_p (x9, operands[2]))
                    return -1;
                  return 33; /* addcsi3_scalar_zero */

                case CLOBBER:
                  x9 = XEXP (x6, 0);
                  if (GET_CODE (x9) != REG
                      || REGNO (x9) != 106
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  operands[1] = x22;
                  operands[2] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2DImode:
                      if (pattern194 (x3, 
E_V2DImode, 
E_V2SImode) != 0)
                        return -1;
                      return 1548; /* addv2di3_zext */

                    case E_V4DImode:
                      if (pattern194 (x3, 
E_V4DImode, 
E_V4SImode) != 0)
                        return -1;
                      return 1549; /* addv4di3_zext */

                    case E_V8DImode:
                      if (pattern194 (x3, 
E_V8DImode, 
E_V8SImode) != 0)
                        return -1;
                      return 1550; /* addv8di3_zext */

                    case E_V16DImode:
                      if (pattern194 (x3, 
E_V16DImode, 
E_V16SImode) != 0)
                        return -1;
                      return 1551; /* addv16di3_zext */

                    case E_V32DImode:
                      if (pattern194 (x3, 
E_V32DImode, 
E_V32SImode) != 0)
                        return -1;
                      return 1552; /* addv32di3_zext */

                    case E_V64DImode:
                      if (pattern194 (x3, 
E_V64DImode, 
E_V64SImode) != 0)
                        return -1;
                      return 1553; /* addv64di3_zext */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern123 (x6) != 0)
                return -1;
              operands[1] = x22;
              switch (pattern196 (x1))
                {
                case 0:
                  return 1572; /* addv2di3_vcc_zext_dup2 */

                case 1:
                  return 1573; /* addv4di3_vcc_zext_dup2 */

                case 2:
                  return 1574; /* addv8di3_vcc_zext_dup2 */

                case 3:
                  return 1575; /* addv16di3_vcc_zext_dup2 */

                case 4:
                  return 1576; /* addv32di3_vcc_zext_dup2 */

                case 5:
                  return 1577; /* addv64di3_vcc_zext_dup2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern112 (x1))
            {
            case 0:
              return 1560; /* addv2di3_vcc_zext_dup */

            case 1:
              return 1561; /* addv4di3_vcc_zext_dup */

            case 2:
              return 1562; /* addv8di3_vcc_zext_dup */

            case 3:
              return 1563; /* addv16di3_vcc_zext_dup */

            case 4:
              return 1564; /* addv32di3_vcc_zext_dup */

            case 5:
              return 1565; /* addv64di3_vcc_zext_dup */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 106
              || GET_MODE (x9) != E_DImode)
            return -1;
          x22 = XEXP (x4, 0);
          operands[2] = x22;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern190 (x3, 
E_V2QImode, 
E_QImode) != 0)
                return -1;
              return 1392; /* addv2qi3_dup */

            case E_V2HImode:
              if (pattern190 (x3, 
E_V2HImode, 
E_HImode) != 0)
                return -1;
              return 1394; /* addv2hi3_dup */

            case E_V2SImode:
              if (pattern190 (x3, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              return 1396; /* addv2si3_dup */

            case E_V4QImode:
              if (pattern190 (x3, 
E_V4QImode, 
E_QImode) != 0)
                return -1;
              return 1398; /* addv4qi3_dup */

            case E_V4HImode:
              if (pattern190 (x3, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              return 1400; /* addv4hi3_dup */

            case E_V4SImode:
              if (pattern190 (x3, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              return 1402; /* addv4si3_dup */

            case E_V8QImode:
              if (pattern190 (x3, 
E_V8QImode, 
E_QImode) != 0)
                return -1;
              return 1404; /* addv8qi3_dup */

            case E_V8HImode:
              if (pattern190 (x3, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              return 1406; /* addv8hi3_dup */

            case E_V8SImode:
              if (pattern190 (x3, 
E_V8SImode, 
E_SImode) != 0)
                return -1;
              return 1408; /* addv8si3_dup */

            case E_V16QImode:
              if (pattern190 (x3, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              return 1410; /* addv16qi3_dup */

            case E_V16HImode:
              if (pattern190 (x3, 
E_V16HImode, 
E_HImode) != 0)
                return -1;
              return 1412; /* addv16hi3_dup */

            case E_V16SImode:
              if (pattern190 (x3, 
E_V16SImode, 
E_SImode) != 0)
                return -1;
              return 1414; /* addv16si3_dup */

            case E_V32QImode:
              if (pattern190 (x3, 
E_V32QImode, 
E_QImode) != 0)
                return -1;
              return 1416; /* addv32qi3_dup */

            case E_V32HImode:
              if (pattern190 (x3, 
E_V32HImode, 
E_HImode) != 0)
                return -1;
              return 1418; /* addv32hi3_dup */

            case E_V32SImode:
              if (pattern190 (x3, 
E_V32SImode, 
E_SImode) != 0)
                return -1;
              return 1420; /* addv32si3_dup */

            case E_V64QImode:
              if (pattern190 (x3, 
E_V64QImode, 
E_QImode) != 0)
                return -1;
              return 1422; /* addv64qi3_dup */

            case E_V64HImode:
              if (pattern190 (x3, 
E_V64HImode, 
E_HImode) != 0)
                return -1;
              return 1424; /* addv64hi3_dup */

            case E_V64SImode:
              if (pattern190 (x3, 
E_V64SImode, 
E_SImode) != 0)
                return -1;
              return 1426; /* addv64si3_dup */

            default:
              return -1;
            }

        case SET:
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != LTU
              || GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != PLUS)
            return -1;
          x10 = XEXP (x8, 0);
          if (GET_CODE (x10) != VEC_DUPLICATE)
            return -1;
          x12 = XEXP (x7, 1);
          if (GET_CODE (x12) != VEC_DUPLICATE)
            return -1;
          x22 = XEXP (x4, 0);
          operands[1] = x22;
          if (!gcn_alu_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!register_operand (operands[3], E_DImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          x11 = XEXP (x8, 1);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern219 (x1, 
E_V2SImode) != 0)
                return -1;
              return 1440; /* addv2si3_vcc_dup */

            case E_V4SImode:
              if (pattern219 (x1, 
E_V4SImode) != 0)
                return -1;
              return 1442; /* addv4si3_vcc_dup */

            case E_V8SImode:
              if (pattern219 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1444; /* addv8si3_vcc_dup */

            case E_V16SImode:
              if (pattern219 (x1, 
E_V16SImode) != 0)
                return -1;
              return 1446; /* addv16si3_vcc_dup */

            case E_V32SImode:
              if (pattern219 (x1, 
E_V32SImode) != 0)
                return -1;
              return 1448; /* addv32si3_vcc_dup */

            case E_V64SImode:
              if (pattern219 (x1, 
E_V64SImode) != 0)
                return -1;
              return 1450; /* addv64si3_vcc_dup */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64DFmode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64DFmode)
      && general_operand (operands[1], E_V64DFmode))
    return gen_split_117 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64DFmode)
      || !memory_operand (operands[1], E_V64DFmode))
    return NULL;
  return gen_split_213 (insn, operands);
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64HImode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64HImode)
      && general_operand (operands[1], E_V64HImode))
    return gen_split_112 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64HImode)
      || !memory_operand (operands[1], E_V64HImode))
    return NULL;
  return gen_split_208 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32SFmode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32SFmode)
      && general_operand (operands[1], E_V32SFmode))
    return gen_split_107 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32SFmode)
      || !memory_operand (operands[1], E_V32SFmode))
    return NULL;
  return gen_split_203 (insn, operands);
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 2);
  if (!gcn_exec_reg_operand (x4, E_DImode))
    return NULL;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_34 (x1, insn);

    case PLUS:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern72 (x7, 
106) != 0)
            return NULL;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern204 (x3, 
E_V2DImode) != 0
                  || !
#line 1662 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[1])
   && gcn_can_split_p (V2DImode, operands[2])
   && gcn_can_split_p (V2DImode, operands[4])))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_V4DImode:
              if (pattern204 (x3, 
E_V4DImode) != 0
                  || !
#line 1662 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[1])
   && gcn_can_split_p (V4DImode, operands[2])
   && gcn_can_split_p (V4DImode, operands[4])))
                return NULL;
              return gen_split_234 (insn, operands);

            case E_V8DImode:
              if (pattern204 (x3, 
E_V8DImode) != 0
                  || !
#line 1662 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[1])
   && gcn_can_split_p (V8DImode, operands[2])
   && gcn_can_split_p (V8DImode, operands[4])))
                return NULL;
              return gen_split_235 (insn, operands);

            case E_V16DImode:
              if (pattern204 (x3, 
E_V16DImode) != 0
                  || !
#line 1662 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[1])
   && gcn_can_split_p (V16DImode, operands[2])
   && gcn_can_split_p (V16DImode, operands[4])))
                return NULL;
              return gen_split_236 (insn, operands);

            case E_V32DImode:
              if (pattern204 (x3, 
E_V32DImode) != 0
                  || !
#line 1662 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[1])
   && gcn_can_split_p (V32DImode, operands[2])
   && gcn_can_split_p (V32DImode, operands[4])))
                return NULL;
              return gen_split_237 (insn, operands);

            case E_V64DImode:
              if (pattern204 (x3, 
E_V64DImode) != 0
                  || !
#line 1662 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[1])
   && gcn_can_split_p (V64DImode, operands[2])
   && gcn_can_split_p (V64DImode, operands[4])))
                return NULL;
              return gen_split_238 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern134 (x1))
            {
            case 0:
              if (!
#line 1795 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[2])
   && gcn_can_split_p (V2DImode, operands[3])))
                return NULL;
              return gen_split_257 (insn, operands);

            case 1:
              if (!
#line 1795 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[2])
   && gcn_can_split_p (V4DImode, operands[3])))
                return NULL;
              return gen_split_258 (insn, operands);

            case 2:
              if (!
#line 1795 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[2])
   && gcn_can_split_p (V8DImode, operands[3])))
                return NULL;
              return gen_split_259 (insn, operands);

            case 3:
              if (!
#line 1795 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[2])
   && gcn_can_split_p (V16DImode, operands[3])))
                return NULL;
              return gen_split_260 (insn, operands);

            case 4:
              if (!
#line 1795 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[2])
   && gcn_can_split_p (V32DImode, operands[3])))
                return NULL;
              return gen_split_261 (insn, operands);

            case 5:
              if (!
#line 1795 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[2])
   && gcn_can_split_p (V64DImode, operands[3])))
                return NULL;
              return gen_split_262 (insn, operands);

            case 6:
              if (!
#line 1991 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[4])))
                return NULL;
              return gen_split_281 (insn, operands);

            case 7:
              if (!
#line 1991 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[4])))
                return NULL;
              return gen_split_282 (insn, operands);

            case 8:
              if (!
#line 1991 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[4])))
                return NULL;
              return gen_split_283 (insn, operands);

            case 9:
              if (!
#line 1991 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[4])))
                return NULL;
              return gen_split_284 (insn, operands);

            case 10:
              if (!
#line 1991 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[4])))
                return NULL;
              return gen_split_285 (insn, operands);

            case 11:
              if (!
#line 1991 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[4])))
                return NULL;
              return gen_split_286 (insn, operands);

            case 12:
              if (!
#line 1888 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[2])
   && gcn_can_split_p (V2DImode, operands[4])))
                return NULL;
              return gen_split_269 (insn, operands);

            case 13:
              if (!
#line 1888 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[2])
   && gcn_can_split_p (V4DImode, operands[4])))
                return NULL;
              return gen_split_270 (insn, operands);

            case 14:
              if (!
#line 1888 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[2])
   && gcn_can_split_p (V8DImode, operands[4])))
                return NULL;
              return gen_split_271 (insn, operands);

            case 15:
              if (!
#line 1888 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[2])
   && gcn_can_split_p (V16DImode, operands[4])))
                return NULL;
              return gen_split_272 (insn, operands);

            case 16:
              if (!
#line 1888 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[2])
   && gcn_can_split_p (V32DImode, operands[4])))
                return NULL;
              return gen_split_273 (insn, operands);

            case 17:
              if (!
#line 1888 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[2])
   && gcn_can_split_p (V64DImode, operands[4])))
                return NULL;
              return gen_split_274 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MINUS:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return NULL;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 106
          || GET_MODE (x10) != E_DImode)
        return NULL;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern202 (x3, 
E_V2DImode) != 0
              || !
#line 1729 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[1])
   && gcn_can_split_p (V2DImode, operands[2])
   && gcn_can_split_p (V2DImode, operands[3])))
            return NULL;
          return gen_split_245 (insn, operands);

        case E_V4DImode:
          if (pattern202 (x3, 
E_V4DImode) != 0
              || !
#line 1729 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[1])
   && gcn_can_split_p (V4DImode, operands[2])
   && gcn_can_split_p (V4DImode, operands[3])))
            return NULL;
          return gen_split_246 (insn, operands);

        case E_V8DImode:
          if (pattern202 (x3, 
E_V8DImode) != 0
              || !
#line 1729 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[1])
   && gcn_can_split_p (V8DImode, operands[2])
   && gcn_can_split_p (V8DImode, operands[3])))
            return NULL;
          return gen_split_247 (insn, operands);

        case E_V16DImode:
          if (pattern202 (x3, 
E_V16DImode) != 0
              || !
#line 1729 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[1])
   && gcn_can_split_p (V16DImode, operands[2])
   && gcn_can_split_p (V16DImode, operands[3])))
            return NULL;
          return gen_split_248 (insn, operands);

        case E_V32DImode:
          if (pattern202 (x3, 
E_V32DImode) != 0
              || !
#line 1729 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[1])
   && gcn_can_split_p (V32DImode, operands[2])
   && gcn_can_split_p (V32DImode, operands[3])))
            return NULL;
          return gen_split_249 (insn, operands);

        case E_V64DImode:
          if (pattern202 (x3, 
E_V64DImode) != 0
              || !
#line 1729 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[1])
   && gcn_can_split_p (V64DImode, operands[2])
   && gcn_can_split_p (V64DImode, operands[3])))
            return NULL;
          return gen_split_250 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return NULL;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      operands[4] = x4;
      switch (pattern165 (x1))
        {
        case 0:
          if (!
#line 2255 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_305 (insn, operands);

        case 1:
          if (!
#line 2255 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_306 (insn, operands);

        case 2:
          if (!
#line 2255 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_307 (insn, operands);

        case 3:
          if (!
#line 2255 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_308 (insn, operands);

        case 4:
          if (!
#line 2255 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_309 (insn, operands);

        case 5:
          if (!
#line 2255 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_310 (insn, operands);

        case 6:
          if (!
#line 2330 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_317 (insn, operands);

        case 7:
          if (!
#line 2330 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_318 (insn, operands);

        case 8:
          if (!
#line 2330 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_319 (insn, operands);

        case 9:
          if (!
#line 2330 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_320 (insn, operands);

        case 10:
          if (!
#line 2330 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_321 (insn, operands);

        case 11:
          if (!
#line 2330 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_322 (insn, operands);

        case 12:
          if (!
#line 2402 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_329 (insn, operands);

        case 13:
          if (!
#line 2402 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_330 (insn, operands);

        case 14:
          if (!
#line 2402 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_331 (insn, operands);

        case 15:
          if (!
#line 2402 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_332 (insn, operands);

        case 16:
          if (!
#line 2402 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_333 (insn, operands);

        case 17:
          if (!
#line 2402 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_334 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
